/**************************************************************************

   Fotoxx      edit photos and manage collections

   Copyright 2007 2008 2009 2010 2011 2012 Michael Cornelison
   Source URL: http://kornelix.com/fotoxx
   Contact: kornelix2@gmail.com
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program. If not, see http://www.gnu.org/licenses/.

***************************************************************************/

#define EX extern                                                          //  enable extern declarations
#include "fotoxx.h"


void build_menus()                                                         //  v.13.01
{

   //  build the main window menus, either classic (at the top of the window)
   //   or vertical on the left side of the window.

   GtkWidget   *mFile, *mTools, *mMeta, *mArea, *mXform;
   GtkWidget   *mRt, *mRt2, *mArt, *mComb, *mPlugins, *mHelp;
   GtkWidget   *fhbox, *fvb1, *fvb2;
   vbox_menu   *fvbm = 0;

   if (strEqu(menu_style,"classic"))                                       //  classic menu and toolbar
   {
      fMenu = create_menubar(fVbox);                                       //  add menu bar to main window
      fTbar = create_toolbar(fVbox);                                       //  add toolbar
      fDwin = gtk_drawing_area_new();                                      //  add drawing window
      gtk_box_pack_start(GTK_BOX(fVbox),fDwin,1,1,0);
      fSbar = create_stbar(fVbox);                                         //  add status bar

      if (strEqu(tbar_style,"icons"))                                      //  set toolbar style
         gtk_toolbar_set_style(GTK_TOOLBAR(fTbar),GTK_TOOLBAR_ICONS);
      else if (strEqu(tbar_style,"text"))
         gtk_toolbar_set_style(GTK_TOOLBAR(fTbar),GTK_TOOLBAR_TEXT);
      else gtk_toolbar_set_style(GTK_TOOLBAR(fTbar),GTK_TOOLBAR_BOTH);

      mFile = add_menubar_item(fMenu,ZTX("File"),topmenufunc);             //  add top menu items
      mTools = add_menubar_item(fMenu,ZTX("Tools"),topmenufunc);
      mMeta = add_menubar_item(fMenu,ZTX("Metadata"),topmenufunc);
      mArea = add_menubar_item(fMenu,ZTX("Areas"),topmenufunc);
      mXform = add_menubar_item(fMenu,ZTX("Transform"),topmenufunc);
      mRt = add_menubar_item(fMenu,ZTX("Retouch"),topmenufunc);
      mRt2 = add_menubar_item(fMenu,ZTX("Retouch2"),topmenufunc);
      mArt = add_menubar_item(fMenu,ZTX("Art"),topmenufunc);
      mComb = add_menubar_item(fMenu,ZTX("Combine"),topmenufunc);
      mPlugins = add_menubar_item(fMenu,ZTX("Plugins"),topmenufunc);
      mHelp = add_menubar_item(fMenu,ZTX("Help"),topmenufunc);
   }
   
   else                                                                    //  vertical menu and toolbar
   {
      fhbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL,0);                   //   ____________________
      gtk_box_pack_start(GTK_BOX(fVbox),fhbox,1,1,0);                      //  |       |            |
      fvb1 = gtk_box_new(GTK_ORIENTATION_VERTICAL,0);                      //  | fvb1  | fvb2       | fhbox
      fvb2 = gtk_box_new(GTK_ORIENTATION_VERTICAL,0);                      //  | menu  | image      |
      gtk_box_pack_start(GTK_BOX(fhbox),fvb1,0,0,0);                       //  |_______|____________|
      gtk_box_pack_start(GTK_BOX(fhbox),fvb2,1,1,0);                       //  |____________________| status bar
      fDwin = gtk_drawing_area_new();
      gtk_box_pack_start(GTK_BOX(fvb2),fDwin,1,1,0);
      fSbar = create_stbar(fVbox);
      gtk_widget_set_size_request(fvb1,10,0);                              //  compensate GTK bug
      fvbm = vbox_menu_new(fvb1);

      mFile = create_popmenu();                                            //  add top menu items to menu vbox
      mTools = create_popmenu();
      mMeta = create_popmenu();
      mArea = create_popmenu();
      mXform = create_popmenu();
      mRt = create_popmenu();
      mRt2 = create_popmenu();
      mArt = create_popmenu();
      mComb = create_popmenu();
      mHelp = create_popmenu();
      mPlugins = create_popmenu();
      fTbar = 0;                                                           //  no GTK toolbar

      vbox_menu_add(fvbm,ZTX("File"),0,0, (mtFunc *) popup_menu, (cchar *) mFile);
      vbox_menu_add(fvbm,ZTX("Tools"),0,0, (mtFunc *) popup_menu, (cchar *) mTools);
      vbox_menu_add(fvbm,ZTX("Metadata"),0,0, (mtFunc *) popup_menu, (cchar *) mMeta);
      vbox_menu_add(fvbm,ZTX("Areas"),0,0, (mtFunc *) popup_menu, (cchar *) mArea);
      vbox_menu_add(fvbm,ZTX("Transform"),0,0, (mtFunc *) popup_menu, (cchar *) mXform);
      vbox_menu_add(fvbm,ZTX("Retouch"),0,0, (mtFunc *) popup_menu, (cchar *) mRt);
      vbox_menu_add(fvbm,ZTX("Retouch2"),0,0, (mtFunc *) popup_menu, (cchar *) mRt2);
      vbox_menu_add(fvbm,ZTX("Art"),0,0, (mtFunc *) popup_menu, (cchar *) mArt);
      vbox_menu_add(fvbm,ZTX("Combine"),0,0, (mtFunc *) popup_menu, (cchar *) mComb);
      vbox_menu_add(fvbm,ZTX("Plugins"),0,0, (mtFunc *) popup_menu, (cchar *) mPlugins);
      vbox_menu_add(fvbm,ZTX("Help"),0,0, (mtFunc *) popup_menu, (cchar *) mHelp);
   }

   int      me;
   Nmenus = 0;                                                             //  build a table of menu and toolbar items
  
   #define MENUENT(topmenu2,text2,icon2,desc2,func2,arg2)         \
      me = Nmenus++;                                              \
      menutab[me].topmenu = topmenu2;                             \
      menutab[me].text = text2;                                   \
      menutab[me].icon = icon2;                                   \
      menutab[me].desc = desc2;                                   \
      menutab[me].func = func2;                                   \
      if (arg2) menutab[me].arg = arg2;                           \
      else menutab[me].arg = text2;


   MENUENT(mFile, ZTX("New Window"), 0,            ZTX("Open another window"),             m_clone, 0 );
   MENUENT(mFile, ZTX("Open Image File"), 0,       ZTX("Open a new image file"),           m_open, 0 );
   MENUENT(mFile, ZTX("Open Previous File"), 0,    ZTX("Open the previously seen file"),   m_previous, 0 );
   MENUENT(mFile, ZTX("Open Recent File"), 0,      ZTX("Open a recently seen file"),       m_recent, 0 );
   MENUENT(mFile, ZTX("Open RAW file (ufraw)"), 0, ZTX("Open and edit a camera RAW file"), m_ufraw, 0 );
   MENUENT(mFile, ZTX("Save to Same File"), 0,     ZTX("Save to the same file (replace)"), m_save, 0 );
   MENUENT(mFile, ZTX("Save to New Version"), 0,   ZTX("Save to a new (next) version"),    m_savevers, 0 );
   MENUENT(mFile, ZTX("Save to New File"), 0,      ZTX("Save to a new file name"),         m_saveas, 0 );
   MENUENT(mFile, ZTX("Rename Image File"), 0,     ZTX("Change the image file name"),      m_rename, 0 );
   MENUENT(mFile, ZTX("New Blank Image"), 0,       ZTX("Create a blank image"),            m_create, 0 );
   MENUENT(mFile, ZTX("Trash Image File"), 0,      ZTX("Move image file to Trash"),        m_trash, 0 );
   MENUENT(mFile, ZTX("Print Image"), 0,           ZTX("Print the current image"),         m_print, 0 );
   MENUENT(mFile, ZTX("Quit Fotoxx"), 0,           ZTX("Quit Fotoxx"),                     m_quit, 0 );

   MENUENT(mTools,  ZTX("Batch Rename"), 0,              ZTX("Rename multiple image files"),            m_batch_rename, 0 );
   MENUENT(mTools,  ZTX("Batch Convert/Resize/Move"), 0, ZTX("Convert resize, move multiple files"),    m_batch_convert, 0 );
   MENUENT(mTools,  ZTX("Batch Convert RAW Files"), 0,   ZTX("Convert multiple camera RAW files"),      m_batch_conv_raw, 0 );
   MENUENT(mTools,  ZTX("Manage Collections"), 0,        ZTX("Organize images into collections"),       m_manage_coll, 0 );
   MENUENT(mTools,  ZTX("Move Collections"), 0,          ZTX("Convert for a new top directory"),        m_move_coll, 0 );
   MENUENT(mTools,  ZTX("Slide Show"), 0,                ZTX("Start a slide show"),                     m_slideshow, 0 );
   MENUENT(mTools,  ZTX("Synchronize Files"), 0,         ZTX("Index new files and make thumbnails"),    m_syncfiles, 0 );
   MENUENT(mTools,  ZTX("Show RGB"), 0,                  ZTX("Show RGB colors at mouse click"),         m_show_RGB, 0 );
   MENUENT(mTools,  ZTX("Grid Lines"), 0,                ZTX("Show or revise grid lines"),              m_gridlines, "G" );
   MENUENT(mTools,  ZTX("Burn Images to CD/DVD"), 0,     ZTX("Burn selected image files to CD or DVD"), m_burn, 0 );
   MENUENT(mTools,  ZTX("Monitor Color"), 0,             ZTX("Chart to adjust monitor color"),          m_moncheck, 0 );
   MENUENT(mTools,  ZTX("Monitor Gamma"), 0,             ZTX("Chart to adjust monitor gamma"),          m_mongamma, 0 );
   MENUENT(mTools,  ZTX("Brightness Distribution"), 0,   ZTX("Show a brightness distribution graph"),   m_histogram, 0 );
   MENUENT(mTools,  ZTX("Change Language"), 0,           ZTX("Change the GUI language"),                m_lang, 0 );
   MENUENT(mTools,  ZTX("Edit Translations"), 0,         ZTX("Edit translations while using Fotoxx"),   m_translate, 0 );
   MENUENT(mTools,  ZTX("Menu and Launcher"), 0,         ZTX("Create a Gnome menu and launcher"),       m_menu_launcher, 0 );
   MENUENT(mTools,  ZTX("User Settings"), 0,             ZTX("Change user preferences"),                m_settings, 0 );
   MENUENT(mTools,  ZTX("Resources"), 0,                 ZTX("Report memory and CPU usage"),            m_resources, 0 );

   MENUENT(mMeta,  ZTX("Edit Caption/Comments"), 0,   ZTX("Edit image caption or comment"),          m_edit_cctext, 0 );
   MENUENT(mMeta,  ZTX("Edit Metadata"), 0,           ZTX("Edit image date/rating/tags"),            m_edit_metadata, 0 );
   MENUENT(mMeta,  ZTX("Batch Add Tags"), 0,          ZTX("Add tags to multiple images"),            m_batchAddTags, 0 );
   MENUENT(mMeta,  ZTX("Batch Delete Tag"), 0,        ZTX("Delete a tag from multiple images"),      m_batchDelTag, 0 );
   MENUENT(mMeta,  ZTX("View Metadata (short)"), 0,   ZTX("List a few key metadata items"),          m_meta_view_short, 0 );
   MENUENT(mMeta,  ZTX("View Metadata (long)"), 0,    ZTX("List all metadata items"),                m_meta_view_long, 0 );
   MENUENT(mMeta,  ZTX("Edit Any Metadata"), 0,       ZTX("Edit any image metadata"),                m_meta_edit_any, 0 );
   MENUENT(mMeta,  ZTX("Delete Metadata"), 0,         ZTX("Remove all metadata from an image"),      m_meta_delete, 0 );
   MENUENT(mMeta,  ZTX("Download Geolocations"), 0,   ZTX("Download initial geolocation database"),  m_download_geolocs, 0 );
///MENUENT(mMeta,  ZTX("World Map Test"), 0,          ZTX("Test World Map coordinate transforms"),   m_worldmap_test, 0 );
   MENUENT(mMeta,  ZTX("Edit Geotags"), 0,            ZTX("Edit image geotags"),                     m_edit_geotags, 0 );
   MENUENT(mMeta,  ZTX("Batch Add Geotags"), 0,       ZTX("Add geotags to multiple images"),         m_batch_add_geotags, 0 );
   MENUENT(mMeta,  ZTX("Images by Location/Date"), 0, ZTX("Find all images for a location [date]"),  m_geotag_groups, 0 );
   MENUENT(mMeta,  ZTX("Images by Map Location"), 0,  ZTX("Find images by clicking a world map"),    m_geotag_worldmap, 0 );
   MENUENT(mMeta,  ZTX("Search Images"), 0,           ZTX("Find images meeting select criteria"),    m_search_images, 0 );

   MENUENT(mArea,  ZTX("Select"), 0,     ZTX("Select object or area for editing"),     m_select, 0 );
   MENUENT(mArea,  ZTX("Show"), 0,       ZTX("Show (outline) existing area"),          m_select_show, 0 );
   MENUENT(mArea,  ZTX("Hide"), 0,       ZTX("Hide existing area"),                    m_select_hide, 0 );
   MENUENT(mArea,  ZTX("Enable"), 0,     ZTX("Enable area for editing"),               m_select_enable, 0 );
   MENUENT(mArea,  ZTX("Disable"), 0,    ZTX("Disable area for editing"),              m_select_disable, 0 );
   MENUENT(mArea,  ZTX("Invert"), 0,     ZTX("Reverse existing area"),                 m_select_invert, 0 );
   MENUENT(mArea,  ZTX("Unselect"), 0,   ZTX("Erase existing area"),                   m_select_unselect, 0 );
   MENUENT(mArea,  ZTX("Copy"), 0,       ZTX("Copy an area for later pasting"),        m_select_copy, 0 );
   MENUENT(mArea,  ZTX("Paste"), 0,      ZTX("Paste an area into the current image"),  m_select_paste, 0 );
   MENUENT(mArea,  ZTX("Open"), 0,       ZTX("Open a file with a saved area"),         m_select_open, 0 );
   MENUENT(mArea,  ZTX("Save"), 0,       ZTX("Save an area to a file"),                m_select_save, 0 );

   MENUENT(mXform,   ZTX("Rotate Image"), 0,          ZTX("Turn upright or level tilted image"),       m_rotate, 0 );
   MENUENT(mXform,   ZTX("Trim Image"), 0,            ZTX("Cut off unwanted margins"),                 m_trim, 0 );
   MENUENT(mXform,   ZTX("Auto-Trim Image"), 0,       ZTX("Remove margins from warp, panorama, etc."), m_autotrim, 0 );
   MENUENT(mXform,   ZTX("Resize Image"), 0,          ZTX("Change pixel dimensions"),                  m_resize, 0 );
   MENUENT(mXform,   ZTX("Write Text"), 0,            ZTX("Write text on image"),                      m_write_text, 0 );
   MENUENT(mXform,   ZTX("Flip Image"), 0,            ZTX("Mirror image horizontally or vertically"),  m_flip, 0 );
   MENUENT(mXform,   ZTX("Color Mode"), 0,            ZTX("Make BW/color, negative/positive, sepia"),  m_colormode, 0 );
   MENUENT(mXform,   ZTX("Unbend Image"), 0,          ZTX("Remove curvature, esp. panoramas"),         m_unbend, 0 );
   MENUENT(mXform,   ZTX("Keystone Correction"), 0,   ZTX("Straighten objects seen from an angle"),    m_keystone, 0 );
   MENUENT(mXform,   ZTX("Warp Image (area)"), 0,     ZTX("Distort image areas using the mouse"),      m_warp_area, 0 );
   MENUENT(mXform,   ZTX("Warp Image (curved)"), 0,   ZTX("Distort the whole image using the mouse"),  m_warp_curved, 0 );
   MENUENT(mXform,   ZTX("Warp Image (linear)"), 0,   ZTX("Distort the whole image using the mouse"),  m_warp_linear, 0 );
   MENUENT(mXform,   ZTX("Warp Image (affine)"), 0,   ZTX("Distort the whole image using the mouse"),  m_warp_affine, 0 );

   MENUENT(mRt,   ZTX("Voodoo Enhance"), 0,     ZTX("Fast auto enhance that may work OK"),            m_voodoo, 0 );
   MENUENT(mRt,   ZTX("Brightness/Color"), 0,   ZTX("Adjust brightness, contrast, color"),            m_tune, 0 );
   MENUENT(mRt,   ZTX("Gamma Curves"), 0,       ZTX("Adjust contrast using a gamma curve"),           m_gamma, 0 );
   MENUENT(mRt,   ZTX("Tone Mapping"), 0,       ZTX("Add local contrast, enhance details"),           m_tonemap, 0 );
   MENUENT(mRt,   ZTX("Flatten Brightness"), 0, ZTX("Flatten brightness distribution"),               m_flatten, 0 );
   MENUENT(mRt,   ZTX("Expand Brightness"), 0,  ZTX("Expand brightness range"),                       m_xbrange, 0 );
   MENUENT(mRt,   ZTX("White Balance"), 0,      ZTX("Click on a white/gray area to fix color tint"),  m_whitebal, 0 );
   MENUENT(mRt,   ZTX("Red Eyes"), 0,           ZTX("Fix red-eyes from electronic flash"),            m_redeye, 0 );
   MENUENT(mRt,   ZTX("Blur Image"), 0,         ZTX("Make the image look fuzzy"),                     m_blur, 0 );
   MENUENT(mRt,   ZTX("Sharpen Image"), 0,      ZTX("Make the image look sharper"),                   m_sharpen, 0 );
   MENUENT(mRt,   ZTX("Reduce Noise"), 0,       ZTX("Filter noise from low-light photos"),            m_denoise, 0 );

   MENUENT(mRt2,  ZTX("Smart Erase"), 0,        ZTX("Remove unwanted objects"),                      m_smart_erase, 0 );
   MENUENT(mRt2,  ZTX("Vignette Tool"), 0,      ZTX("Change brightness or color radially"),          m_vignette, 0 );
   MENUENT(mRt2,  ZTX("Match Colors"), 0,       ZTX("Match colors on one image with another"),       m_match_color, 0 );
   MENUENT(mRt2,  ZTX("CMYK Density"), 0,       ZTX("Adjust color using CMYK or RGB values"),        m_CMYK, 0 );
   MENUENT(mRt2,  ZTX("Revise RGB"), 0,         ZTX("Adjust color in selected image areas"),         m_revise_RGB, 0 );
   MENUENT(mRt2,  ZTX("Brightness Ramp"), 0,    ZTX("Fix brightness uniformity across image"),       m_brightramp, 0 );
   MENUENT(mRt2,  ZTX("Remove Dust"), 0,        ZTX("Remove dust spots from scanned slides"),        m_dust, 0 );
   MENUENT(mRt2,  ZTX("Fix Stuck Pixels"), 0,   ZTX("Erase known hot and dark pixels"),              m_stuckpix, 0 );
   MENUENT(mRt2,  ZTX("Fix Color Fringes"), 0,  ZTX("Reduce Chromatic Abberation"),                  m_chromatic, 0 );
   MENUENT(mRt2,  ZTX("Paint Pixels"), 0,       ZTX("Paint image pixels using the mouse"),           m_paint_pixels, 0 );
   MENUENT(mRt2,  ZTX("Leverage Edits"), 0,     ZTX("Leverage edits by brightness or color"),        m_lever_edits, 0 );
   MENUENT(mRt2,  ZTX("Paint Edits"), 0,        ZTX("Paint edit function gradually with the mouse"), m_paint_edits, 0 );

   MENUENT(mArt,  ZTX("Color Depth"), 0,   ZTX("Reduce color depth (posterize)"),             m_colordep, 0 );
   MENUENT(mArt,  ZTX("Drawing"), 0,       ZTX("Convert to charcoal or chalk drawing"),       m_draw, 0 );
   MENUENT(mArt,  ZTX("Outlines"), 0,      ZTX("Convert to colored line drawing"),            m_outlines, 0 );
   MENUENT(mArt,  ZTX("Embossing"), 0,     ZTX("Create an embossed or 3D appearance"),        m_emboss, 0 );
   MENUENT(mArt,  ZTX("Tiles"), 0,         ZTX("Convert to square tiles"),                    m_tiles, 0 );
   MENUENT(mArt,  ZTX("Dots"), 0,          ZTX("Convert to dots (Roy Lichtenstein effect)"),  m_dots, 0 );
   MENUENT(mArt,  ZTX("Painting"), 0,      ZTX("Convert into a simulated painting"),          m_painting, 0 );
   MENUENT(mArt,  ZTX("Shift Colors"), 0,  ZTX("Shift/convert colors into other colors"),     m_shiftRGB, 0 );

   MENUENT(mComb,  ZTX("High Dynamic Range"), 0,  ZTX("Combine bright/dark images for better detail"),   m_HDR, 0 );
   MENUENT(mComb,  ZTX("High Depth of Field"), 0, ZTX("Combine near/far focus images for deeper focus"), m_HDF, 0 );
   MENUENT(mComb,  ZTX("Stack / Paint"), 0,       ZTX("Combine images to erase passing people, etc."),   m_STP, 0 );
   MENUENT(mComb,  ZTX("Stack / Noise"), 0,       ZTX("Combine noisy images into a low-noise image"),    m_STN, 0 );
   MENUENT(mComb,  ZTX("Panorama"), 0,            ZTX("Combine images into a panorama"),                 m_pano, 0 );
   MENUENT(mComb,  ZTX("Vertical Panorama"), 0,   ZTX("Combine images into a vertical panorama"),        m_vpano, 0 );

   MENUENT(mPlugins, ZTX("Edit Plugins"), 0, ZTX("Add another image editor to the menu"), m_edit_plugins, 0);

   MENUENT(mHelp,  ZTX("User Guide"), 0,             ZTX("Read the user guide"),                  m_help, 0 );
   MENUENT(mHelp,  ZTX("User Guide Changes"), 0,     ZTX("Recent user guide changes"),            m_help, 0 );
   MENUENT(mHelp,  ZTX("Program Updates"), 0,        ZTX("Fotoxx updates notification"),          m_help, 0 );
   MENUENT(mHelp,  ZTX("Edit Functions Summary"), 0, ZTX("Summary of image edit functions"),      m_help, 0 );
   MENUENT(mHelp,  ZTX("Keyboard Shortcuts"), 0,     ZTX("List of keyboard shortcuts"),           m_help, 0 );
   MENUENT(mHelp,  ZTX("README"), 0,                 ZTX("Technical installation notes"),         m_help, 0 );
   MENUENT(mHelp,  ZTX("Change Log"), 0,             ZTX("List updates by Fotoxx version"),       m_help, 0 );
   MENUENT(mHelp,  ZTX("Log File"), 0,               ZTX("View the log file and error messages"), m_help, 0 );
   MENUENT(mHelp,  ZTX("Translations"), 0,           ZTX("How to do Fotoxx translations"),        m_help, 0 );
   MENUENT(mHelp,  ZTX("Home Page"), 0,              ZTX("Show the Fotoxx web page"),             m_help, 0 );
   MENUENT(mHelp,  ZTX("About"), 0,                  ZTX("Version, license, contact, credits"),   m_help, 0 );

   MENUENT(fTbar,  ZTX("Favs"),     "favorites.png",  ZTX("Favorites Menu"),            m_favorites, 0 );
   MENUENT(fTbar,  ZTX("Open"),     "open.png",       ZTX("Open a new image file"),     m_open, 0 );
   MENUENT(fTbar,  ZTX("Prev"),     "prev.png",       ZTX("Open the previous file"),    m_prev, 0 );
   MENUENT(fTbar,  ZTX("Next"),     "next.png",       ZTX("Open the next file"),        m_next, 0 );
   MENUENT(fTbar,  "Zoom+",         "zoom+.png",      ZTX("Zoom-in (bigger)"),          m_zoom, 0 );
   MENUENT(fTbar,  "Zoom-",         "zoom-.png",      ZTX("Zoom-out (smaller)"),        m_zoom, 0 );
   MENUENT(fTbar,  ZTX("Undo"),     "undo.png",       ZTX("Undo one edit"),             m_undo, 0 );
   MENUENT(fTbar,  ZTX("Redo"),     "redo.png",       ZTX("Redo one edit"),             m_redo, 0 );
   MENUENT(fTbar,  "separator",     null,             null,                             null, 0 );
   MENUENT(fTbar,  Bcolor,          "fg-color.png",   ZTX("Foreground Color"),          m_fg_color, 0 );
   MENUENT(fTbar,  "separator",     null,             null,                             null, 0 );
   MENUENT(fTbar,  ZTX("Save"),     "save.png",       ZTX("Save to the same file"),     m_save, 0 );
   MENUENT(fTbar,  ZTX("Save+V"),   "save+V.png",     ZTX("Save to a new version"),     m_savevers, 0 );
   MENUENT(fTbar,  ZTX("Save+F"),   "save+F.png",     ZTX("Save to a new file"),        m_saveas, 0 );
   MENUENT(fTbar,  "separator",     null,             null,                             null, 0 );
   MENUENT(fTbar,  ZTX("Trash"),    "trash.png",      ZTX("Move image file to Trash"),  m_trash, 0 );
   MENUENT(fTbar,  "separator",     null,             null,                             null, 0 );


   if (strEqu(menu_style,"classic"))                                       //  build classic menu and toolbar
   {
      for (me = 0; me < Nmenus; me++)
      {
         if (menutab[me].topmenu == fTbar)
            add_toolbar_button(fTbar, menutab[me].text, menutab[me].desc, menutab[me].icon, menutab[me].func);
         else
            add_submenu_item(menutab[me].topmenu, menutab[me].text, menutab[me].func, menutab[me].desc);
      }

      for (int ii = 0; ii < Nplugins; ii++)                                //  add plugin menu items
      {
         char *pp = strstr(plugins[ii]," = ");
         if (! pp) continue;
         *pp = 0;
         add_submenu_item(mPlugins, plugins[ii], m_run_plugin, ZTX("Run as Fotoxx edit function"));
         *pp = ' ';
      }
   }

   else                                                                    //  build vertical menu and toolbar
   {
      for (me = 0; me < Nmenus; me++)
      {
         if (menutab[me].topmenu)
            add_popmenu_item(menutab[me].topmenu, menutab[me].text, menutab[me].func, menutab[me].arg, menutab[me].desc);
         else {
            if (strEqu(menutab[me].text,"separator")) continue;
            if (strEqu(tbar_style,"text"))
               vbox_menu_add(fvbm, menutab[me].text, 0, menutab[me].desc, menutab[me].func, menutab[me].arg);
            else if (strEqu(tbar_style,"icons")) 
               vbox_menu_add(fvbm, 0, menutab[me].icon, menutab[me].desc, menutab[me].func, menutab[me].arg);
            else 
               vbox_menu_add(fvbm, menutab[me].text, menutab[me].icon, menutab[me].desc, menutab[me].func, menutab[me].arg);
         }
      }

      for (int ii = 0; ii < Nplugins; ii++) {                              //  build plugins menu
         char *pp = strstr(plugins[ii]," = ");
         if (! pp) continue;
         *pp = 0;
         add_popmenu_item(mPlugins, plugins[ii], m_run_plugin, 0, ZTX("Run as Fotoxx edit function"));  
         *pp = ' ';
      }
   }
   

   //  build the gallery window toolbar, either classic (at the top of the window)
   //   or vertical on the left side of the window.
   
   GtkWidget   *gTbar, *gVbox2, *ghbox;
   vbox_menu   *gvbm = 0;
   PangoFontDescription    *pfontdesc;

   if (strEqu(menu_style,"classic"))                                       //  classic toolbar
   {
      gTbar = create_toolbar(gVbox,24);                                    //  add toolbar and buttons
      gVbox2 = gVbox;

      if (strEqu(tbar_style,"icons"))                                      //  set toolbar style
         gtk_toolbar_set_style(GTK_TOOLBAR(gTbar),GTK_TOOLBAR_ICONS);
      else if (strEqu(tbar_style,"text"))
         gtk_toolbar_set_style(GTK_TOOLBAR(gTbar),GTK_TOOLBAR_TEXT);
      else gtk_toolbar_set_style(GTK_TOOLBAR(gTbar),GTK_TOOLBAR_BOTH);
   }

   else                                                                    //  vertical toolbar
   {
      ghbox = gtk_box_new(GTK_ORIENTATION_HORIZONTAL,0);                   //   ____________________
      gtk_box_pack_start(GTK_BOX(gVbox),ghbox,1,1,0);                      //  |       |            |
      gTbar = gtk_box_new(GTK_ORIENTATION_VERTICAL,0);                     //  | gTbar |  gVbox2    | ghbox
      gVbox2 = gtk_box_new(GTK_ORIENTATION_VERTICAL,0);                    //  |       |  gallery   |
      gtk_box_pack_start(GTK_BOX(ghbox),gTbar,0,0,0);                      //  |_______|____________|
      gtk_box_pack_start(GTK_BOX(ghbox),gVbox2,1,1,0);
      gtk_widget_set_size_request(gTbar,10,0);                             //  compensate GTK bug
      gvbm = vbox_menu_new(gTbar);
   }

   gHbox = gtk_box_new(HORIZONTAL,0);                                      //  add navigation widgets
   gtk_box_pack_start(GTK_BOX(gVbox2),gHbox,0,0,0);                        //  [file system] [no directory]
   gHome = gtk_button_new_with_label("file system");
   gPath = gtk_entry_new();                                                //  add directory label
   gtk_entry_set_text(GTK_ENTRY(gPath),"no directory");
   gtk_widget_set_can_focus(gPath,0);                                      //  stop unwanted focus
   gtk_box_pack_start(GTK_BOX(gHbox),gHome,0,0,3);
   gtk_box_pack_start(GTK_BOX(gHbox),gPath,1,1,3);
   pfontdesc = pango_font_description_from_string("Monospace 10");         //  monospace font, 8 pixel width
   gtk_widget_modify_font(gPath,pfontdesc);

   gSwin = gtk_scrolled_window_new(0,0);                                   //  create scrolled window
   gtk_scrolled_window_set_policy(SCROLLWIN(gSwin),NEVER,ALWAYS);          //  vertical scroll bar
   gSadj = gtk_scrolled_window_get_vadjustment(SCROLLWIN(gSwin));
   gtk_box_pack_start(GTK_BOX(gVbox2),gSwin,1,1,0);
   gDwin = gtk_drawing_area_new();                                         //  create drawing window
   gtk_scrolled_window_add_with_viewport(SCROLLWIN(gSwin),gDwin);          //  add to scrolled window

   int me0 = Nmenus;

   MENUENT(gTbar, ZTX("Open"),    "open.png",     ZTX("change directory"),         navi::menufuncx, 0 );
   MENUENT(gTbar, ZTX("Discard"), "discard.png",  ZTX("new gallery from tab F"),   navi::menufuncx, 0 );
   MENUENT(gTbar, "Zoom+",        "zoom+.png",    ZTX("increase thumbnail size"),  navi::menufuncx, 0 );
   MENUENT(gTbar, "Zoom-",        "zoom-.png",    ZTX("reduce thumbnail size"),    navi::menufuncx, 0 );
   MENUENT(gTbar, ZTX("First"),   "top.png",      ZTX("jump to first page"),       navi::menufuncx, 0 );
   MENUENT(gTbar, ZTX("Last"),    "bottom.png",   ZTX("jump to last page"),        navi::menufuncx, 0 );
   MENUENT(gTbar, ZTX("Page↑"),   "up+.png",      ZTX("previous page"),            navi::menufuncx, 0 );
   MENUENT(gTbar, ZTX("Page↓"),   "down+.png",    ZTX("next page"),                navi::menufuncx, 0 );
   MENUENT(gTbar, ZTX("Row↑"),    "up.png",       ZTX("previous row"),             navi::menufuncx, 0 );
   MENUENT(gTbar, ZTX("Row↓"),    "down.png",     ZTX("next row"),                 navi::menufuncx, 0 );

   for (me = me0; me < Nmenus; me++)
   {
      if (strEqu(menu_style,"classic"))
         add_toolbar_button(gTbar, menutab[me].text, menutab[me].desc, menutab[me].icon, menutab[me].func);
      else {
         if (strEqu(tbar_style,"text"))
            vbox_menu_add(gvbm, menutab[me].text, 0, menutab[me].desc, menutab[me].func, menutab[me].arg);
         else if (strEqu(tbar_style,"icons")) 
            vbox_menu_add(gvbm, 0, menutab[me].icon, menutab[me].desc, menutab[me].func, menutab[me].arg);
         else 
            vbox_menu_add(gvbm, menutab[me].text, menutab[me].icon, menutab[me].desc, menutab[me].func, menutab[me].arg);
      }
   }

   return;
}


