/**************************************************************************

   Fotoxx      edit photos and manage collections

   Copyright 2007 2008 2009 2010 2011 2012 Michael Cornelison
   Source URL: http://kornelix.com/fotoxx
   Contact: kornelix2@gmail.com
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program. If not, see http://www.gnu.org/licenses/.

***************************************************************************/

#define EX extern                 //  disable extern declarations
#include "fotoxx.h"

/**************************************************************************
      Fotoxx image edit - file menu functions
***************************************************************************/

//  Setup function for right-click popup menus
//  for the main window and gallery thumbnails.

GtkWidget  *popmenu_main, *popmenu_thumb, *popmenu_raw;

void Rclick_Popup_setup()
{
   static int        initflag = 0;
   
   if (initflag && ! ZTXnewtranslations()) return;                         //  v.13.01
   initflag = 1;

   cchar    *menurename = ZTX("Rename");
   cchar    *menucopyto = ZTX("Copy to");
   cchar    *menumoveto = ZTX("Move to");
   cchar    *menudelete = ZTX("Delete");
   cchar    *menutrash = ZTX("Trash");
   cchar    *menuprint = ZTX("Print");
   cchar    *menucopy = ZTX("Copy to Clipboard");
   cchar    *menutrim = ZTX("Trim");
   cchar    *menuresize = ZTX("Resize");
   cchar    *menurotate = ZTX("Rotate");
   cchar    *menuvoodoo = ZTX("Voodoo Enhance");
   cchar    *menubright = ZTX("Brightness/Color");
   cchar    *menugamma = ZTX("Gamma Curves");
   cchar    *menuflatten = ZTX("Flatten Brightness");
   cchar    *menutonemap = ZTX("Tone Mapping");
   cchar    *menuwhitebal = ZTX("White Balance");
   cchar    *menuredeyes = ZTX("Red Eyes");
   cchar    *menugrid = ZTX("Grid Lines");
   cchar    *menuselect = ZTX("Select Area");
   cchar    *menuopenraw = ZTX("Open RAW file (ufraw)");

   popmenu_main = create_popmenu();
   add_popmenu_item(popmenu_main,menurename,popup_menufunc,"rename");
   add_popmenu_item(popmenu_main,menucopyto,popup_menufunc,"copyto");
   add_popmenu_item(popmenu_main,menumoveto,popup_menufunc,"moveto");
   add_popmenu_item(popmenu_main,menudelete,popup_menufunc,"delete");
   add_popmenu_item(popmenu_main,menutrash,popup_menufunc,"trash");
   add_popmenu_item(popmenu_main,menuprint,popup_menufunc,"print");
   add_popmenu_item(popmenu_main,menutrim,popup_menufunc,"trim");
   add_popmenu_item(popmenu_main,menuresize,popup_menufunc,"resize");
   add_popmenu_item(popmenu_main,menurotate,popup_menufunc,"rotate");
   add_popmenu_item(popmenu_main,menuvoodoo,popup_menufunc,"voodoo");
   add_popmenu_item(popmenu_main,menubright,popup_menufunc,"bright");
   add_popmenu_item(popmenu_main,menugamma,popup_menufunc,"gamma");
   add_popmenu_item(popmenu_main,menuflatten,popup_menufunc,"flatten");
   add_popmenu_item(popmenu_main,menutonemap,popup_menufunc,"tonemap");
   add_popmenu_item(popmenu_main,menuwhitebal,popup_menufunc,"whitebal");
   add_popmenu_item(popmenu_main,menuredeyes,popup_menufunc,"redeyes");
   add_popmenu_item(popmenu_main,menugrid,popup_menufunc,"grid");
   add_popmenu_item(popmenu_main,menuselect,popup_menufunc,"select");
   add_popmenu_item(popmenu_main,menucopy,popup_menufunc,"copy");

   popmenu_thumb = create_popmenu();
   add_popmenu_item(popmenu_thumb,menurename,popup_menufunc,"rename");
   add_popmenu_item(popmenu_thumb,menucopyto,popup_menufunc,"copyto");
   add_popmenu_item(popmenu_thumb,menumoveto,popup_menufunc,"moveto");
   add_popmenu_item(popmenu_thumb,menuprint,popup_menufunc,"print");
   add_popmenu_item(popmenu_thumb,menutrash,popup_menufunc,"trash");
   add_popmenu_item(popmenu_thumb,menudelete,popup_menufunc,"delete");
   add_popmenu_item(popmenu_thumb,menucopy,popup_menufunc,"copy");

   popmenu_raw = create_popmenu();
   add_popmenu_item(popmenu_raw,menuopenraw,f_open_ufraw,0);
   add_popmenu_item(popmenu_raw,menurename,popup_menufunc,"rename");
   add_popmenu_item(popmenu_raw,menucopyto,popup_menufunc,"copyto");
   add_popmenu_item(popmenu_raw,menumoveto,popup_menufunc,"moveto");
   add_popmenu_item(popmenu_raw,menutrash,popup_menufunc,"trash");
   add_popmenu_item(popmenu_raw,menudelete,popup_menufunc,"delete");

   return;
}   


//  right-click popup menu function

void popup_menufunc(GtkWidget *, cchar *menu)                              //  v.12.12
{
   if (strEqu(menu,"rename")) m_rename(0,0);                               //  funcs used from main + gallery windows
   if (strEqu(menu,"copyto")) m_copyto(0,0);                               //  these funcs use click_file if defined,
   if (strEqu(menu,"moveto")) m_moveto(0,0);                               //    else they use curr_file.
   if (strEqu(menu,"delete")) m_delete(0,0);                               //  set click_file to null after use.
   if (strEqu(menu,"trash")) m_trash(0,0);
   if (strEqu(menu,"print")) m_print(0,0);
   if (strEqu(menu,"copy")) copyto_clipboard(0,0);

   if (strEqu(menu,"trim")) m_trim(0,0);                                   //  these functions use curr_file only
   if (strEqu(menu,"resize")) m_resize(0,0);                               //  (not used for gallery/thumbnail click)
   if (strEqu(menu,"rotate")) m_rotate(0,0);
   if (strEqu(menu,"voodoo")) m_voodoo(0,0);
   if (strEqu(menu,"bright")) m_tune(0,0);
   if (strEqu(menu,"gamma")) m_gamma(0,0);
   if (strEqu(menu,"flatten")) m_flatten(0,0);
   if (strEqu(menu,"tonemap")) m_tonemap(0,0);
   if (strEqu(menu,"whitebal")) m_whitebal(0,0);
   if (strEqu(menu,"redeyes")) m_redeye(0,0);
   if (strEqu(menu,"grid")) toggle_grid(2);
   if (strEqu(menu,"select")) m_select(0,0);
   return;
}


//  main window mouse right-click popup menu

void image_Rclick_popup(int Nth)
{
   Rclick_Popup_setup();
   if (! curr_file) return;
   popup_menu(0,popmenu_main);
   return;
}


//  gallery thumbnail mouse left-click function
//  open the clicked file in the main window

void gallery_Lclick_func(int Nth)
{
   char     *file;

   zfuncs::F1_help_topic = "navigation";
   
   file = gallery(0,"find",Nth);
   if (! file) return;
   
   f_open(file,1,Nth);                                                     //  clicked file >> current file

   zfree(file);
   return;
}


//  gallery thumbnail mouse right-click popup menu

void gallery_Rclick_popup(int Nth)                                         //  v.12.09
{
   int      ftype;

   Rclick_Popup_setup();

   click_file = gallery(0,"find",Nth);                                     //  click_file is subject for zfree()
   if (! click_file) return;
   ftype = image_file_type(click_file);

   if (ftype == 2)                                                         //  clicked thumbnail is an image file
      popup_menu(0,popmenu_thumb);

   if (ftype == 3) {                                                       //  clicked thumbnail is a RAW file
      popup_menu(0,popmenu_raw);
   }

   return;
}


/**************************************************************************/

//  function to copy an image file to the clipboard
//  used in thumbnail right-click popup menu

void copyto_clipboard(GtkWidget *, cchar *)                                //  v.12.09
{
   GtkClipboard   *clipboard;
   GdkPixbuf      *pixbuf;
   GError         *gerror = 0;
   char           *file;
   
   if (click_file) file = click_file;                                      //  v.12.12
   else file = strdupz(curr_file,0,"clipboard");
   click_file = 0;
   pixbuf = gdk_pixbuf_new_from_file(file,&gerror);
   zfree(file);
   if (! pixbuf) return;
   clipboard = gtk_clipboard_get(GDK_SELECTION_CLIPBOARD);
   gtk_clipboard_clear(clipboard);
   gtk_clipboard_set_image(clipboard,pixbuf);
   g_object_unref(pixbuf);
   return;
}


/**************************************************************************/

//  start a new parallel instance of fotoxx
//  new window is slightly down and right from old window

void m_clone(GtkWidget *, cchar *)
{
   int      cc, xx, yy, ww, hh, err;
   char     progexe[300];

   zfuncs::F1_help_topic = "clone";
   
   gtk_window_get_position(MWIN,&xx,&yy);                                  //  get window position and size
   gtk_window_get_size(MWIN,&ww,&hh);

   cc = readlink("/proc/self/exe",progexe,300);                            //  get own program path      v.13.01
   if (cc <= 0) {
      zmessageACK(mWin,"cannot get /proc/self/exe");
      return;
   }
   progexe[cc] = 0;

   snprintf(command,ccc,"%s -c %d %d %d %d -lang %s",progexe,xx,yy,ww,hh,zfuncs::zlang);
   if (curr_file) strncatv(command,ccc," \"",curr_file,"\"",null);

   strcat(command," &");                                                   //  start new instance and pass
   printf("command: %s \n",command);                                       //    my window posn and size
   err = system(command);
   if (err) printf("%s \n",wstrerror(err));
   return;
}


/**************************************************************************/

//  open file menu function

void m_open(GtkWidget *, cchar *)
{
   zfuncs::F1_help_topic = "open_image_file";
   f_open(null,1);
   return;
}


/**************************************************************************/

//  open drag-drop file

void m_open_drag(int x, int y, char *file)
{
   zfuncs::F1_help_topic = "open_image_file";
   f_open(file,1);
   return;
}


/**************************************************************************/

//  open the previous file opened (not the same as toolbar [prev] button)
//  repeated use will cycle back and forth between two most recent files

void m_previous(GtkWidget *, cchar *)
{
   int            ii, jj, err;
   struct stat    statb;
   
   zfuncs::F1_help_topic = "open_previous_file";

   if (checkmenulock()) return;                                            //  menu locked               v.12.09
   if (mod_keep()) return;
   
   if (curr_file) jj = 1;                                                  //  2nd most recent file
   else jj = 0;                                                            //  no current file, use most recent

   for (ii = jj; ii < Nrecentfiles; ii++)
   {
      if (! recentfiles[ii]) continue;                                     //  bugfix  v.12.01
      err = stat(recentfiles[ii],&statb);                                  //  stop message loop if many files deleted
      if (err) continue;                                                   //  v.12.09
      err = f_open(recentfiles[ii],1);                                     //  get first one that is still there
      return;                                                              //  do not loop               v.12.11
   }

   return;
}


/**************************************************************************/

//  open an image file from the list of recent image files

void m_recent(GtkWidget *, cchar *)
{
   int      ii, jj, typ;
   FILE     *fid;

   zfuncs::F1_help_topic = "open_recent_file";

   if (checkmenulock()) return;                                            //  menu locked                  v.12.09
   if (mod_keep()) return;

   fid = fopen(recentfiles_file,"w");                                      //  revalidate recent files list
   if (! fid) return;                                                      //    and write to disk

   for (ii = jj = 0; ii < Nrecentfiles; ii++)
   {
      if (! recentfiles[ii]) continue;
      typ = image_file_type(recentfiles[ii]);
      if (typ != 2 && typ != 3) {                                          //  image or RAW file            v.12.09
         zfree(recentfiles[ii]);
         recentfiles[ii] = 0;
         continue;
      }
      if (jj < ii) {
         recentfiles[jj] = recentfiles[ii];
         recentfiles[ii] = 0;
      }
      fprintf(fid,"%s \n",recentfiles[jj]);
      jj++;
   }

   fclose(fid);

   if (! jj) return;                                                       //  no files found
   
   navi::gallerytype = 2;                                                  //  prevent f_open() from refreshing gallery
   gallery(recentfiles_file,"initF");                                      //  generate gallery of recent files
   navi::gallerytype = 5;                                                  //  gallery type = recent files
   gallery(0,"paint");

   return;
}


/**************************************************************************/

//  open previous or next file in current gallery list

void m_prev_next(int index)                                                //  v.12.11
{
   int         err, Nth, ftype;
   char        *pfile, *ptiff;
   struct stat statb;
   
   if (! curr_file) return;
   if (checkmenulockquiet()) return;                                       //  for high-speed button hammering v.12.09
   if (mod_keep()) return;
   
   err = stat(curr_file,&statb);                                           //  tolerate curr. file deleted     v.12.12
   if (err) curr_file_posn -= index;                                       //  start search from prior gallery posn.
   
   for (Nth = curr_file_posn + index; ; Nth += index)
   {
      if (Nth < 0) return;
      if (Nth >= navi::nfiles) return;
      pfile = gallery(0,"find",Nth);                                       //  next file in gallery
      if (! pfile) continue;                                               //  v.12.12
      ftype = image_file_type(pfile);
      if (ftype != 2 && ftype != 3) {                                      //  not an image or raw file
         zfree(pfile);
         continue;
      }

      if (ftype == 3) {                                                    //  RAW file
         ptiff = raw_to_tiff(pfile);                                       //  get equivalent .tiff
         if (strEqu(ptiff,curr_file)) {                                    //  if same as current file, ignore
            zfree(pfile);                                                  //  v.12.10
            zfree(ptiff);
            continue;
         }
         zfree(ptiff);
      }

      if (ftype == 2 || ftype == 3) {                                      //  open the RAW or image file
         err = stat(pfile,&statb);                                         //  (if RAW, tiff will be opened or created)
         if (err) { zfree(pfile); continue; }                              //  v.12.11
         err = f_open(pfile,1,Nth);
         zfree(pfile);
         if (err) return;
         f_preload(index);                                                 //  preload next image              v.12.06
         return;
      }
   }
   
   return;
}


void m_prev(GtkWidget *, cchar *menu)
{
   if (menu) zfuncs::F1_help_topic = "open_image_file";
   m_prev_next(-1);                                                        //  search from curr_file -1 to first file
   return;
}


void m_next(GtkWidget *, cchar *menu) 
{
   if (menu) zfuncs::F1_help_topic = "open_image_file";
   m_prev_next(+1);                                                        //  search from curr_file +1 to last file
   return;
}


/**************************************************************************/

//  menu function: open a camera RAW file and edit with the ufraw GUI

void m_ufraw(GtkWidget *, cchar *menu)                                     //  v.12.09
{
   char        *pp;

   zfuncs::F1_help_topic = "open_raw_ufraw";
   
   if (rawfile) zfree(rawfile);

   pp = curr_file;                                                         //  directory for file open dialog
   if (! pp) pp = curr_dirk;
   rawfile = zgetfile1(ZTX("Open RAW file (ufraw)"),"open",pp);            //  dialog to get RAW filespec
   if (! rawfile) return;
   
   if (image_file_type(rawfile) != 3) {
      zmessageACK(mWin,ZTX("RAW type not registered in User Settings"));
      zfree(rawfile);
      rawfile = 0;
      return;
   }
   
   f_open_ufraw(0,0);
   return;
}


/**************************************************************************/

//  save (modified) image to same file

void m_save(GtkWidget *, cchar *menu)
{
   int         Fwarn = 1, zstat, suppress;
   char        *pp;
   zdialog     *zd;
   cchar       *warn_message = ZTX("Overwrite original file?");
   cchar       *suppress_message = ZTX("Do not warn again");

   if (checkmenulock()) return;                                            //  menu locked            v.12.09
   if (! curr_file) return;

   if (menu && strNeq(menu,"nowarn"))                                      //  don't change help topic
      zfuncs::F1_help_topic = "save_file";

   if (Fwarnoverwrite) {                                                   //  warn if overwrite original
      pp = strrchr(curr_file,'/');
      if (! pp) return;
      pp = strstr(pp,".v");                                                //  look for version notation .vNN 
      if (pp && pp[2] >= '0' && pp[2] <= '9'
          && pp[3] >= '0' && pp[3] <= '9') Fwarn = 0;                      //  found, file not original
   
      if (Fwarn && ! (menu && strEqu(menu,"nowarn"))) {                    //  no warn if KB rotate save 
         zd = zdialog_new(ZTX("Warning"),mWin,Bproceed,Bcancel,null);
         zdialog_add_widget(zd,"label","lab1","dialog",warn_message,"space=5");
         zdialog_add_widget(zd,"check","suppress","dialog",suppress_message,"space=5");
         zdialog_run(zd,0,"mouse");                                        //  v.13.01
         zstat = zdialog_wait(zd);
         zdialog_fetch(zd,"suppress",suppress);
         zdialog_free(zd);
         if (suppress) {
            Fwarnoverwrite = 0;
            save_params();
         }
         if (zstat != 1) return;
      }
   }
   
   strcpy(jpeg_quality,def_jpeg_quality);                                  //  default jpeg save quality

   if (strEqu(curr_file_type,"other"))                                     //  if not supported type, use jpg
      strcpy(curr_file_type,"jpg");

   f_save(curr_file,curr_file_type,curr_file_bpc);                         //  save file
   
   strcpy(curr_file_type,f_save_type);                                     //  update curr_file_xxx from f_save_xxx
   curr_file_size = f_save_size;
   
   return;
}


/**************************************************************************/

//  save (modified) image to new version of same file
//   - no confirmation of overwrite.

void m_savevers(GtkWidget *, cchar *)
{   
   char           *outfile, *pext, *pvers;
   cchar          *delim;
   int            ii, err, nvers;
   struct stat    fstat;
   
   if (checkmenulock()) return;                                            //  menu locked            v.12.09
   if (! curr_file) return;

   zfuncs::F1_help_topic = "save_file";

   strcpy(jpeg_quality,def_jpeg_quality);                                  //  default jpeg save quality

   outfile = strdupz(curr_file,12,"curr_file");                            //  output file name TBD

   pext = strrchr(outfile,'/');                                            //  find file .ext
   if (pext) pext = strrchr(pext,'.');
   if (pext && strlen(pext) > 5) pext = 0;
   if (! pext) pext = outfile + strlen(outfile);                           //  unknown, none

   pvers = pext - 4;                                                       //  find curr. version: filename.vNN.ext
   if (! strnEqu(pvers,".v",2)) nvers = 0;
   else {
      err = convSI(pvers+2,nvers,1,98,&delim);                             //  convert NN to number 1-98
      if (err > 1) nvers = 0;                                              //  conversion error
      if (delim != pext) nvers = 0;                                        //  check format is .vNN
   }
   if (nvers == 0) {                                                       //  no version in file name
      pvers = pext;
      pext += 4;
      memmove(pext,pvers,6);                                               //  make space for .vNN before .ext
      strncpy(pvers,".vNN",4);
   }

   for (ii = 98; ii > nvers; ii--)                                         //  look for higher file versions
   {
      pvers[2] = ii/10 + '0';                                              //  build filename.vNN.ext
      pvers[3] = ii - 10 * (ii/10) + '0';
      err = stat(outfile,&fstat);
      if (! err) break;
   }

   ii++;                                                                   //  use next version 1-99
   nvers = ii;
   pvers[2] = ii/10 + '0';                                                 //  build filename.vNN.ext
   pvers[3] = ii - 10 * (ii/10) + '0';

   if (strEqu(curr_file_type,"other"))                                     //  if not supported type, use jpg
      strcpy(curr_file_type,"jpg");                                        //  v.12.09

   f_save(outfile,curr_file_type,curr_file_bpc);                           //  save file (fails at 99 versions)

   f_open(f_save_file,1,0,1);                                              //  open actual file saved (.ext may change)
                                                                           //                            v.12.11
   zfree(outfile);
   return;
}


/**************************************************************************/

//  save (modified) image to new file
//  confirm if overwrite existing file

GtkWidget   *saveas_fchooser;

void m_saveas(GtkWidget *, cchar *menu)
{
   void  saveas_radiobutt(void *, int button);
   void  saveas_kbkey(void *, GdkEventKey *event);

   GtkWidget      *fdialog, *vbox, *hbox;
   GtkWidget      *tif8, *tif16, *png8, *png16, *ico, *bmp, *jpg, *jqlab, *jqval;
   GtkWidget      *makecurrent;
   char           *outfile = 0, *outfile2 = 0, *pext;
   int            ii, err, yn, bpc, status, mkcurr = 0;
   struct stat    fstat;
   cchar          *type;

   if (checkmenulock()) return;                                            //  menu locked            v.12.09
   if (! curr_file) return;

   if (menu) zfuncs::F1_help_topic = "save_file";

   fdialog = gtk_dialog_new_with_buttons(ZTX("Save File"),                 //  build file save dialog
                           MWIN, GTK_DIALOG_MODAL,
                           GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, 
                           GTK_STOCK_SAVE, GTK_RESPONSE_ACCEPT, null);

   gtk_window_set_default_size(GTK_WINDOW(fdialog),600,500);
   
   vbox = gtk_dialog_get_content_area(GTK_DIALOG(fdialog));

   saveas_fchooser = gtk_file_chooser_widget_new(GTK_FILE_CHOOSER_ACTION_SAVE);
   gtk_container_add(GTK_CONTAINER(vbox),saveas_fchooser);

   gtk_file_chooser_set_filename(GTK_FILE_CHOOSER(saveas_fchooser),curr_file);
   char *fname = strrchr(curr_file,'/') + 1;
   gtk_file_chooser_set_current_name(GTK_FILE_CHOOSER(saveas_fchooser),fname);
   
   hbox = gtk_box_new(HORIZONTAL,0);
   gtk_container_add(GTK_CONTAINER(vbox),hbox);
   gtk_box_set_child_packing(GTK_BOX(vbox),hbox,0,0,10,GTK_PACK_END);

   tif8 = gtk_radio_button_new_with_label(null,"tif-8");
   tif16 = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(tif8),"tif-16");
   png8 = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(tif8),"png-8");
   png16 = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(tif8),"png-16");
   ico = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(tif8),"ico");
   bmp = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(tif8),"bmp");
   jpg = gtk_radio_button_new_with_label_from_widget(GTK_RADIO_BUTTON(tif8),"jpg");
   jqlab = gtk_label_new(ZTX("quality"));
   jqval = gtk_entry_new();
   makecurrent = gtk_check_button_new_with_label(ZTX("make current"));

   gtk_entry_set_width_chars(GTK_ENTRY(jqval),2);
   gtk_box_pack_start(GTK_BOX(hbox),tif8,0,0,5);                           //  (o) tif-8  (o) tif-16
   gtk_box_pack_start(GTK_BOX(hbox),tif16,0,0,5);
   gtk_box_pack_start(GTK_BOX(hbox),png8,0,0,5);                           //   ... (o) png-8  (o) png-16   v.12.09
   gtk_box_pack_start(GTK_BOX(hbox),png16,0,0,5);
   gtk_box_pack_start(GTK_BOX(hbox),ico,0,0,5);                            //   ... (o) ico  (o) bmp
   gtk_box_pack_start(GTK_BOX(hbox),bmp,0,0,5);
   gtk_box_pack_start(GTK_BOX(hbox),jpg,0,0,5);                            //   ... (o) jpg  quality [__]
   gtk_box_pack_start(GTK_BOX(hbox),jqlab,0,0,0);
   gtk_box_pack_start(GTK_BOX(hbox),jqval,0,0,3);
   gtk_box_pack_end(GTK_BOX(hbox),makecurrent,0,0,8);                      //  [x] make current
   
   G_SIGNAL(tif8,"pressed",saveas_radiobutt,0);                            //  connect file type radio buttons
   G_SIGNAL(tif16,"pressed",saveas_radiobutt,1);                           //    to handler function
   G_SIGNAL(png8,"pressed",saveas_radiobutt,2);
   G_SIGNAL(png16,"pressed",saveas_radiobutt,3);                           //  v.12.09
   G_SIGNAL(ico,"pressed",saveas_radiobutt,4);
   G_SIGNAL(bmp,"pressed",saveas_radiobutt,5);
   G_SIGNAL(jpg,"pressed",saveas_radiobutt,6);
   G_SIGNAL(fdialog,"key-release-event",saveas_kbkey,0);

   gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(jpg),1);                 //  set default file type = jpeg
   gtk_entry_set_text(GTK_ENTRY(jqval),def_jpeg_quality);                  //  set default jpeg save quality
   
   if (strEqu(curr_file_type,"tif")) {                                     //  if curr. file type is tif, 
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tif8),1);             //    set tif-8/16 based on file bpc
      if (curr_file_bpc == 16)
         gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(tif16),1);
   }

   if (strEqu(curr_file_type,"png")) {                                     //  same for png                 v.12.09
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(png8),1);
      if (curr_file_bpc == 16)
         gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(png16),1);
   }

   if (strEqu(curr_file_type,"ico"))                                       //  ico type                     v.12.03
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(ico),1);

   if (strEqu(curr_file_type,"bmp"))                                       //  bmp type                     v.12.03
      gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(bmp),1);

dialog_run:

   gtk_widget_show_all(fdialog);                                           //  run dialog

   status = gtk_dialog_run(GTK_DIALOG(fdialog));
   if (status != GTK_RESPONSE_ACCEPT) {                                    //  user cancelled
      gtk_widget_destroy(fdialog);
      return;
   }

   outfile2 = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(saveas_fchooser));
   if (! outfile2) goto dialog_run;
   outfile = strdupz(outfile2,12,"curr_file");                             //  add space for possible .vNN and .ext
   g_free(outfile2);

   type = "jpg";                                                           //  default output type
   bpc = 8;

   if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(tif8)))
      type = "tif";

   if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(tif16))) {
      type = "tif";
      bpc = 16;
   }

   if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(png8)))
      type = "png";

   if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(png16))) {           //  v.12.09
      type = "png";
      bpc = 16;
   }

   if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(ico)))               //  v.12.03
      type = "ico";

   if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(bmp)))               //  v.12.03
      type = "bmp";

   if (strEqu(type,"jpg")) {                                               //  set jpeg save quality
      ii = atoi(gtk_entry_get_text(GTK_ENTRY(jqval)));
      if (ii < 1 || ii > 100) {
         zmessageACK(mWin,ZTX("jpeg quality must be 1-100"));
         goto dialog_run;
      }
      sprintf(jpeg_quality,"%d",ii);
   }

   pext = strrchr(outfile,'/');                                            //  locate file .ext
   if (pext) pext = strrchr(pext,'.');

   if (pext) {                                                             //  validate .ext OK for type    v.12.09
      if (strEqu(type,"jpg") && ! strcasestr(".jpg .jpeg",pext)) pext = 0;
      if (strEqu(type,"tif") && ! strcasestr(".tif .tiff",pext)) pext = 0;
      if (strEqu(type,"png") && ! strcasestr(".png",pext)) pext = 0;
      if (strEqu(type,"bmp") && ! strcasestr(".bmp",pext)) pext = 0;
      if (strEqu(type,"ico") && ! strcasestr(".ico",pext)) pext = 0;
   }

   if (! pext) pext = outfile + strlen(outfile);                           //  wrong or missing, add new .ext
   strcpy(pext,".");
   strcpy(pext+1,type);

   if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(makecurrent)))       //  make saved file the current file?
      mkcurr = 1;
   
   gtk_widget_destroy(fdialog);                                            //  kill dialog

   err = stat(outfile,&fstat);                                             //  check if file exists
   if (! err) {
      yn = zmessageYN(mWin,ZTX("Overwrite file? \n %s"),outfile);          //  confirm overwrite
      if (! yn) {
         zfree(outfile);
         return;
      }
   }

   err = f_save(outfile,type,bpc);                                         //  save the file
   if (err) {
      zfree(outfile);                                                      //  v.12.03
      return;
   }
   
   if (mkcurr)                                                             //  use the saved file as new current file
      f_open(outfile,1,0,1);                                               //    and retain edit history

   zfree(outfile);
   return;
}


//  set dialog file type from user selection of file type radio button

void saveas_radiobutt(void *, int button)
{
   cchar    *filetypes[7] = { ".tif", ".tif", ".png", ".png", ".ico", ".bmp", ".jpg" };
   char     *filespec;
   char     *filename, *pp;

   filespec = gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(saveas_fchooser));
   if (! filespec) return;
   filename = strrchr(filespec,'/');
   if (! filename) return;
   filename = strdupz(filename+1,6,"saveas");
   pp = strrchr(filename,'.');
   if (! pp || strlen(pp) > 5) pp = filename + strlen(filename);
   strcpy(pp,filetypes[button]);
   gtk_file_chooser_set_current_name(GTK_FILE_CHOOSER(saveas_fchooser),filename);
   gtk_widget_show_all(saveas_fchooser);
   zfree(filename);
   g_free(filespec);
   return;
}


//  response function for KB key release

void saveas_kbkey(void *, GdkEventKey *event)
{
   if (event->keyval == GDK_KEY_F1)
      showz_userguide(zfuncs::F1_help_topic);
   return;
}


/**************************************************************************/

//  create a new blank image with desired background color

void m_create(GtkWidget *, cchar *)
{
   int   create_dialog_event(zdialog *zd, cchar *event);

   zdialog     *zd;
   int         zstat;
   char        *prev_file = 0;

   zfuncs::F1_help_topic = "create_blank_image";
   
   if (mod_keep()) return;                                                 //  unsaved edits
   if (! menulock(1)) return;                                              //  lock menus

   if (curr_file) prev_file = strdupz(curr_file,0,"create");

//    file name [___________________________] [.jpg|v]
//    width [____]  height [____] (pixels)
//    color [____]
   
   zd = zdialog_new(ZTX("Create Blank Image"),mWin,Bdone,Bcancel,null);
   zdialog_add_widget(zd,"hbox","hbf","dialog",0,"space=5");
   zdialog_add_widget(zd,"label","labf","hbf",ZTX("file name"),"space=3");
   zdialog_add_widget(zd,"entry","file","hbf","no-name","space=3|expand");
   zdialog_add_widget(zd,"combo","ext","hbf",".jpg");
   zdialog_add_widget(zd,"hbox","hbz","dialog",0,"space=5");
   zdialog_add_widget(zd,"label","space","hbz",0,"space=3");
   zdialog_add_widget(zd,"label","labw","hbz",ZTX("width"));
   zdialog_add_widget(zd,"spin","width","hbz","100|9999|1|1600");
   zdialog_add_widget(zd,"label","space","hbz",0,"space=5");
   zdialog_add_widget(zd,"label","labh","hbz",ZTX("height"));
   zdialog_add_widget(zd,"spin","height","hbz","100|9999|1|1000");
   zdialog_add_widget(zd,"label","space","hbz",0,"space=3");
   zdialog_add_widget(zd,"label","labp","hbz","(pixels) ");
   zdialog_add_widget(zd,"hbox","hbc","dialog",0,"space=5");
   zdialog_add_widget(zd,"label","space","hbc",0,"space=3");
   zdialog_add_widget(zd,"label","labc","hbc",ZTX("color"));
   zdialog_add_widget(zd,"colorbutt","color","hbc","200|200|200");
   
   zdialog_cb_app(zd,"ext",".jpg");
   zdialog_cb_app(zd,"ext",".png");
   zdialog_cb_app(zd,"ext",".tif");
   zdialog_cb_app(zd,"ext",".bmp");
   
   zdialog_help(zd,"create_blank_image");                                  //  zdialog help topic
   zdialog_restore_inputs(zd);                                             //  preload prior user inputs    v.12.09

   zdialog_run(zd,create_dialog_event);                                    //  run dialog
   zstat = zdialog_wait(zd);                                               //  wait for completion
   zdialog_free(zd);

   if (zstat != 1) {                                                       //  cancel
      if (prev_file) {
         f_open(prev_file,0);                                              //  back to previous file
         zfree(prev_file);
         mwpaint2();
      }
   }

   menulock(0);
   return;
}


//  create dialog event and completion function

int create_dialog_event(zdialog *zd, cchar *event)                         //  overhauled
{
   char           color[20], fname[100], fext[8], *filespec;
   cchar          *pp;
   int            fncc, ww, hh, err, cstat;
   static int     red, green, blue;
   PXB            *tempxb;
   GError         *gerror = 0;
   uint8          *pixel;
   struct stat    statb;

   if (zd->zstat != 1) return 0;                                           //  [done]
   
   zdialog_fetch(zd,"file",fname,92);                                      //  get new file name
   strTrim2(fname);
   if (*fname <= ' ') strcpy(fname,"no-name");

   zdialog_fetch(zd,"ext",fext,8);                                         //  add extension
   strcat(fname,fext);
   
   fncc = strlen(fname);
   filespec = strdupz(curr_dirk,fncc+4,"create");                          //  make full filespec
   strcat(filespec,"/");
   strcat(filespec,fname);
   
   err = stat(filespec,&statb);                                            //  make sure it does not exist
   if (! err) {
      zmessageACK(mWin,"file already exists");
      zfree(filespec);
      zd->zstat = 0;                                                       //  keep dialog alive
      return 0;
   }
   
   if (curr_file) zfree(curr_file);                                        //  stop copy of metadata from old file
   curr_file = 0; 

   zdialog_fetch(zd,"width",ww);                                           //  get image dimensions
   zdialog_fetch(zd,"height",hh);

   zdialog_fetch(zd,"color",color,19);                                     //  get image color
   pp = strField(color,"|",1);
   if (pp) red = atoi(pp);
   pp = strField(color,"|",2);
   if (pp) green = atoi(pp);
   pp = strField(color,"|",3);
   if (pp) blue = atoi(pp);
   
   tempxb = PXB_make(ww,hh);                                               //  create pixbuf image
   if (! tempxb) zappcrash("out of memory");
   
   for (int py = 0; py < hh; py++)                                         //  fill with color
   for (int px = 0; px < ww; px++)
   {
      pixel = PXBpix(tempxb,px,py);
      pixel[0] = red;
      pixel[1] = green;
      pixel[2] = blue;
   }
   
   if (strEqu(fext,".jpg")) strcpy(fext,"jpeg");
   if (strEqu(fext,".png")) strcpy(fext,"png");
   if (strEqu(fext,".tif")) strcpy(fext,"tiff");
   if (strEqu(fext,".bmp")) strcpy(fext,"bmp");

   cstat = gdk_pixbuf_save(tempxb->pixbuf,filespec,fext,&gerror,null);
   if (! cstat) {
      zmessageACK(mWin,"error: %s",gerror->message);
      PXB_free(tempxb);
      zfree(filespec);
      return 0;
   }

   f_open(filespec,0);                                                     //  make it the current file

   zfree(filespec);
   PXB_free(tempxb);

   return 0;
}


/**************************************************************************/

//  rename menu function
//  activate rename dialog, stuff data from current or clicked file
//  dialog remains active when new file is opened

char     rename_old[200] = "";
char     rename_new[200] = "";
char     rename_prev[200] = "";
char     *rename_file = 0;

void m_rename(GtkWidget *, cchar *menu)                                    //  v.12.12
{
   int rename_dialog_event(zdialog *zd, cchar *event);
   
   char     *pdir, *pfile, *pext;

   if (menu) zfuncs::F1_help_topic = "rename";
   
   if (rename_file) zfree(rename_file);
   rename_file = 0;
   
   if (click_file) {                                                       //  use clicked file if present
      rename_file = click_file;
      click_file = 0;
   }
   else if (curr_file)                                                     //  else current file
      rename_file = strdupz(curr_file,0,"rename");
   else return;

/***
               Rename Image File

         old name  [_____________________]
         new name  [_____________________]
                   [previous name] [add 1]

                         [apply] [cancel]
***/

   if (! zdrename)                                                         //  restart dialog
   {
      zdrename = zdialog_new(ZTX("Rename Image File"),mWin,Bapply,Bcancel,null);
      zdialog *zd = zdrename;

      zdialog_add_widget(zd,"hbox","hb1","dialog",0,"space=10");
      zdialog_add_widget(zd,"vbox","vb1","hb1",0,"homog|space=5");
      zdialog_add_widget(zd,"vbox","vb2","hb1",0,"homog|expand");

      zdialog_add_widget(zd,"label","Lold","vb1",ZTX("old name"));
      zdialog_add_widget(zd,"label","Lnew","vb1",ZTX("new name"));
      zdialog_add_widget(zd,"label","space","vb1");

      zdialog_add_widget(zd,"hbox","hb2","vb2");
      zdialog_add_widget(zd,"label","oldname","hb2");
      zdialog_add_widget(zd,"label","space","hb2",0,"expand");

      zdialog_add_widget(zd,"entry","newname","vb2",0,"scc=30");
      zdialog_add_widget(zd,"hbox","hb3","vb2");
      zdialog_add_widget(zd,"button","Bprev","hb3",ZTX("previous name"));
      zdialog_add_widget(zd,"button","Badd1","hb3",ZTX("add 1"),"space=8");

      zdialog_help(zd,"rename");                                           //  zdialog help topic
      zdialog_run(zd,rename_dialog_event);                                 //  run dialog
   }
   
   zdialog *zd = zdrename;
   parsefile(rename_file,&pdir,&pfile,&pext);
   strncpy0(rename_old,pfile,199);
   strncpy0(rename_new,pfile,199);
   zdialog_stuff(zd,"oldname",rename_old);                                 //  current file name
   zdialog_stuff(zd,"newname",rename_new);                                 //  entered file name (same)

   return;
}


//  dialog event and completion callback function

int rename_dialog_event(zdialog *zd, cchar *event)                         //  v.12.12
{
   char           *pp, *pdir, *pfile, *pext, *newfile;
   int            nseq, digits, ccp, ccn, ccx, Nth, err;
   struct stat    statb;
   
   if (strEqu(event,"Bprev"))                                              //  previous name >> new name
      if (strlen(rename_prev) > 0)
         zdialog_stuff(zd,"newname",rename_prev);

   if (strEqu(event,"Badd1"))                                              //  increment sequence number
   {
      zdialog_fetch(zd,"newname",rename_new,194);                          //  get entered filename
      pp = rename_new + strlen(rename_new);
      digits = 0;
      while (pp[-1] >= '0' && pp[-1] <= '9') {
         pp--;                                                             //  look for NNN in filenameNNN
         digits++;
      }
      nseq = 1 + atoi(pp);                                                 //  NNN + 1
      if (nseq > 9999) nseq = 0;
      if (digits < 2) digits = 2;                                          //  keep digit count if enough
      if (nseq > 99 && digits < 3) digits = 3;                             //  use leading zeros
      if (nseq > 999 && digits < 4) digits = 4;
      snprintf(pp,digits+1,"%0*d",digits,nseq);
      zdialog_stuff(zd,"newname",rename_new);
   }
   
   if (zd->zstat == 0) return 0;                                           //  not finished
   
   if (zd->zstat != 1) {                                                   //  canceled
      zdialog_free(zd);                                                    //  kill dialog
      zdrename = 0;
      if (rename_file) zfree(rename_file);
      rename_file = 0;
      return 0;
   }
   
   zd->zstat = 0;                                                          //  keep dialog active
   
   if (checkmenulock()) return 0;                                          //  menu locked            v.12.09
   
   if (! rename_file) return 0;

   parsefile(rename_file,&pdir,&pfile,&pext);                              //  existing /directories/file.ext

   zdialog_fetch(zd,"newname",rename_new,194);                             //  new file name from user

   ccp = strlen(pdir);                                                     //  length of /directories/
   ccn = strlen(rename_new);                                               //  length of file
   if (pext) ccx = strlen(pext);                                           //  length of .ext
   else ccx = 0;

   newfile = zmalloc(ccp + ccn + ccx + 1,"rename");                        //  put it all together
   strncpy(newfile,rename_file,ccp);                                       //   /directories.../newfilename.ext
   strcpy(newfile+ccp,rename_new);
   if (ccx) strcpy(newfile+ccp+ccn,pext);
   
   err = stat(newfile,&statb);                                             //  check if new name exists
   if (! err) {
      zmessageACK(mWin,ZTX("target file already exists"));
      zfree(newfile);
      return 0;
   }
   
   snprintf(command,ccc,"cp -p \"%s\" \"%s\"",rename_file,newfile);        //  copy old to new file
   err = system(command);
   if (err) {
      zmessageACK(mWin,ZTX("Rename failed: \n %s"),wstrerror(err));
      zdialog_free(zd);
      zdrename = 0;
      zfree(newfile);
      zfree(rename_file);
      rename_file = 0;
      return 0;
   }

   strncpy0(rename_prev,rename_new,199);                                   //  save new name to previous name

   load_filemeta(newfile);                                                 //  add new file to search index
   update_search_index(newfile);
   zfree(newfile);

   err = remove(rename_file);                                              //  delete old file on disk
   if (err) {
      zmessageACK(mWin,ZTX("delete failed: \n %s"),wstrerror(err));
      zdialog_free(zd);
      zdrename = 0;
      zfree(rename_file);
      rename_file = 0;
      return 0;
   }

   delete_search_index(rename_file);                                       //  delete old file in search index
   Nth = gallery_position(rename_file,0);                                  //  find in gallery list
   if (Nth >= 0) gallery(0,"delete",Nth);                                  //  delete from gallery list

   zfree(rename_file);
   rename_file = 0;

   if (cTab == tabF)                                                       //  main window, curr. file was renamed
      m_next(0,0);
   else {                                                                  //  gallery window, kill dialog
      zdialog_free(zd);
      zdrename = 0;
   }

   return 0;
}


/**************************************************************************/

//  copy an image file to a new location (duplicate)

void m_copyto(GtkWidget *, cchar *)                                        //  v.12.12
{
   void copy_move(cchar *);
   copy_move("copy");
   return;
}


//  move an image file to a new location (delete original)

void m_moveto(GtkWidget *, cchar *)
{
   void copy_move(cchar *);                                                //  v.12.12
   copy_move("move");
   return;
}


//  copy an image to a new location and optionally delete the original

char     *copymove_file = 0;
char     *copymove_loc = 0;
int      copymove_Fdelete;

void copy_move(cchar *menu)                                                //  v.12.12
{
   int copymove_dialog_event(zdialog *zd, cchar *event);
   
   static char menux[8];
   
   if (menu) strcpy(menux,menu);                                           //  remember for re-entry with null menu
   
   zfuncs::F1_help_topic = menux;
   
   if (copymove_file) zfree(copymove_file);
   copymove_file = 0;
   
   if (click_file) {                                                       //  use clicked file if present
      copymove_file = click_file;
      click_file = 0;
   }
   else if (curr_file)                                                     //  else use current file
      copymove_file = strdupz(curr_file,0,"copymove");
   else return;

/***
               XXXX Image File

         image file [________________]
         new location [______________] [browse]

                         [apply] [cancel]
***/

   if (! zdcopymove)
   {
      if (strEqu(menux,"copy"))
         zdcopymove = zdialog_new(ZTX("Copy Image File"),mWin,Bapply,Bcancel,null);
      else if (strEqu(menux,"move"))
         zdcopymove = zdialog_new(ZTX("Move Image File"),mWin,Bapply,Bcancel,null);
      else return;

      zdialog *zd = zdcopymove;

      zdialog_add_widget(zd,"hbox","hb1","dialog",0,"space=10");
      zdialog_add_widget(zd,"label","labf","hb1",ZTX("image file"),"space=5");
      zdialog_add_widget(zd,"label","file","hb1");
      zdialog_add_widget(zd,"label","space","hb1",0,"expand");

      zdialog_add_widget(zd,"hbox","hb2","dialog");
      zdialog_add_widget(zd,"label","labl","hb2",ZTX("new location"),"space=5");
      zdialog_add_widget(zd,"entry","newloc","hb2",0,"expand");
      zdialog_add_widget(zd,"button","browse","hb2",Bbrowse,"space=5");

      zdialog_help(zd,menux);                                              //  zdialog help topic
      zdialog_resize(zd,400,0);
      zdialog_run(zd,copymove_dialog_event);                               //  run dialog
   }

   zdialog *zd = zdcopymove;
   
   char *pfile = strrchr(copymove_file,'/');
   if (pfile) pfile++;
   else pfile = copymove_file;

   zdialog_stuff(zd,"file",pfile);
   if (copymove_loc)
      zdialog_stuff(zd,"newloc",copymove_loc);

   if (strEqu(menux,"copy")) copymove_Fdelete = 0;                         //  copy, no delete
   else copymove_Fdelete = 1;                                              //  move, delete original

   return;
}


//  dialog event and completion callback function

int copymove_dialog_event(zdialog *zd, cchar *event)                       //  v.12.12
{
   char           *newloc, *pfile, *newfile;
   int            cc, err, Nth;
   struct stat    statb;
   
   if (strEqu(event,"browse")) {                                           //  browse for new location
      newloc = zgetfile1(ZTX("Select directory"),"folder",copymove_loc);
      if (! newloc) return 0;
      zdialog_stuff(zd,"newloc",newloc);
      if (copymove_loc) zfree(copymove_loc);
      copymove_loc = newloc;
      return 0;
   }
   
   if (zd->zstat == 0) return 0;                                           //  wait for dialog finished
   
   if (zd->zstat != 1) {                                                   //  canceled
      zdialog_free(zd);                                                    //  kill dialog
      zdcopymove = 0;
      if (copymove_file) zfree(copymove_file);
      copymove_file = 0;
      return 0;
   }

   zd->zstat = 0;                                                          //  keep dialog active

   if (checkmenulock()) return 0;                                          //  menu locked
   
   if (! copymove_file) return 0;
   
   if (copymove_loc) zfree(copymove_loc);                                  //  get new location from dialog
   copymove_loc = zmalloc(maxfcc,"copymove");
   zdialog_fetch(zd,"newloc",copymove_loc,maxfcc);
   
   stat(copymove_loc,&statb);                                              //  check for valid directory
   if (! S_ISDIR(statb.st_mode)) {
      zmessageACK(mWin,ZTX("new location is not a directory"));
      return 0;
   }
   
   pfile = strrchr(copymove_file,'/');                                     //  isolate source file filename.ext
   if (pfile) pfile++;
   else pfile = copymove_file;
   cc = strlen(copymove_loc) + strlen(pfile) + 2;                          //  new file = /new/location/filename.ext
   newfile = zmalloc(cc,"copymove");
   strcpy(newfile,copymove_loc);
   strcat(newfile,"/");
   strcat(newfile,pfile);

   err = stat(newfile,&statb);                                             //  check if new file exists
   if (! err) {
      zmessageACK(mWin,ZTX("target file already exists"));
      zfree(newfile);
      return 0;
   }

   snprintf(command,ccc,"cp -p \"%s\" \"%s\"",copymove_file,newfile);      //  copy source file to new file
   err = system(command);
   if (err) {
      zmessageACK(mWin,ZTX("file copy failed: \n %s"),wstrerror(err));
      zfree(newfile);
      zdialog_free(zd);
      zdcopymove = 0;
      zfree(copymove_file);
      copymove_file = 0;
      return 0;
   }

   load_filemeta(newfile);                                                 //  update search index for new file
   update_search_index(newfile);
   zfree(newfile);
   
   if (copymove_Fdelete) {
      err = remove(copymove_file);                                         //  delete file
      if (err) {
         zmessageACK(mWin,ZTX("delete failed: \n %s"),wstrerror(err));
         zdialog_free(zd);
         zdcopymove = 0;
         zfree(copymove_file);
         copymove_file = 0;
         return 0;
      }

      delete_search_index(copymove_file);                                  //  delete old file in search index
      Nth = gallery_position(copymove_file,0);                             //  find in gallery list
      if (Nth >= 0) gallery(0,"delete",Nth);                               //  delete from gallery list
   }

   zfree(copymove_file);
   copymove_file = 0;

   if (cTab == tabF)                                                       //  main window, curr. file copied/moved
      m_next(0,0);
   else {
      zdialog_free(zd);                                                    //  gallery window, kill dialog
      zdcopymove = 0;
   }

   return 0;
}


/**************************************************************************/

//  delete an image file, cannot be reversed

char     *delete_file = 0;

void m_delete(GtkWidget *, cchar *)                                        //  v.12.12
{
   int delete_dialog_event(zdialog *zd, cchar *event);
   
   cchar  *title = ZTX("Delete Image File - CANNOT BE REVERSED");
   
   zfuncs::F1_help_topic = "delete";
   
   if (delete_file) zfree(delete_file);
   delete_file = 0;
   
   if (click_file) {                                                       //  use clicked file if present
      delete_file = click_file;
      click_file = 0;
   }
   else if (curr_file)                                                     //  else use current file
      delete_file = strdupz(curr_file,0,"delete");
   else return;

/***
               Delete Image File
               CANNOT BE REVERSED

         image file [_______________________]

                             [apply] [cancel]
***/

   if (! zddelete)
   {
      zddelete = zdialog_new(title,mWin,Bapply,Bcancel,null);
      zdialog *zd = zddelete;

      zdialog_add_widget(zd,"hbox","hb1","dialog",0,"space=10");
      zdialog_add_widget(zd,"label","labf","hb1",ZTX("image file"),"space=5");
      zdialog_add_widget(zd,"label","file","hb1");

      zdialog_help(zd,"delete");                                           //  zdialog help topic
      zdialog_resize(zd,400,0);
      zdialog_run(zd,delete_dialog_event);                                 //  run dialog
   }

   zdialog *zd = zddelete;

   char *pfile = strrchr(delete_file,'/');
   if (pfile) pfile++;
   else pfile = delete_file;
   zdialog_stuff(zd,"file",pfile);

   return;
}


//  dialog event and completion callback function

int delete_dialog_event(zdialog *zd, cchar *event)                         //  v.12.12
{
   int      err, Nth;
   
   if (zd->zstat == 0) return 0;                                           //  wait for dialog finished
   
   if (zd->zstat != 1) {                                                   //  canceled
      zdialog_free(zd);                                                    //  kill dialog
      zddelete = 0;
      if (delete_file) zfree(delete_file);
      delete_file = 0;
      return 0;
   }

   zd->zstat = 0;                                                          //  keep dialog active

   if (checkmenulock()) return 0;                                          //  menu locked
   
   if (! delete_file) return 0;
   
   err = remove(delete_file);                                              //  delete file
   if (err) {
      zmessageACK(mWin,ZTX("delete failed: \n %s"),wstrerror(err));
      zdialog_free(zd);
      zddelete = 0;
      zfree(delete_file);
      delete_file = 0;
      return 0;
   }

   delete_search_index(delete_file);                                       //  delete old file in search index
   Nth = gallery_position(delete_file,0);                                  //  find in gallery list
   if (Nth >= 0) gallery(0,"delete",Nth);                                  //  delete from gallery list

   zfree(delete_file);
   delete_file = 0;

   if (cTab == tabF)                                                       //  main window, curr. file deleted
      m_next(0,0);
   else {
      zdialog_free(zd);                                                    //  gallery window, kill dialog
      zddelete = 0;
   }
   
   return 0;
}


/**************************************************************************/

//  Trash image file - move curr_file to trash.
//  Use the Linux standard trash function. 
//  If not available, revert to Desktop folder.

char     *trash_file = 0;

void m_trash(GtkWidget *, cchar *)                                         //  v.12.12
{
   int trash_dialog_event(zdialog *zd, cchar *event);
   
   cchar  *title = ZTX("Trash Image File");
   
   zfuncs::F1_help_topic = "trash";
   
   if (trash_file) zfree(trash_file);
   trash_file = 0;
   
   if (click_file) {                                                       //  use clicked file if present
      trash_file = click_file;
      click_file = 0;
   }
   else if (curr_file)                                                     //  else use current file
      trash_file = strdupz(curr_file,0,"trash");
   else return;

/***
               Trash Image File

         image file [_______________________]

                             [apply] [cancel]
***/

   if (! zdtrash)
   {
      zdtrash = zdialog_new(title,mWin,Bapply,Bcancel,null);
      zdialog *zd = zdtrash;

      zdialog_add_widget(zd,"hbox","hb1","dialog",0,"space=10");
      zdialog_add_widget(zd,"label","labf","hb1",ZTX("image file"),"space=3");
      zdialog_add_widget(zd,"label","file","hb1",0,"space=3");

      zdialog_help(zd,"trash");                                            //  zdialog help topic
      zdialog_resize(zd,300,0);
      zdialog_run(zd,trash_dialog_event);                                  //  run dialog
   }

   zdialog *zd = zdtrash;

   char *pfile = strrchr(trash_file,'/');
   if (pfile) pfile++;
   else pfile = trash_file;
   zdialog_stuff(zd,"file",pfile);

   return;
}


//  dialog event and completion callback function

int trash_dialog_event(zdialog *zd, cchar *event)                          //  v.12.12
{
   int            err, yn, Nth, gstat;
   char           trashdir[200];
   GError         *gerror = 0;
   GFile          *gfile = 0;
   struct stat    statb;
   static int     trashworks = 1, desktopworks = 1;                        //  assume OK until found otherwise

   cchar    *mess1 = ZTX("Linux standard trash does not work. \n"
                         "Desktop trash folder will be created.");

   cchar    *mess2 = ZTX("Linux and Desktop trash do not work. \n"
                         "Permanently delete the image file?");

   if (zd->zstat == 0) return 0;                                           //  wait for dialog finished
   
   if (zd->zstat != 1) {                                                   //  canceled
      zdialog_free(zd);                                                    //  kill dialog
      zdtrash = 0;
      if (trash_file) zfree(trash_file);
      trash_file = 0;
      return 0;
   }

   zd->zstat = 0;                                                          //  keep dialog active

   if (checkmenulock()) return 0;                                          //  menu locked
   
   if (! trash_file) return 0;

   err = stat(trash_file,&statb);                                          //  get file status
   if (err) {
      zmessLogACK(mWin,strerror(errno));
      zfree(trash_file);
      trash_file = 0;
      return 0;
   }

   if (! (statb.st_mode & S_IWUSR)) {                                      //  check permission
      yn = zmessageYN(mWin,ZTX("Move read-only file to trash?"));
      if (! yn) {
         zfree(trash_file);
         trash_file = 0;
         return 0;
      }
      statb.st_mode |= S_IWUSR;                                            //  make writable if needed
      chmod(trash_file,statb.st_mode);
   }

   if (trashworks)                                                         //  try Linux standard trash
   {
      gfile = g_file_new_for_path(trash_file);
      gstat = g_file_trash(gfile,0,&gerror);                               //  move file to trash
      g_object_unref(gfile);
      if (! gstat) {
         printf("standard trash failed: %s \n",gerror->message);           //  did not work
         zmessageACK(mWin,mess1);
         trashworks = 0;
      }
   }

   if (! trashworks && desktopworks)
   {
      snprintf(trashdir,199,"%s/%s",getenv("HOME"),desktoptrash);          //  use fotoxx desktop trash folder
      err = stat(trashdir,&statb);
      if (! S_ISDIR(statb.st_mode)) {
         err = mkdir(trashdir,0750);                                       //  create if not already
         if (err) {
            zmessLogACK(mWin,ZTX("Cannot create trash folder: %s"),wstrerror(errno));
            desktopworks = 0;
         }
      }
      
      if (desktopworks)
      {
         snprintf(command,ccc,"cp \"%s\" \"%s\" ",trash_file,trashdir);    //  copy image file to desktop trash
         err = system(command);
         if (err) {
            zmessLogACK(mWin,ZTX("error: %s"),wstrerror(err));
            desktopworks = 0;
         }
         else {
            err = remove(trash_file);                                      //  remove original file
            if (err) {
               zmessLogACK(mWin,ZTX("error: %s"),wstrerror(errno));        //  cannot delete file
               zfree(trash_file);
               trash_file = 0;
               return 0;
            }
         }
      }
   }

   if (! trashworks && ! desktopworks)
   {
      yn = zmessageYN(mWin,mess2);                                         //  nothing works, ask to delete    v.12.08
      if (! yn) {
         zfree(trash_file);
         trash_file = 0;
         return 0;
      }
      err = remove(trash_file);                                            //  delete file
      if (err) {
         zmessLogACK(mWin,ZTX("delete failed: %s"),wstrerror(errno));
         zdialog_free(zd);
         zdtrash = 0;
         zfree(trash_file);
         trash_file = 0;
         return 0;
      }
   }

   delete_search_index(trash_file);                                        //  delete file in search index
   Nth = gallery_position(trash_file,0);                                   //  find in gallery list
   if (Nth >= 0) gallery(0,"delete",Nth);                                  //  delete from gallery list

   zfree(trash_file);
   trash_file = 0;

   if (cTab == tabF)                                                       //  main window, curr. file trashd
      m_next(0,0);
   else {
      zdialog_free(zd);                                                    //  gallery window, kill dialog
      zdtrash = 0;
   }
   
   return 0;
}


/**************************************************************************/

//  print image file

void m_print(GtkWidget *, cchar *)                                         //  use GTK print
{
   int print_addgrid(PXB *Ppxb);

   int      pstat;
   char     *printfile = 0;
   PXB      *Ppxb;
   GError   *gerror = 0;
   
   zfuncs::F1_help_topic = "print";
   
   if (click_file) {                                                       //  use clicked file if present  v.12.12
      printfile = click_file;
      click_file = 0;
   }
   else if (curr_file)                                                     //  else use current file
      printfile = strdupz(curr_file,0,"print");
   else return;
   
   Ppxb = PXB_load(printfile,1);                                           //  error > zmessageACK()
   if (! Ppxb) return;

   zfree(printfile);
   printfile = 0;

   print_addgrid(Ppxb);                                                    //  add grid lines if wanted

   printfile = strdupz(get_zuserdir(),20,"printfile");                     //  make temp print file:
   strcat(printfile,"/printfile.png");                                     //    ~/.fotoxx/printfile.png

   pstat = gdk_pixbuf_save(Ppxb->pixbuf,printfile,"png",&gerror,null);   
   if (! pstat) {
      zmessageACK(mWin,"error: %s",gerror->message);
      PXB_free(Ppxb);
      zfree(printfile);
      return;
   }

   print_image_file(mWin,printfile);
   
   PXB_free(Ppxb);
   zfree(printfile);
   return;
}


//  add grid lines to print image if wanted

int print_addgrid(PXB *Ppxb)
{
   uint8    *pix;
   int      px, py, ww, hh;
   int      startx, starty, stepx, stepy;
   
   if (! Fgrid) return 0;                                                  //  grid lines off

   ww = Ppxb->ww;
   hh = Ppxb->hh;

   stepx = gridspace[0];                                                   //  space between grid lines
   stepy = gridspace[1];
   
   stepx = stepx / Mscale;                                                 //  window scale to image scale
   stepy = stepy / Mscale;
   
   if (gridcount[0]) stepx = ww / (1 + gridcount[0]);                      //  if line counts specified,
   if (gridcount[1]) stepy = hh / ( 1 + gridcount[1]);                     //    set spacing accordingly
   
   startx = stepx * gridoffset[0] / 100;                                   //  variable offsets
   if (startx < 0) startx += stepx;

   starty = stepy * gridoffset[1] / 100;
   if (starty < 0) starty += stepy;

   if (gridon[0]) {
      for (px = startx; px < ww-1; px += stepx)
      for (py = 0; py < hh; py++)
      {
         pix = PXBpix(Ppxb,px,py);
         pix[0] = pix[1] = pix[2] = 255;
         pix[3] = pix[4] = pix[5] = 0;
      }
   }

   if (gridon[1]) {
      for (py = starty; py < hh-1; py += stepy)
      for (px = 0; px < ww; px++)
      {
         pix = PXBpix(Ppxb,px,py);
         pix[0] = pix[1] = pix[2] = 255;
         pix[3] = pix[4] = pix[5] = 0;
      }
   }

   return 1;
}


/**************************************************************************/

//  normal quit menu function

void m_quit(GtkWidget *, cchar *)
{
   if (mod_keep()) return;                                                 //  unsaved edits
   printf("quit \n");
   Fshutdown++;

   for (int ii = 0; ii < 20; ii++) {                                       //  wait if something running
      if (! Ffuncbusy) break;
      zmainloop();
      zsleep(0.1);
   }
   
   if (Ffuncbusy) printf("busy function killed \n");

   quitxx();                                                               //  does not return
   return;
}

//  used also for main window delete and destroy events
//  does not return

void quitxx()                                                              //  v.12.07
{
   Fshutdown++;
   gtk_window_get_position(MWIN,&mwgeom[0],&mwgeom[1]);                    //  get last window position 
   gtk_window_get_size(MWIN,&mwgeom[2],&mwgeom[3]);                        //    and size for next session
   save_params();                                                          //  save state for next session
   zdialog_inputs("save");                                                 //  save dialog inputs              v.12.09
   zdialog_positions("save");                                              //  save dialog positions
   free_resources();                                                       //  delete temp files
   fflush(null);                                                           //  flush stdout, stderr
   exiftool_server(0);                                                     //  kill exiftool_server process    v.12.03
   gtk_main_quit();                                                        //  gone forever
   exit(1);                                                                //  just in case
   return;
}


/**************************************************************************/

//  add a file to the list of recent files

void add_recent_file(cchar *file)
{
   int      ii;

   for (ii = 0; ii < Nrecentfiles-1 && recentfiles[ii]; ii++)              //  find file in recent list
      if (strEqu(file,recentfiles[ii])) break;                             //    (or find last entry in list)
   if (recentfiles[ii]) zfree(recentfiles[ii]);                            //  free this slot in list
   for (; ii > 0; ii--) recentfiles[ii] = recentfiles[ii-1];               //  move list UP to fill hole
   recentfiles[0] = strdupz(file,0,"recent files");                        //  current file >> first in list
   return;
}


/**************************************************************************/

//  update information in main window title bar

void set_mwin_title()                                                      //  v.12.02
{
   int         cc, gtype, fposn, nfiles, nimages;
   char        *pp, titlebar[250];
   char        fname[100], gname[100], fdirk[100];

   if (! curr_file) return;                                                //  bugfix  v.12.06.2
   pp = (char *) strrchr(curr_file,'/');
   strncpy0(fname,pp+1,99);                                                //  file name
   cc = pp - curr_file;
   if (cc < 99) strncpy0(fdirk,curr_file,cc+2);                            //  get dirk/path/ if short enough
   else {
      strncpy(fdirk,curr_file,96);                                         //  or use /dirk/path...
      strcpy(fdirk+95,"...");
   }

   nfiles = navi::nfiles;                                                  //  total gallery files (incl. directories)
   nimages = navi::nimages;                                                //  total image files
   fposn = curr_file_posn;                                                 //  v.12.05
   fposn = fposn + 1 - nfiles + nimages;                                   //  position among images, 1-based

   gtype = navi::gallerytype;

   if (gtype == 1)                                                         //  gallery name = directory
      snprintf(titlebar,250,"%s  %d/%d  %s  %s",
                   fotoxxvers,fposn,nimages,fname,fdirk);
   else {
      if (gtype == 2 || gtype == 3)                                        //  v.13.01
         strcpy(gname,"Search Results");
      else if (gtype == 4) {
         pp = strrchr(navi::galleryname,'/');
         if (! pp) pp = navi::galleryname;
         else pp++;
         strcpy(gname,"Collection: ");
         strncpy0(gname+12,pp,87);
      }
      else if (gtype == 5)
         strcpy(gname,"Recent Files");
      else
         strcpy(gname,"No Gallery");

      snprintf(titlebar,250,"%s  %s  %d/%d  %s  %s",                       //  window title bar
             fotoxxvers,gname,fposn,nimages,fname,fdirk);
   }

   gtk_window_set_title(MWIN,titlebar);                                    //  zmainloop() removed (leaky)  v.12.07

   return;
}


/**************************************************************************
   Image file load and save functions
   PXM pixmap or PXB pixbuf <--> file on disk
***************************************************************************/

//  get the equivalent .tiff file name for a given RAW file
//  returned file name is subject to zfree()

char * raw_to_tiff(cchar *rawfile)                                         //  v.12.10
{
   char     *ptiff, *pext;

   ptiff = strdupz(rawfile,6,"rawtotiff");
   pext = strrchr(ptiff,'.');
   if (! pext) pext = ptiff + strlen(ptiff);
   strcpy(pext,".tiff");
   return ptiff;
}


/**************************************************************************/

//  Function to preload image files hopefully ahead of need.
//  Usage: f_preload(next)
//    next = -1 / +1  to read previous / next image file in curr. gallery
//    preload_file will be non-zero if and when preload_pxb is available.

char     *preload_tryfile;
char     *preload_file;
char     preload_type[8];
int      preload_bpc;
int      preload_size;
int      preload_Nth;
PXB      *preload_pxb;

void f_preload(int next)
{
   void * preload_thread(void *);

   int            Nth, ftype = 0, err;
   char           *file = 0, *tiffile = 0;
   int            nfiles = navi::nfiles;                                   //  gallery files (incl. directories)
   struct stat    statb;

   while (mutex_trylock(&preload_lock) != 0) zsleep(0.1);                  //  wait if preload busy         v.12.09
   mutex_unlock(&preload_lock);

   if (preload_pxb) PXB_free(preload_pxb);
   if (preload_file) zfree(preload_file);
   preload_pxb = 0;
   preload_file = 0;
   preload_tryfile = 0;

   if (! curr_file) return;

   if (next == 1) {
      for (Nth = curr_file_posn+1; Nth < nfiles; Nth++) {
         file = gallery_find(Nth);
         if (! file) continue;
         ftype = image_file_type(file);
         if (ftype == 2) break;
         if (ftype == 3) {
            tiffile = raw_to_tiff(file);                                   //  v.12.10
            if (strEqu(tiffile,curr_file)) {
               zfree(file);
               file = 0;
               zfree(tiffile);
               continue;
            }
            zfree(tiffile);
            break;
         }
         zfree(file);
         file = 0;
      }
   }
   
   if (next == -1) {
      for (Nth = curr_file_posn-1; Nth >= 0; Nth--) {
         file = gallery_find(Nth);
         if (! file) continue;
         ftype = image_file_type(file);
         if (ftype == 2) break;
         if (ftype == 3) {
            tiffile = raw_to_tiff(file);                                   //  v.12.10
            if (strEqu(tiffile,curr_file)) {
               zfree(file);
               file = 0;
               zfree(tiffile);
               continue;
            }
            zfree(tiffile);
            break;
         }
         zfree(file);
         file = 0;
      }
   }
   
   if (! file) return;
   err = stat(file,&statb);
   if (err) return;

   if (strEqu(file,curr_file)) {                                           //  v.12.10
      zfree(file);
      return;
   }
   
   mutex_lock(&preload_lock);                                              //  lock now, thread unlocks
   preload_tryfile = file;
   preload_Nth = Nth;
   start_detached_thread(preload_thread,0);
   return;
}

void * preload_thread(void *)
{
   int            err, ftype;
   char           *file, *tiffile;
   struct stat    statb;

   file = preload_tryfile;
   ftype = image_file_type(file);

   if (ftype == 2)
      preload_pxb = PXB_load(file,0);                                      //  image file
   
   else if (ftype == 3)                                                    //  RAW file
   {
      tiffile = raw_to_tiff(file);                                         //  filename.raw >> filename.tiff

      err = stat(tiffile,&statb);                                          //  see if .tiff already present
      if (err) {
         snprintf(command,ccc,"%s \"%s\" ",RAWcommand,file);               //  no, convert raw to .tiff
         err = system(command);
         err = stat(tiffile,&statb);
         if (err) {
            printf("preload: %s\n %s\n",wstrerror(err),file);              //  v.12.12
            zfree(file);
            zfree(tiffile);
            goto threadexit;
         }
      }

      preload_pxb = PXB_load(tiffile,0);                                   //  load PXB pixbuf from .tiff
      zfree(file);                                                         //  (no ACK dialog in thread)
      file = tiffile;                                                      //  v.12.10
   }

   if (preload_pxb) {
      preload_file = file;                                                 //  file is now available
      strcpy(preload_type,f_load_type);                                    //  v.12.09
      preload_bpc = f_load_bpc;
      preload_size = f_load_size;
   }
   else zfree(file);

threadexit:
   mutex_unlock(&preload_lock);
   pthread_exit(0);
}


/**************************************************************************/

//  Open a file and initialize Fpxb pixbuf.
//  If flock and menu is locked, do nothing and return.
//  Otherwise open the file and display in main window.
//  If Nth matches the file position in current gallery, curr_file_posn 
//    will be set to Nth, otherwise it is searched and set correctly
//    (a file can be present multiple times in a collection gallery).
//  If Fkeep is true, the edit undo stack is not purged, and current 
//    edits are kept after opening the new file (used by m_saveas()).
//  If Fack is true, failure will cause a popup ACK dialog.
//  Following are set: curr_file_type, curr_file_bpc, curr_file_size.
//  Returns: 0 = OK, +N = error.
//  errors: 1  menu locked
//          2  unsaved edits, mod_keep() true
//          3  user canceled open dialog
//          4  RAW conversion failure
//          5  unsupported file type or open failure

int f_open(cchar *filespec, int flock, int Nth, int Fkeep, int Fack)       //  v.12.10
{
   PXB            *tempxb = 0;
   int            err, fposn, ftype, gtype, Fnewgallery = 0;
   char           *pp, *file;
   struct stat    statb;

   if (flock && checkmenulock()) return 1;                                 //  menu locked
   if (! Fkeep && mod_keep()) return 2;                                    //  unsaved edits                   v.12.10
   
   gtype = navi::gallerytype;

   if (filespec)  
      file = strdupz(filespec,0,"f_open");                                 //  use passed filespec
   else {
      pp = curr_file;                                                      //  use file open dialog
      if (! pp) pp = curr_dirk;
      file = zgetfile1(ZTX("Open Image File"),"open",pp);
      if (! file) return 3;
      if (gtype > 1) Fnewgallery = 1;                                      //  discard special gallery
   }

   err = stat(file,&statb);                                                //  check file exists               v.12.09
   if (err) {
      if (Fack) zmessageACK(mWin,ZTX("file not found"));
      zfree(file);
      return 5;
   }

   ftype = image_file_type(file);                                          //  must be image or RAW file type
   if (ftype == 4) {
      if (Fack) zmessageACK(mWin,"thumbnail file");
      return 5;
   }

   if (ftype != 2 && ftype != 3) {
      if (Fack) zmessageACK(mWin,ZTX("unknown file type"));
      zfree(file);
      return 5;
   }
   
   if (ftype == 3) {
      rawfile = file;
      file = raw_to_tiff(rawfile);                                         //  filename.raw >> filename.tiff
   }

   while (mutex_trylock(&preload_lock) != 0) zsleep(0.05);                 //  wait if preload busy            v.12.09
   mutex_unlock(&preload_lock);

   if (preload_file && strEqu(file,preload_file)) {                        //  use preload file if there       v.12.10
      tempxb = preload_pxb;
      zfree(preload_file);
      preload_file = 0;
      preload_pxb = 0;
      strcpy(f_load_type,preload_type);                                    //  file poop from preloader
      f_load_bpc = preload_bpc;
      f_load_size = preload_size;
   }

   else if (ftype == 2)                                                    //  supported image file type
      tempxb = PXB_load(file,1);                                           //  load image as PXB pixbuf

   else if (ftype == 3) {                                                  //  RAW file type                   v.12.09
      err = stat(file,&statb);                                             //  see if .tiff already present
      if (err) {
         snprintf(command,ccc,"%s \"%s\" ",RAWcommand,rawfile);            //  no, convert raw to .tiff
         err = system(command);
         if (err) {
            if (Fack) zmessageACK(mWin,wstrerror(err));                    //  failed, clean up
            zfree(file);
            zfree(rawfile);
            rawfile = 0;
            return 4;
         }
      }

      tempxb = PXB_load(file,1);                                           //  load PXB pixbuf from .tiff
      zfree(rawfile);
      rawfile = 0;
   }

   if (! tempxb) {                                                         //  PXB_load() messages user        v.12.09
      zfree(file);
      return 5;
   }

   settab("F");                                                            //  switch to tab F now             v.12.09

   free_resources(Fkeep);                                                  //  free resources for old image file

   if (curr_file) zfree(curr_file);                                        //  set new current image filespec
   curr_file = file;

   if (curr_dirk) zfree(curr_dirk);                                        //  set current directory
   curr_dirk = strdupz(curr_file,0,"f_open");                              //    for new current file
   pp = strrchr(curr_dirk,'/');
   *pp = 0;
   err = chdir(curr_dirk);
   
   Fpxb = tempxb;                                                          //  pixmap for current image
  
   strcpy(curr_file_type,f_load_type);                                     //  set curr_file_xxx from f_load_xxx
   curr_file_bpc = f_load_bpc;
   curr_file_size = f_load_size;
   
   if (gtype == 0 || gtype == 5) Fnewgallery = 1;                          //  no gallery, or recent files     v.13.01

   if (! Fnewgallery) {
      fposn = gallery_position(file,Nth);                                  //  file position in gallery list
      if (fposn < 0) Fnewgallery = 1;                                      //  not there, need new gallery
   }

   if (Fnewgallery) {
      gallery(curr_file,"init");                                           //  generate new gallery list
      fposn = gallery_position(curr_file,0);                               //  position and count in gallery list
   }

   curr_file_posn = fposn;                                                 //  keep track of file position

   Fzoom = 0;                                                              //  zoom level = fit window
   zoomx = zoomy = 0;                                                      //  no zoom center
   set_mwin_title();                                                       //  set win title from curr_file info 
   gtk_window_present(MWIN);                                               //  stop sometimes blank window     v.13.01
   
   add_recent_file(curr_file);                                             //  v.12.09
   
   if (Fautotrim) {
      if (zdrename) Fautotrim = 0;                                         //  stop autotrim if other dialog active
      if (zdcopymove) Fautotrim = 0;
      if (zddelete) Fautotrim = 0;
      if (zdtrash) Fautotrim = 0;
      if (zdexifview) Fautotrim = 0;
      if (zdexifedit) Fautotrim = 0;
      if (zdeditmeta) Fautotrim = 0;
      if (zdaddgeotags) Fautotrim = 0;
      if (zdeditcctext) Fautotrim = 0;
      if (Fautotrim) m_trim(0,0);                                          //  else do the autotrim            v.12.06
   }

   if (zdrename) m_rename(0,0);                                            //  update active rename dialog
   if (zdcopymove) copy_move(0);                                           //    "  copy/move dialog
   if (zddelete) m_delete(0,0);                                            //    "  delete dialog
   if (zdtrash) m_trash(0,0);                                              //    "  trash dialog
   if (zdexifview) meta_view(0);                                           //    "  EXIF/IPTC view window
   if (zdexifedit) m_meta_edit_any(0,0);                                   //    "  EXIF/IPTC edit window 
   if (zdeditmeta) m_edit_metadata(0,0);                                   //    "  edit date/rating/tags dialog
   if (zdaddgeotags) m_edit_geotags(0,0);                                  //    "  edit geotags dialog        v.12.05
   if (zdeditcctext) m_edit_cctext(0,0);                                   //    "  edit comments dialog 
   
   return 0;
}


//  open a RAW file with ufraw
//  returns 0 if OK, +N if error
//  function type is compatible with popup menus but args are not used
//  opens click_file if present or rawfile if not

void f_open_ufraw(GtkWidget *, cchar *)                                    //  v.12.10
{
   cchar *ufrawcommand = "ufraw --exposure=auto --interpolation=bilinear"
                         " --out-type=tiff --out-depth=16 --overwrite"
                         " --output=\"%s\" \"%s\"";
   char        *tiffile;
   int         err;
   struct stat statb;

   if (checkmenulock()) return;
   if (mod_keep()) return;
   
   if (click_file) {
      rawfile = click_file;
      click_file = 0;
   }

   if (! rawfile) return;

   zfuncs::F1_help_topic = "open_raw_ufraw";
   
   tiffile = raw_to_tiff(rawfile);

   snprintf(command,ccc,ufrawcommand,tiffile,rawfile);                     //  ufraw command, convert to tiff
   err = system(command);
   zfree(rawfile);
   rawfile = 0;

   if (err) {
      zmessLogACK(mWin,ZTX("error: %s"),wstrerror(err));
      zfree(tiffile);
      return;
   }
   
   err = stat(tiffile,&statb);
   if (err) {
      zfree(tiffile);
      return;
   }
   
   f_open(tiffile,0);                                                      //  open tiff file if present
   zfree(tiffile);
   return;
}


/**************************************************************************/

//  save current image to specified disk file (same or new).
//  set f_save_type, f_save_bpc, f_save_size
//  update search index file
//  return 0 if OK, else +N
//  If Fack is true, failure will cause a popup ACK dialog.

int f_save(char *outfile, cchar *type, int bpc, int Fack)                  //  use tiff/png/pixbuf libraries
{
   cchar          *exifkey[2] = { exif_orientation_key, exif_editlog_key };
   cchar          *exifdata[2];
   char           **ppv, *pp, *tempfile, *pext, *thumbfile;
   int            nkeys, err = 1, cc1, cc2, newfile = 0;
   struct stat    fstat;

   if (! curr_file) return 0;

   Ffuncbusy++;                                                            //  big file + slow CPU can take time

   outfile = strdupz(outfile,6,"f_save");

   pext = strrchr(outfile,'/');                                            //  force compatible file extension
   if (pext) pext = strrchr(pext,'.');                                     //    if not already
   if (! pext) pext = outfile + strlen(outfile);

   if (strEqu(type,"jpg") && ! strcasestr(".jpg .jpeg",pext))
      strcpy(pext,".jpg");
   if (strEqu(type,"tif") && ! strcasestr(".tif .tiff",pext))
      strcpy(pext,".tif");
   if (strEqu(type,"png") && ! strcasestr(".png",pext))
      strcpy(pext,".png");
   if (strEqu(type,"ico") && ! strcasestr(".ico",pext))
      strcpy(pext,".ico");
   if (strEqu(type,"bmp") && ! strcasestr(".bmp",pext))
      strcpy(pext,".bmp");

   if (! E0pxm) {                                                          //  no edits were made     v.12.10
      E0pxm = PXM_load(curr_file,1);                                       //  reload file to get full color depth
      if (! E0pxm) { Ffuncbusy--; return 1; }                              //  PXM_load() messages user
   }

   tempfile = strdupz(get_zuserdir(),24,"f_save");                         //  use temp output file
   strcat(tempfile,"/temp_");                                              //    ~/.fotoxx/temp_ppppp.ext
   strcat(tempfile,PIDstring);
   strcat(tempfile,".");
   strcat(tempfile,type);

   if (strEqu(type,"tif"))                                                 //  save as tif file (bpc = 8 or 16)
      err = PXM_TIFF_save(E0pxm,tempfile,bpc);

   else if (strEqu(type,"png"))                                            //  save as png file (bpc = 8 or 16)
      err = PXM_PNG_save(E0pxm,tempfile,bpc);                              //  v.12.09

   else {                                                                  //  save as .ico .bmp .jpg 
      err = PXM_ANY_save(E0pxm,tempfile);                                  //  (bpc = 8 always)
      bpc = 8;
   }

   if (err) {
      if (*file_errmess)                                                   //  pass error to user           v.12.12
         if (Fack) zmessageACK(mWin,file_errmess);
      remove(tempfile);                                                    //  failure, clean up
      zfree(tempfile);
      zfree(outfile);
      Ffuncbusy--;
      return 1;
   }

   if (exif_editlog_cc < 0) {                                              //  get edits made in prior sessions   v.12.12
      ppv = exif_get(curr_file,&exifkey[1],1);                             //  (curr. session edits are ignored)
      if (ppv[0]) {
         strncpy0(exif_editlog,ppv[0],exif_maxcc-2);
         zfree(ppv[0]);
         exif_editlog_cc = strlen(exif_editlog);                           //  edits made before this file was opened
      }
      else exif_editlog_cc = 0;                                            //  none
   }

   if (Pundo > 0)                                                          //  edits were made - update edit hist log
   {
      Fsaved = Pundo;                                                      //  mark last edit saved to disk
      
      cc1 = exif_editlog_cc;                                               //  add a blank if prior text found
      if (cc1 && cc1 < exif_maxcc-1) {
         strcpy(exif_editlog+cc1," ");
         cc1++;
      }

      if (cc1 < exif_maxcc-8) {                                            //  start these edits with "Fotoxx:"
         strcpy(exif_editlog+cc1,"Fotoxx:");
         cc1 += 7;
      }

      for (int ii = 1; ii <= Pundo; ii++)                                  //  append new list of edits
      {                                                                    //  (omit index 0 = initial image)
         pp = pvlist_get(editlog,ii);
         cc2 = strlen(pp);
         if (cc1 + cc2 >= exif_maxcc-2) break;                             //  "Fotoxx:edit1|edit2|...editN|"     v.12.11
         strcpy(exif_editlog+cc1,pp);
         strcpy(exif_editlog+cc1+cc2,"|");
         cc1 += cc2 + 1;
      }
   }
   
   exifdata[0] = "";                                                       //  remove EXIF orientation if present
   nkeys = 1;                                                              //  (assume saved file is upright)

   if (exif_editlog_cc || Pundo) {                                         //  prior and/or curr. edits exist     v.12.12
      exifdata[1] = exif_editlog;                                          //  EXIF edit history, fotoxx edits made
      nkeys = 2;
   }

   err = exif_copy(curr_file,tempfile,exifkey,exifdata,nkeys);             //  copy all EXIF/IPTC data to
   if (err && Fack)                                                        //    temp file with above revisions
      zmessageACK(mWin,ZTX("Unable to copy EXIF/IPTC data"));
   
   snprintf(command,ccc,"cp -f \"%s\" \"%s\" ",tempfile,outfile);          //  copy temp file to output file
   err = system(command);

   remove(tempfile);                                                       //  delete temp file
   zfree(tempfile);

   if (err) {                                                              //  v.13.01
      if (Fack) zmessageACK(mWin,"Unable to save image: %s",wstrerror(err));
      return 2;
   }

   if (strNeq(curr_file,outfile))                                          //  output file not same as input
      newfile = 1;

   if (newfile) {                                                          //  v.12.09
      load_filemeta(outfile);
      update_search_index(outfile);
      thumbfile = image_thumbfile(outfile);                                //  make thumbnail file
      if (thumbfile) zfree(thumbfile);
   }
   
   if (newfile && samedirk(outfile,curr_file)) {                           //  if output new file to same directory
      gallery(curr_file,"init",-1);                                        //  update curr. gallery list       v.12.09
      set_mwin_title();                                                    //  update window title posn, count
   }

   add_recent_file(outfile);                                               //  first in recent files list

   if (f_save_file) zfree(f_save_file);                                    //  actual file saved (.ext may change)
   f_save_file = outfile;                                                  //                            v.12.11
   strcpy(f_save_type,type);                                               //  update f_save_xxx data
   f_save_bpc = bpc;
   err = stat(outfile,&fstat);
   f_save_size = fstat.st_size;

   Ffuncbusy--;
   mwpaint2();

   if (zdrename) m_rename(0,0);                                            //  update active rename dialog     v.12.12
   if (zdcopymove) copy_move(0);                                           //    "  copy/move dialog
   if (zddelete) m_delete(0,0);                                            //    "  delete dialog
   if (zdtrash) m_trash(0,0);                                              //    "  trash dialog
   if (zdexifview) meta_view(0);                                           //    "  EXIF/IPTC view window
   if (zdexifedit) m_meta_edit_any(0,0);                                   //    "  EXIF/IPTC edit window 
   if (zdeditmeta) m_edit_metadata(0,0);                                   //    "  edit date/rating/tags dialog
   if (zdaddgeotags) m_edit_geotags(0,0);                                  //    "  edit geotags dialog
   if (zdeditcctext) m_edit_cctext(0,0);                                   //    "  edit comments dialog 

   return 0;
}


/**************************************************************************/

//  Load an image file into a PXB pixmap
//  Also sets the following file scope variables:
//    f_load_type = "jpg" "tif" "png" "bmp" "ico" "other"
//    f_load_bpc = disk file bits per color = 1/8/16
//    f_load_size = disk file size
//  If Fack is true, failure will cause a popup ACK dialog
//  Do not call from a thread with Fack true.

PXB * PXB_load(cchar *file, int Fack)                                      //  v.12.10
{
   int            err;
   cchar          *pext;
   PXB            *pxb;
   struct stat    fstat;
   
   err = stat(file,&fstat);
   if (err) {
      if (Fack) zmessageACK(mWin,ZTX("file not found: %s"),file);
      goto f_load_fail;
   }

   if (image_file_type(file) != 2) {
      if (Fack) zmessageACK(mWin,ZTX("file type not supported: %s"),file);
      goto f_load_fail;
   }

   f_load_size = fstat.st_size;                                            //  set f_load_size

   pext = strrchr(file,'/');
   if (! pext) pext = file;
   pext = strrchr(pext,'.');
   if (! pext) pext = "";
   
   if (strcasestr(".jpg .jpeg",pext)) strcpy(f_load_type,"jpg");           //  set f_load_type
   else if (strcasestr(".tif .tiff",pext)) strcpy(f_load_type,"tif");
   else if (strcasestr(".png",pext)) strcpy(f_load_type,"png");
   else if (strcasestr(".bmp",pext)) strcpy(f_load_type,"bmp");
   else if (strcasestr(".ico",pext)) strcpy(f_load_type,"ico");
   else strcpy(f_load_type,"other");
   
   if (strEqu(f_load_type,"tif"))                                          //  use loader for file type
      pxb = TIFF_PXB_load(file);                                           //  f_load_bpc = file bpc

   else if (strEqu(f_load_type,"png")) 
      pxb = PNG_PXB_load(file);

   else pxb = ANY_PXB_load(file);

   if (pxb) return pxb;

   if (Fack && *file_errmess)                                              //  pass error to user     v.12.12
      zmessageACK(mWin,file_errmess);

f_load_fail:
   *f_load_type = f_load_size = f_load_bpc = 0;
   return 0;
}


/**************************************************************************/

//  Load an image file into a PXM pixmap
//  Also sets the following file scope variables:
//    f_load_type = "jpg" "tif" "png" "bmp" "ico" "other"
//    f_load_bpc = disk file bits per color = 1/8/16
//    f_load_size = disk file size
//  If Fack is true, failure will cause a popup ACK dialog
//  Do not call from a thread with Fack true.

PXM * PXM_load(cchar *file, int Fack)                                      //  v.12.10
{
   int            err;
   cchar          *pext;
   PXM            *pxm;
   struct stat    fstat;
   
   err = stat(file,&fstat);
   if (err) {
      if (Fack) zmessageACK(mWin,ZTX("file not found: %s"),file);
      goto f_load_fail;
   }

   if (image_file_type(file) != 2) {
      if (Fack) zmessageACK(mWin,ZTX("file type not supported: %s"),file);
      goto f_load_fail;
   }

   f_load_size = fstat.st_size;                                            //  set f_load_size
   
   pext = strrchr(file,'/');
   if (! pext) pext = file;
   pext = strrchr(pext,'.');
   if (! pext) pext = "";
   
   if (strcasestr(".jpg .jpeg",pext)) strcpy(f_load_type,"jpg");           //  set f_load_type
   else if (strcasestr(".tif .tiff",pext)) strcpy(f_load_type,"tif");
   else if (strcasestr(".png",pext)) strcpy(f_load_type,"png");
   else if (strcasestr(".bmp",pext)) strcpy(f_load_type,"bmp");
   else if (strcasestr(".ico",pext)) strcpy(f_load_type,"ico");
   else strcpy(f_load_type,"other");
   
   if (strEqu(f_load_type,"tif"))                                          //  use loader for file type
      pxm = TIFF_PXM_load(file);                                           //  f_load_bpc = file bpc

   else if (strEqu(f_load_type,"png"))  
      pxm = PNG_PXM_load(file); 

   else pxm = ANY_PXM_load(file);
   
   if (pxm) return pxm;

   if (Fack && *file_errmess)                                              //  pass error to user     v.12.12
      zmessageACK(mWin,file_errmess);

f_load_fail:
   *f_load_type = f_load_size = f_load_bpc = 0;
   return 0;
}


/**************************************************************************
   TIFF file read and write functions
***************************************************************************/

//  Intercept TIFF warning messages (many)

void tiffwarninghandler(cchar *module, cchar *format, va_list ap)
{
   return;                                                                 //  stop flood of crap
   char  message[200];
   vsnprintf(message,199,format,ap);
   printf("TIFF warning: %s %s \n",module,message);
   return;
}


//  Load PXB from TIFF file using TIFF library. 
//  Native TIFF file bits/pixel >> f_load_bpc

PXB * TIFF_PXB_load(cchar *file)                                           //  v.12.10
{
   static int  ftf = 1;
   TIFF        *tiff;
   PXB         *pxb;
   char        *tiffbuff;
   uint8       *tiff8;
   uint16      *tiff16;
   uint8       *pix;
   uint16      bpc, nch, fmt; 
   int         ww, hh, rps, stb, nst;                                      //  int not uint
   int         tiffstat, row, col, strip;
   int         row1, row2, cc;
   
   if (ftf) {
      TIFFSetWarningHandler(tiffwarninghandler);                           //  intercept TIFF warning messages
      ftf = 0;
   }
   
   *file_errmess = 0;                                                      //  v.12.12

   tiff = TIFFOpen(file,"r");
   if (! tiff) {
      snprintf(file_errmess,999,"TIFF file read error: %s",file);          //  v.12.12
      printf("%s\n",file_errmess);
      return 0;
   }

   TIFFGetField(tiff, TIFFTAG_IMAGEWIDTH, &ww);                            //  width
   TIFFGetField(tiff, TIFFTAG_IMAGELENGTH, &hh);                           //  height
   TIFFGetField(tiff, TIFFTAG_BITSPERSAMPLE, &bpc);                        //  bits per color, 1/8/16
   TIFFGetField(tiff, TIFFTAG_SAMPLESPERPIXEL, &nch);                      //  no. channels (colors), 1/3/4
   TIFFGetField(tiff, TIFFTAG_ROWSPERSTRIP, &rps);                         //  rows per strip
   TIFFGetField(tiff, TIFFTAG_SAMPLEFORMAT, &fmt);                         //  data format
   stb = TIFFStripSize(tiff);                                              //  strip size
   nst = TIFFNumberOfStrips(tiff);                                         //  number of strips
   
   if (ww > wwhh_limit || hh > wwhh_limit) {
      snprintf(file_errmess,999,"image too big, %dx%d: %s",ww,hh,file);    //  v.12.12
      printf("%s\n",file_errmess);
      TIFFClose(tiff);
      return 0;
   }

   if (bpc > 8 && bpc != 16) {                                             //  check for supported bits/color
      printf("TIFF bits=%d not supported: %s \n",bpc,file);
      TIFFClose(tiff);
      return ANY_PXB_load(file);                                           //  fallback to pixbuf loader
   }
   
   f_load_bpc = bpc;                                                       //  file bpc 1/8/16

   if (bpc <= 8)                                                           //  use universal TIFF reader
   {                                                                       //    if bits/color <= 8
      tiffbuff = zmalloc(ww*hh*4,"tiffbuff");
      tiffstat = TIFFReadRGBAImage(tiff, ww, hh, (uint *) tiffbuff, 0);
      TIFFClose(tiff);

      if (tiffstat != 1) {
         snprintf(file_errmess,999,"TIFF file read error: %s",file);       //  v.12.12
         printf("%s\n",file_errmess);
         zfree(tiffbuff);
         return 0;
      }

      pxb = PXB_make(ww,hh);                                               //  create PXB

      tiff8 = (uint8 *) tiffbuff;

      for (row = 0; row < hh; row++)                                       //  convert RGBA to RGB
      {
         pix = pxb->pixels + (hh-1 - row) * pxb->rs;

         for (col = 0; col < ww; col++)
         {
            pix[0] = tiff8[0];                                             //  0 - 255  >> 0 - 255
            pix[1] = tiff8[1];
            pix[2] = tiff8[2];
            pix += 3;
            tiff8 += 4;
         }
      }

      zfree(tiffbuff);
      return pxb;
   }

   pxb = PXB_make(ww,hh);                                                  //  TIFF file has 16 bits/color
   
   stb += 1000000;                                                         //  reduce risk of crash
   tiffbuff = zmalloc(stb,"tiffbuff");                                     //  read encoded strips 

   for (strip = 0; strip < nst; strip++)
   {
      cc = TIFFReadEncodedStrip(tiff,strip,tiffbuff,stb);
      if (cc < 0) {
         snprintf(file_errmess,999,"TIFF file read error: %s",file);       //  v.12.12
         printf("%s\n",file_errmess);
         TIFFClose(tiff);
         zfree(tiffbuff);
         PXB_free(pxb);
         return 0;
      }
      
      if (cc == 0) break;
      
      tiff16 = (uint16 *) tiffbuff;

      row1 = strip * rps;                                                  //  rows in strip
      row2 = row1 + cc / (ww * nch * 2);
      if (row2 > hh) row2 = hh;                                            //  rps unreliable if nst = 1
      
      for (row = row1; row < row2; row++)
      {
         pix = pxb->pixels + row * pxb->rs;

         for (col = 0; col < ww; col++)
         {
            pix[0] = tiff16[0] / 256;                                      //  0 - 65535  >>  0 - 255
            pix[1] = tiff16[1] / 256;
            pix[2] = tiff16[2] / 256;
            pix += 3;
            tiff16 += nch;
         }
      }
   }

   TIFFClose(tiff);
   zfree(tiffbuff);
   return pxb;
}


//  Load PXM from TIFF file using TIFF library. 
//  Native TIFF file bits/pixel >> f_load_bpc

PXM * TIFF_PXM_load(cchar *file)                                           //  v.12.10
{
   static int  ftf = 1;
   TIFF        *tiff;
   PXM         *pxm;
   char        *tiffbuff;
   uint8       *tiff8;
   uint16      *tiff16;
   float       *pix;
   uint16      bpc, nch, fmt; 
   int         ww, hh, rps, stb, nst;                                      //  int not uint
   int         tiffstat, row, col, strip, cc;

   if (ftf) {
      TIFFSetWarningHandler(tiffwarninghandler);                           //  intercept TIFF warning messages
      ftf = 0;
   }

   *file_errmess = 0;                                                      //  v.12.12

   tiff = TIFFOpen(file,"r");
   if (! tiff) {
      snprintf(file_errmess,999,"TIFF file read error: %s",file);          //  v.12.12
      printf("%s\n",file_errmess);
      return 0;
   }

   TIFFGetField(tiff, TIFFTAG_IMAGEWIDTH, &ww);                            //  width
   TIFFGetField(tiff, TIFFTAG_IMAGELENGTH, &hh);                           //  height
   TIFFGetField(tiff, TIFFTAG_BITSPERSAMPLE, &bpc);                        //  bits per color, 1/8/16
   TIFFGetField(tiff, TIFFTAG_SAMPLESPERPIXEL, &nch);                      //  no. channels (colors), 1/3/4
   TIFFGetField(tiff, TIFFTAG_ROWSPERSTRIP, &rps);                         //  rows per strip
   TIFFGetField(tiff, TIFFTAG_SAMPLEFORMAT, &fmt);                         //  data format
   stb = TIFFStripSize(tiff);                                              //  strip size
   nst = TIFFNumberOfStrips(tiff);                                         //  number of strips

   if (ww > wwhh_limit || hh > wwhh_limit) {
      snprintf(file_errmess,999,"image too big, %dx%d: %s",ww,hh,file);    //  v.12.12
      printf("%s\n",file_errmess);
      TIFFClose(tiff);
      return 0;
   }

   if (bpc > 8 && bpc != 16) {                                             //  check for supported bits/color
      printf("TIFF bits=%d not supported: %s \n",bpc,file);
      TIFFClose(tiff);
      return ANY_PXM_load(file);                                           //  fallback to pixbuf loader
   }

   f_load_bpc = bpc;                                                       //  file bpc 1/8/16

   if (bpc <= 8)                                                           //  use universal TIFF reader
   {                                                                       //    if bits/color <= 8
      tiffbuff = zmalloc(ww*hh*4,"tiffbuff");
      tiffstat = TIFFReadRGBAImage(tiff, ww, hh, (uint *) tiffbuff, 0);
      TIFFClose(tiff);

      if (tiffstat != 1) {
         snprintf(file_errmess,999,"TIFF file read error: %s",file);       //  v.12.12
         printf("%s\n",file_errmess);
         zfree(tiffbuff);
         return 0;
      }

      pxm = PXM_make(ww,hh);                                               //  create PXM

      tiff8 = (uint8 *) tiffbuff;

      for (row = 0; row < hh; row++)                                       //  convert RGBA to RGB
      {
         pix = pxm->pixels + (hh-1 - row) * ww * 3;

         for (col = 0; col < ww; col++)
         {
            pix[0] = tiff8[0];                                             //  0 - 255  >>  0.0 - 255.0 
            pix[1] = tiff8[1];
            pix[2] = tiff8[2];
            pix += 3;
            tiff8 += 4;
         }
      }

      zfree(tiffbuff);
      return pxm;
   }

   pxm = PXM_make(ww,hh);                                                  //  TIFF file has 16 bits/color
   
   stb += 1000000;                                                         //  reduce risk of crash
   tiffbuff = zmalloc(stb,"tiffbuff");                                     //  read encoded strips 

   for (strip = 0; strip < nst; strip++)
   {
      cc = TIFFReadEncodedStrip(tiff,strip,tiffbuff,stb);
      if (cc < 0) {
         snprintf(file_errmess,999,"TIFF file read error: %s",file);       //  v.12.12
         printf("%s\n",file_errmess);
         TIFFClose(tiff);
         zfree(tiffbuff);
         PXM_free(pxm);
         return 0;
      }
      
      if (cc == 0) break;
      
      tiff16 = (uint16 *) tiffbuff;
      row = strip * rps;
      pix = pxm->pixels + row * ww * 3;

      while (cc >= 6)
      {
         pix[0] = tiff16[0] / 256.0;                                       //  0 - 65535  >>  0.0 - 255.996
         pix[1] = tiff16[1] / 256.0;                                       //  v.12.03
         pix[2] = tiff16[2] / 256.0;
         pix += 3;
         tiff16 += nch;
         cc -= nch * 2;
      }
   }

   TIFFClose(tiff);
   zfree(tiffbuff);
   return pxm;
}


//  Write PXM to TIFF file using TIFF library. 
//  TIFF file bpc is 8 or 16.
//  Returns 0 if OK, +N if error.

int PXM_TIFF_save(PXM *pxm, cchar *file, int bpc)                          //  v.12.10
{
   static int  ftf = 1;
   TIFF        *tiff;
   uint8       *tiff8;
   uint16      *tiff16;
   float       *pix;
   int         tiffstat = 0;
   int         ww, hh, row, col, rowcc;                                    //  int not uint
   int         nch, pm = 2, pc = 1, comp = 5; 
   char        *tiffbuff;
   
   if (ftf) {
      TIFFSetWarningHandler(tiffwarninghandler);                           //  intercept TIFF warning messages
      ftf = 0;
   }

   *file_errmess = 0;                                                      //  v.12.12

   tiff = TIFFOpen(file,"w");
   if (! tiff) {
      snprintf(file_errmess,999,"TIFF file write error: %s",file);         //  v.12.12
      printf("%s\n",file_errmess);
      return 0;
   }
   
   ww = pxm->ww;
   hh = pxm->hh;
   nch = 3;                                                                //  alpha channel removed

   TIFFSetField(tiff, TIFFTAG_IMAGEWIDTH, ww);
   TIFFSetField(tiff, TIFFTAG_BITSPERSAMPLE, bpc);
   TIFFSetField(tiff, TIFFTAG_SAMPLESPERPIXEL, nch);
   TIFFSetField(tiff, TIFFTAG_PHOTOMETRIC, pm);                            //  RGB
   TIFFSetField(tiff, TIFFTAG_PLANARCONFIG, pc);
   TIFFSetField(tiff, TIFFTAG_COMPRESSION, comp);                          //  LZW

   rowcc = TIFFScanlineSize(tiff);
   tiffbuff = (char*) zmalloc(rowcc,"tiffbuff");

   for (row = 0; row < hh; row++)
   {
      if (bpc == 8)                                                        //  write 8-bit TIFF
      {
         tiff8 = (uint8 *) tiffbuff;
         pix = pxm->pixels + row * ww * 3;

         for (col = 0; col < ww; col++)
         {
            tiff8[0] = pix[0];                                             //  0.0 - 255.996  >>  0 - 255
            tiff8[1] = pix[1];
            tiff8[2] = pix[2];
            pix += 3;
            tiff8 += nch;
         }
      }

      if (bpc == 16)                                                       //  write 16-bit TIFF
      {
         tiff16 = (uint16 *) tiffbuff;
         pix = pxm->pixels + row * ww * 3;

         for (col = 0; col < ww; col++)
         {
            tiff16[0] = 256.0 * pix[0];                                    //  0.0 - 255.996  >>  0.0 >> 65535
            tiff16[1] = 256.0 * pix[1];
            tiff16[2] = 256.0 * pix[2];
            pix += 3;
            tiff16 += nch;
         }
      }

      tiffstat = TIFFWriteScanline(tiff,tiffbuff,row,0);
      if (tiffstat != 1) break;
   }

   TIFFClose(tiff);
   zfree(tiffbuff);
   
   if (tiffstat == 1) return 0;
   snprintf(file_errmess,999,"TIFF file write error: %s",file);            //  v.12.12
   printf("%s\n",file_errmess);
   return 2;
}


/**************************************************************************
   PNG file read and write functions
***************************************************************************/

//  Load PXB from PNG file using PNG library. 
//  Native PNG file bits/pixel >> f_load_bpc

PXB * PNG_PXB_load(cchar *file)                                            //  v.12.10
{
   png_structp    pngstruct = 0;
   png_infop      pnginfo = 0;
   FILE           *fid;
   int            ww, hh, bpc, nch, colortype;
   uchar          **pngrows;
   uint8          *png8;
   uint16         *png16;
   PXB            *pxb;
   uint8          *pix;
   int            row, col, bit, ii, rgbval;
   static int     ftf = 1;
   static int     mask[9] = { 0, 0x80, 0xc0, 0xe0, 0xf0, 0xf8, 0xfc, 0xfe, 0xff };
   static float   scale[9];
   
   if (ftf) {
      ftf = 0;
      for (ii = 1; ii < 9; ii++)                                           //  used for < 8 bits per color
         scale[ii] = 255.0 / mask[ii];
   }

   *file_errmess = 0;                                                      //  v.12.12

   fid = fopen(file,"r");                                                  //  open file
   if (! fid) goto erret;

   pngstruct = png_create_read_struct(PNG_LIBPNG_VER_STRING,0,0,0);        //  create png structs
   if (! pngstruct) goto erret;
   pnginfo = png_create_info_struct(pngstruct);
   if (! pnginfo) goto erret;
   if (setjmp(png_jmpbuf(pngstruct))) goto erret;                          //  setup error handling

   png_init_io(pngstruct,fid);                                             //  read png file
   png_read_png(pngstruct,pnginfo,0,0);
   fclose(fid);

   ww = png_get_image_width(pngstruct,pnginfo);                            //  width
   hh = png_get_image_height(pngstruct,pnginfo);                           //  height
   bpc = png_get_bit_depth(pngstruct,pnginfo);                             //  bits per color (channel)
   nch = png_get_channels(pngstruct,pnginfo);                              //  no. channels
   colortype = png_get_color_type(pngstruct,pnginfo);                      //  color type
   pngrows = png_get_rows(pngstruct,pnginfo);                              //  array of png row pointers

   if (ww > wwhh_limit || hh > wwhh_limit) {
      png_destroy_read_struct(&pngstruct,&pnginfo,0);
      snprintf(file_errmess,999,"image too big, %dx%d: %s",ww,hh,file);    //  v.12.12
      printf("%s\n",file_errmess);
      return 0;
   }

   if (bpc > 8 && bpc != 16) {
      png_destroy_read_struct(&pngstruct,&pnginfo,0);
      printf("PNG bpc %d not supported: %s \n",bpc,file);
      return ANY_PXB_load(file);                                           //  fallback to pixbuf loader
   }
   
   if (colortype != PNG_COLOR_TYPE_GRAY && colortype != PNG_COLOR_TYPE_RGB) {
      png_destroy_read_struct(&pngstruct,&pnginfo,0);
      printf("PNG file not RGB or gray scale: %s \n",file);
      return ANY_PXB_load(file);                                           //  fallback to pixbuf loader
   }

   pxb = PXB_make(ww,hh);                                                  //  create PXB

   if (bpc == 8)                                                           //  8 bits/channel
   {
      for (row = 0; row < hh; row++)
      {
         png8 = (uint8 *) pngrows[row];
         pix = pxb->pixels + row * pxb->rs;
         
         for (col = 0; col < ww; col++)
         {
            if (nch < 3) {                                                 //  gray or gray + alpha
               pix[0] = pix[1] = pix[2] = *png8;
            }
            else {                                                         //  RGB or RGB + alpha
               pix[0] = png8[0];
               pix[1] = png8[1];
               pix[2] = png8[2];
            }
            pix += 3;
            png8 += nch;
         }
      }
   }

   else if (bpc < 8)                                                       //  1, 2, 4  bits/channel
   {
      for (row = 0; row < hh; row++)
      {
         png8 = (uint8 *) pngrows[row];
         pix = pxb->pixels + row * pxb->rs;
         bit = 0;
         
         for (col = 0; col < ww; col++)
         {
            if (nch < 3) {                                                 //  gray or gray + alpha
               rgbval = *png8 << bit;
               rgbval = (rgbval & mask[bpc]) * scale[bpc];
               pix[0] = pix[1] = pix[2] = rgbval;
               for (ii = 0; ii < nch; ii++)
               {
                  bit += bpc;
                  if (bit > 7) {
                     bit = bit - 8;
                     png8++;
                  }
               }
            }
            else {
               for (ii = 0; ii < 3; ii++)                                  //  RGB or RGB + alpha
               {
                  rgbval = *png8 << bit;
                  rgbval = (rgbval & mask[bpc]) * scale[bpc];
                  pix[ii] = rgbval;
                  bit += bpc;
                  if (bit > 7) {
                     bit = bit - 8;
                     png8++;
                  }
               }
               if (nch == 4) {
                  bit += bpc;
                  if (bit > 7) {
                     bit = bit - 8;
                     png8++;
                  }
               }
            }
            pix += 3;
         }
      }
   }

   else if (bpc == 16)                                                     //  16 bits/channel
   {
      for (row = 0; row < hh; row++)
      {
         png16 = (uint16 *) pngrows[row];
         pix = pxb->pixels + row * pxb->rs;

         for (col = 0; col < ww; col++)
         {
            if (nch < 3) {                                                 //  gray or gray + alpha
               pix[0] = pix[1] = pix[2] = (*png16) >> 8;                   //  v.12.12
               png16 += nch;
            }
            else {
               pix[0] = png16[0] >> 8;                                     //  v.12.12
               pix[1] = png16[1] >> 8;
               pix[2] = png16[2] >> 8;
               png16 += nch;
            }
            pix += 3;
         }
      }
   }

   else zappcrash("PNGread() bug %d %d",bpc,nch);

   png_destroy_read_struct(&pngstruct,&pnginfo,0);                         //  release memory

   f_load_bpc = bpc;                                                       //  file bpc 1/8/16
   return pxb;

erret:
   if (fid) fclose(fid);
   snprintf(file_errmess,999,"PNG file read error: %s",file);              //  v.12.12
   printf("%s\n",file_errmess);
   return 0;
}


//  Load PXM from PNG file using PNG library. 
//  Native PNG file bits/pixel >> f_load_bpc

PXM * PNG_PXM_load(cchar *file)                                            //  v.12.09
{
   png_structp    pngstruct = 0;
   png_infop      pnginfo = 0;
   FILE           *fid;
   int            ww, hh, bpc, nch, colortype;
   uchar          **pngrows;
   uint8          *png8;
   uint16         *png16;
   PXM            *pxm;
   float          *pix, f256 = 1.0 / 256.0;
   int            row, col, bit, ii, rgbval;
   static int     ftf = 1;
   static int     mask[9] = { 0, 0x80, 0xc0, 0xe0, 0xf0, 0xf8, 0xfc, 0xfe, 0xff };
   static float   scale[9];
   
   if (ftf) {
      ftf = 0;
      for (ii = 1; ii < 9; ii++)                                           //  used for < 8 bits per color
         scale[ii] = 255.0 / mask[ii];
   }

   *file_errmess = 0;                                                      //  v.12.12

   fid = fopen(file,"r");                                                  //  open file
   if (! fid) goto erret;

   pngstruct = png_create_read_struct(PNG_LIBPNG_VER_STRING,0,0,0);        //  create png structs
   if (! pngstruct) goto erret;
   pnginfo = png_create_info_struct(pngstruct);
   if (! pnginfo) goto erret;
   if (setjmp(png_jmpbuf(pngstruct))) goto erret;                          //  setup error handling

   png_init_io(pngstruct,fid);                                             //  read png file
   png_read_png(pngstruct,pnginfo,0,0);
   fclose(fid);
   
   ww = png_get_image_width(pngstruct,pnginfo);                            //  width
   hh = png_get_image_height(pngstruct,pnginfo);                           //  height
   bpc = png_get_bit_depth(pngstruct,pnginfo);                             //  bits per color (channel)
   nch = png_get_channels(pngstruct,pnginfo);                              //  no. channels
   colortype = png_get_color_type(pngstruct,pnginfo);                      //  color type
   pngrows = png_get_rows(pngstruct,pnginfo);                              //  array of png row pointers
   
   if (ww > wwhh_limit || hh > wwhh_limit) {
      png_destroy_read_struct(&pngstruct,&pnginfo,0);
      snprintf(file_errmess,999,"image too big, %dx%d: %s",ww,hh,file);    //  v.12.12
      printf("%s\n",file_errmess);
      return 0;
   }

   if (bpc > 8 && bpc != 16) {
      png_destroy_read_struct(&pngstruct,&pnginfo,0);
      printf("PNG bpc %d not supported: %s \n",bpc,file);
      return ANY_PXM_load(file);                                           //  fallback to pixbuf loader
   }

   if (colortype != PNG_COLOR_TYPE_GRAY && colortype != PNG_COLOR_TYPE_RGB && colortype != PNG_COLOR_TYPE_RGB_ALPHA) {
      png_destroy_read_struct(&pngstruct,&pnginfo,0);
      printf("PNG color type %d not supported: %s \n",colortype,file);
      return ANY_PXM_load(file);                                           //  fallback to pixbuf loader
   }

   pxm = PXM_make(ww,hh);                                                  //  create PXM

   if (bpc == 8)                                                           //  8 bits/channel
   {
      for (row = 0; row < hh; row++)
      {
         png8 = (uint8 *) pngrows[row];
         pix = pxm->pixels + row * ww * 3;
         
         for (col = 0; col < ww; col++)
         {
            if (nch < 3) {                                                 //  gray or gray + alpha
               pix[0] = pix[1] = pix[2] = *png8;
            }
            else {                                                         //  RGB or RGB + alpha
               pix[0] = png8[0];
               pix[1] = png8[1];
               pix[2] = png8[2];
            }
            pix += 3;
            png8 += nch;
         }
      }
   }

   else if (bpc < 8)                                                       //  1, 2, 4  bits/channel
   {
      for (row = 0; row < hh; row++)
      {
         png8 = (uint8 *) pngrows[row];
         pix = pxm->pixels + row * ww * 3;
         bit = 0;
         
         for (col = 0; col < ww; col++)
         {
            if (nch < 3) {                                                 //  gray or gray + alpha
               rgbval = *png8 << bit;
               rgbval = (rgbval & mask[bpc]) * scale[bpc];
               pix[0] = pix[1] = pix[2] = rgbval;
               for (ii = 0; ii < nch; ii++)
               {
                  bit += bpc;
                  if (bit > 7) {
                     bit = bit - 8;
                     png8++;
                  }
               }
            }
            else {
               for (ii = 0; ii < 3; ii++)                                  //  RGB or RGB + alpha
               {
                  rgbval = *png8 << bit;
                  rgbval = (rgbval & mask[bpc]) * scale[bpc];
                  pix[ii] = rgbval;
                  bit += bpc;
                  if (bit > 7) {
                     bit = bit - 8;
                     png8++;
                  }
               }
               if (nch == 4) {
                  bit += bpc;
                  if (bit > 7) {
                     bit = bit - 8;
                     png8++;
                  }
               }
            }
            pix += 3;
         }
      }
   }

   else if (bpc == 16)                                                     //  16 bits/channel
   {
      for (row = 0; row < hh; row++)
      {
         png16 = (uint16 *) pngrows[row];
         pix = pxm->pixels + row * ww * 3;
         
         for (col = 0; col < ww; col++)
         {
            if (nch < 3) {                                                 //  gray or gray + alpha
               pix[0] = pix[1] = pix[2] = f256 * (*png16);                 //  v.12.12
               png16 += nch;
            }
            else {                                                         //  RGB or RGB + alpha
               pix[0] = f256 * png16[0];                                   //  v.12.12
               pix[1] = f256 * png16[1];
               pix[2] = f256 * png16[2];
               png16 += nch;
            }
            pix += 3;
         }
      }
   }

   else zappcrash("PNGread() bug %d %d",bpc,nch);

   png_destroy_read_struct(&pngstruct,&pnginfo,0);                         //  release memory

   f_load_bpc = bpc;                                                       //  file bpc 1/8/16
   return pxm;

erret:
   if (fid) fclose(fid);
   snprintf(file_errmess,999,"PNG file read error: %s",file);              //  v.12.12
   printf("%s\n",file_errmess);
   return 0;
}


//  Write PXM to PNG file using PNG library. 
//  File bpc is 8 or 16.
//  returns 0 if OK, +N if error.

int PXM_PNG_save(PXM *pxm, cchar *file, int bpc)                           //  v.12.10
{
   png_structp    pngstruct;
   png_infop      pnginfo;
   FILE           *fid;
   uchar          **pngrows;
   uint8          *png8;
   uint16         *png16;
   float          *pix;
   int            ww, hh, cc, row, col;
   
   if (bpc != 8 && bpc != 16) zappcrash("PNG write bpc: %d",bpc);
   
   *file_errmess = 0;                                                      //  v.12.12

   ww = pxm->ww;
   hh = pxm->hh;
   
   fid = fopen(file,"w");                                                  //  open output file
   if (! fid) goto erret;

   pngstruct = png_create_write_struct(PNG_LIBPNG_VER_STRING,0,0,0);       //  create png structs
   if (! pngstruct) goto erret;
   pnginfo = png_create_info_struct(pngstruct);
   if (! pnginfo) goto erret;
   if (setjmp(png_jmpbuf(pngstruct))) goto erret;                          //  setup error handling

   png_init_io(pngstruct,fid);                                             //  initz. for writing file
   
   png_set_compression_level(pngstruct,4);                                 //  1...9 = faster...smaller size

   png_set_IHDR(pngstruct,pnginfo,ww,hh,bpc,PNG_COLOR_TYPE_RGB,0,0,0);     //  8 or 18 bit RGB
   
   pngrows = (uchar **) zmalloc(hh * sizeof(char *),"PNGwrite");           //  allocate rows of RGB data
   if (bpc == 8) cc = ww * 3;                                              //  3 bytes per RGB pixel
   else cc = ww * 6;                                                       //  6 bytes per RGB pixel
   for (row = 0; row < hh; row++) 
      pngrows[row] = (uchar *) zmalloc(cc,"PNGwrite");

   png_set_rows(pngstruct,pnginfo,pngrows);                                //  array of png row pointers
   
   if (bpc == 8)                                                           //  8 bit RGB
   {
      for (row = 0; row < hh; row++)
      {
         png8 = (uint8 *) pngrows[row];
         pix = pxm->pixels + row * ww * 3;

         for (col = 0; col < ww; col++)
         {
            png8[0] = pix[0];
            png8[1] = pix[1];
            png8[2] = pix[2];
            png8 += 3;
            pix += 3;
         }
      }
   }

   else if (bpc == 16)                                                     //  16 bit RGB
   {
      for (row = 0; row < hh; row++)
      {
         png16 = (uint16 *) pngrows[row];
         pix = pxm->pixels + row * ww * 3;
         
         for (col = 0; col < ww; col++)
         {
            png16[0] = 256.0 * pix[0];                                     //  v.12.12
            png16[1] = 256.0 * pix[1];
            png16[2] = 256.0 * pix[2];
            png16 += 3;
            pix += 3;
         }
      }
   }
   
   png_write_png(pngstruct,pnginfo,0,0);                                   //  write the file
   fclose(fid);

   png_destroy_write_struct(&pngstruct,&pnginfo);                          //  release memory

   for (row = 0; row < hh; row++)
      zfree(pngrows[row]);
   zfree(pngrows);

   return 0;

erret:
   if (fid) fclose(fid);
   snprintf(file_errmess,999,"PNG file write error: %s",file);             //  v.12.12
   printf("%s\n",file_errmess);
   return 2;
}


/**************************************************************************
   JPEG and other file types read and write functions
***************************************************************************/

//  Load PXB from jpeg and other file types using the pixbuf library. 
//  bpc = 8.

PXB * ANY_PXB_load(cchar *file)                                            //  v.12.10
{
   GError         *gerror = 0;
   PXB            *pxb;
   GdkPixbuf      *pixbuf;
   int            ww, hh, px, py, nch, rowst;
   uint8          *bmp1, *pix1;
   uint8          *bmp2, *pix2;
   
   *file_errmess = 0;                                                      //  v.12.12

   pixbuf = gdk_pixbuf_new_from_file(file,&gerror);
   if (! pixbuf) {
      if (gerror) printf("%s\n",gerror->message);
      snprintf(file_errmess,999,"(pixbuf) file read error: %s",file);      //  v.12.12
      printf("%s\n",file_errmess);
      return 0;
   }

   ww = gdk_pixbuf_get_width(pixbuf);
   hh = gdk_pixbuf_get_height(pixbuf);
   nch = gdk_pixbuf_get_n_channels(pixbuf);
   rowst = gdk_pixbuf_get_rowstride(pixbuf);
   bmp1 = gdk_pixbuf_get_pixels(pixbuf);
   
   if (ww > wwhh_limit || hh > wwhh_limit) {
      snprintf(file_errmess,999,"image too big, %dx%d: %s",ww,hh,file);    //  v.12.12
      printf("%s\n",file_errmess);
      g_object_unref(pixbuf);
      return 0;
   }

   pxb = PXB_make(ww,hh);
   bmp2 = pxb->pixels;
   
   for (py = 0; py < hh; py++)
   {
      pix1 = bmp1 + rowst * py;
      pix2 = bmp2 + py * pxb->rs;
      
      if (nch >= 3)
      {
         for (px = 0; px < ww; px++)
         {
            pix2[0] = pix1[0];
            pix2[1] = pix1[1];
            pix2[2] = pix1[2];
            pix1 += nch;
            pix2 += 3;
         }
      }
      
      else
      {
         for (px = 0; px < ww; px++)
         {
            pix2[0] = pix2[1] = pix2[2] = pix1[0];
            pix1 += nch;
            pix2 += 3;
         }
      }
   }
   
   f_load_bpc = 8;                                                         //  file bits per color
   g_object_unref(pixbuf);

   return pxb;
}


//  Load PXM from jpeg and other file types using the pixbuf library. 
//  bpc = 8.

PXM * ANY_PXM_load(cchar *file)                                            //  v.12.10
{
   GError         *gerror = 0;
   PXM            *pxm;
   GdkPixbuf      *pixbuf;
   int            ww, hh, px, py, nch, rowst;
   uint8          *bmp1, *pix1;
   float          *bmp2, *pix2;
   static int     ftf = 1;
   static float   ftab[256];
   
   if (ftf) {                                                              //  table lookup for speed
      ftf = 0;
      for (int ii = 0; ii < 256; ii++)
         ftab[ii] = ii;
   }
   
   *file_errmess = 0;                                                      //  v.12.12

   pixbuf = gdk_pixbuf_new_from_file(file,&gerror);
   if (! pixbuf) {
      if (gerror) printf("%s\n",gerror->message);
      snprintf(file_errmess,999,"(pixbuf) file read error: %s",file);      //  v.12.12
      printf("%s\n",file_errmess);
      return 0;
   }

   ww = gdk_pixbuf_get_width(pixbuf);
   hh = gdk_pixbuf_get_height(pixbuf);
   nch = gdk_pixbuf_get_n_channels(pixbuf);
   rowst = gdk_pixbuf_get_rowstride(pixbuf);
   bmp1 = gdk_pixbuf_get_pixels(pixbuf);
   
   if (ww > wwhh_limit || hh > wwhh_limit) {
      snprintf(file_errmess,999,"image too big, %dx%d: %s",ww,hh,file);    //  v.12.12
      printf("%s\n",file_errmess);
      g_object_unref(pixbuf);
      return 0;
   }

   pxm = PXM_make(ww,hh);
   bmp2 = pxm->pixels;
   
   for (py = 0; py < hh; py++)
   {
      pix1 = bmp1 + rowst * py;
      pix2 = bmp2 + py * ww * 3;
      
      if (nch >= 3)
      {
         for (px = 0; px < ww; px++)
         {
            pix2[0] = ftab[pix1[0]];                                       //  0-255  >>  0.0-255.0
            pix2[1] = ftab[pix1[1]];
            pix2[2] = ftab[pix1[2]];
            pix1 += nch;
            pix2 += 3;
         }
      }
      
      else
      {
         for (px = 0; px < ww; px++)
         {
            pix2[0] = pix2[1] = pix2[2] = ftab[pix1[0]];
            pix1 += nch;
            pix2 += 3;
         }
      }
   }
   
   f_load_bpc = 8;                                                         //  file bits per color
   g_object_unref(pixbuf);

   return pxm;
}


//  Write PXM to jpeg and other file types using the pixbuf library.
//  bpc = 8.
//  returns 0 if OK, +N if error.

int PXM_ANY_save(PXM *pxm, cchar *file)                                    //  v.12.10
{
   int         ww, hh, px, py, rowst;
   float       *bmp1, *pix1;
   uint8       *bmp2, *pix2;
   GdkPixbuf   *pixbuf;
   cchar       *pext;
   GError      *gerror = 0;
   int         pxbstat;

   *file_errmess = 0;                                                      //  v.12.12

   ww = pxm->ww;
   hh = pxm->hh;

   pixbuf = gdk_pixbuf_new(GDKRGB,0,8,ww,hh);
   if (! pixbuf) zappcrash("pixbuf allocation failure");

   bmp1 = pxm->pixels;
   bmp2 = gdk_pixbuf_get_pixels(pixbuf);
   rowst = gdk_pixbuf_get_rowstride(pixbuf);

   for (py = 0; py < hh; py++)
   {
      pix1 = bmp1 + py * ww * 3;
      pix2 = bmp2 + rowst * py;

      for (px = 0; px < ww; px++)
      {
         pix2[0] = pix1[0];                                                //  0.0 - 255.996  >>  0 - 255
         pix2[1] = pix1[1];
         pix2[2] = pix1[2];
         pix1 += 3;
         pix2 += 3;
      }
   }

   pext = strrchr(file,'/');
   if (! pext) pext = file;
   pext = strrchr(pext,'.');
   if (! pext) pext = "";

   if (strstr(".png .PNG",pext))
      pxbstat = gdk_pixbuf_save(pixbuf,file,"png",&gerror,"compression","4",null);

   else if (strstr(".ico .ICO",pext))
      pxbstat = gdk_pixbuf_save(pixbuf,file,"ico",&gerror,null);

   else if (strstr(".bmp .BMP",pext))
      pxbstat = gdk_pixbuf_save(pixbuf,file,"bmp",&gerror,null);

   else pxbstat = gdk_pixbuf_save(pixbuf,file,"jpeg",&gerror,"quality",jpeg_quality,null);

   g_object_unref(pixbuf);
   if (pxbstat) return 0;

   if (gerror) printf("%s\n",gerror->message);
   snprintf(file_errmess,999,"(pixbuf) file write error: %s",file);        //  v.12.12
   printf("%s\n",file_errmess);
   return 2;
}


/**************************************************************************
   directory navigation and thumbnail gallery functions
**************************************************************************/

namespace navi 
{
   #define thumbnail_cachesize 10000                                       //  max thumbnails cached in memory
                                                                           //  supported image file types
   #define imagetypes ".jpeg .jpg .png .tif .tiff .bmp .ico " \
                      ".gif .svg .xpm .tga" 

   #define TEXTWIN GTK_TEXT_WINDOW_TEXT                                    //  GDK window of GTK text view
   #define NEVER GTK_POLICY_NEVER
   #define ALWAYS GTK_POLICY_ALWAYS

   #define     thumbxx 6                                                   //  thumbx array size
   int         thumbx[6] = { 512, 360, 256, 180, 128, 90 };                //  thumbnail sizes

   char        *galleryname = 0;                                           //  image directory or file list name
   int         gallerytype = 0;                                            //  1-5 = dirk/search/metadata/coll/recent
   int         nfiles = 0;                                                 //  total file count (incl. subdirks)
   int         nimages = 0;                                                //  image file count
   char        **flist = 0;                                                //  image file list
   char        **mdlist = 0;                                               //  corresp. metadata list
   int         mdrows = 0;                                                 //  text rows in metadata list
   int         xwinW = 1000, xwinH = 700;                                  //  gallery window initial size
   int         xwinX, xwinY;                                               //  gallery window initial position
   int         thumbsize = thumbfilesize;                                  //  thumbnail image <= thumbnail file
   int         thumbW, thumbH;                                             //  gallery window thumbnail cell size
   int         fontsize = 9;                                               //  font size for text in gallery window
   int         xrows, xcols;                                               //  gallery window thumbnail rows, cols
   int         margin = 5;                                                 //  cell margin from left and top edge
   int         genthumbs = 0;                                              //  count newly generated thumbnails
   int         maxscroll;                                                  //  max. scroll position
   int         topfileposn = 0;                                            //  scroll-to file position (Nth)

   //  private functions
   int    gallery_paint(GtkWidget *, cairo_t *);                           //  gallery window paint function
   int    gallery_paint_metadata(GtkWidget *gDwin, cairo_t *cr);           //  same, for metadata report
   void   draw_text(cairo_t *cr, char *text, int x, int y, int ww);        //  draw text in gallery window
   void   menufuncx(GtkWidget *win, cchar *menu);                          //  function for gallery window buttons
   void   changedirk(GtkWidget *widget, GdkEventButton *event);            //  function for gallery directory change
   void   rootdirk(GtkWidget *widget, GdkEventButton *event);              //  function for jump to root directory
   void   mouse_event(GtkWidget *widget, GdkEvent *event, void *);         //  gallery window mouse event function
	int    KBxrelease(GtkWidget *, GdkEventKey *, void *);                  //  gallery window key release event
   char * image_navigate(cchar *filez, cchar *action, int Nth = 0);        //  image file list setup and navigate
   int    image_fcomp(cchar *file1, cchar *file2);                         //  file name compare (special sort)
}


/**************************************************************************

   public function to create/update image gallery (thumbnail window)

   Make window scrolling window of thumbnails for a list of files
   Handle window buttons (up row, down page, open file, etc.)
   Call external functions in response to thumbnail mouse-clicks.

   char * gallery(cchar *filez, cchar *action, int Nth)

   filez: image file or directory or file with list of image files

   action:  init:    filez = initial file or directory 
            initF:   filez = file with list of image files to use
            sort:    sort the file list, directories first, ignore case
            insert:  insert filez into file list at position Nth (0 to last+1)
            delete:  delete Nth file in list
            find:    return Nth file (0 base) or null if Nth > last
            paint:   paint gallery window, Nth file in top row
   
   Nth: file to return (action = find) (0 = first file)
        file to scroll-to (action = init, paint) (-1 = no change)

   thumbnail click functions: 
      gallery_Lclick_func()                     left click
      gallery_Rclick_popup()                    right click
      gallery_getfiles_Lclick_func()            left click, gallery_getfiles active
      gallery_getfiles_Rclick_func()            right click, gallery_getfiles active
      passes Nth of clicked thumbnail (0 to last)
      passes -1 if gallery window is closed
      passes -2 if key F1 is pressed (for context help)
      
   Returned values:
      find: filespec,    others: null
      The returned file belongs to caller and is subject for zfree().

***************************************************************************/

char * gallery(cchar *filez, cchar *action, int Nth)                       //  v.12.09
{
   using namespace navi;
   
   int      err, ii;
   char     *file = 0;
   
   zthreadcrash();                                                         //  thread usage not allowed
   
   if (strstr("init initF",action))                                        //  generate new gallery file list
   {
      image_navigate(filez,action);                                        //  make new gallery file list
      
      if (! curr_file) {                                                   //  if no current file, get from gallery
         file = gallery(0,"find",0);                                       //    v.13.01
         if (! file) return 0;
         err = f_open(file,1,0,0,0);
         zfree(file);
         if (err) return 0;
      }
      
      ii = gallery_position(curr_file,0);                                  //  if current file not in gallery,
      if (ii < 0) {                                                        //    open 1st file in gallery
         file = gallery(0,"find",0);
         if (! file) return 0;
         err = f_open(file,1,0,0,0);
         zfree(file);
         if (err) return 0;
         ii = 0;
      }
      curr_file_posn = ii;

      if (Nth >= 0) topfileposn = curr_file_posn;                          //  new gallery scroll position
      return 0;
   }

   if (strstr("sort insert delete",action)) {                              //  revise gallery file list
      image_navigate(filez,action,Nth);
      if (Nth >= 0) topfileposn = Nth;                                     //  new top row file if wanted
      return 0;
   }

   if (strEqu(action,"find"))                                              //  find Nth file in file list
      return image_navigate(0,action,Nth);

   if (strEqu(action,"paint")) {                                           //  paint gallery window
      if (Nth >= 0) topfileposn = Nth;                                     //  new top row file if wanted
      gtk_widget_queue_draw(gDwin);                                        //  draw window
      settab("G");                                                         //  v.13.01
      return 0;
   }
   
   zappcrash("gallery() action: %s",action);                               //  bad call
   return 0;
}


//  private function
//  paint gallery window - draw all thumbnail images that can fit

int navi::gallery_paint(GtkWidget *gDwin, cairo_t *cr)
{
   using namespace navi;

   GdkPixbuf   *pxbT;
   double      x1, y1, x2, y2;
   int         ii, nrows, row, col;
   int         row1, row2;
   int         ww, hh, scrollp;
   int         drwingW, drwingH;
   int         thumx, thumy, texthh;
   char        *pp, *fname, p0;
   char        text[200], pdate[12], size[16];
   
   set_gwin_title();                                                       //  main window title = gallery name

   if (! gallerytype) return 1;
   gtk_entry_set_text(GTK_ENTRY(gPath),galleryname);                       //  set current directory label

   if (gallerytype == 3) {                                                 //  metadata report
      gallery_paint_metadata(gDwin,cr);
      return 1;
   }
   
   fontsize = 7 + thumbsize / 128;                                         //  font size from 7 to 10       v.13.01
   if (! thumbsize) fontsize = 9;                                          //  text only view
   texthh = 3.5 * fontsize + 4;                                            //  two text lines
   thumbW = thumbsize + 10;                                                //  thumbnail cell size
   thumbH = thumbsize + texthh + thumbsize / 24 + 10;

   if (! thumbsize) {
      thumbW = 400;                                                        //  zero, list view
      thumbH = 40;
   }

   xwinW = gtk_widget_get_allocated_width(gSwin);                          //  drawing window size
   xwinH = gtk_widget_get_allocated_height(gSwin);

   xrows = int(0.1 + 1.0 * xwinH / thumbH);                                //  get thumbnail rows and cols that
   xcols = int(0.1 + 1.0 * xwinW / thumbW);                                //    (almost) fit in window 
   if (xrows < 1) xrows = 1;
   if (xcols < 1) xcols = 1;
   nrows = (nfiles+xcols-1) / xcols;                                       //  thumbnail rows, 1 or more
   if (nrows < 1) nrows = 1;

   drwingW = xcols * thumbW + margin + 10;                                 //  layout size for entire gallery
   drwingH = (nrows + 1) * thumbH;                                         //  last row
   if (drwingH < xwinH) drwingH = xwinH;                                   //  at least current size
   
   gtk_widget_get_size_request(gDwin,&ww,&hh);                             //  current size
   if (ww != drwingW || hh != drwingH)
      gtk_widget_set_size_request(gDwin,drwingW,drwingH);                  //  needs to change

   maxscroll = (nrows - xrows) * thumbH;                                   //  max. layout scroll position
   if (maxscroll < 0) maxscroll = 0;

   gtk_adjustment_set_step_increment(gSadj,thumbH);                        //  scrollbar works in row steps
   gtk_adjustment_set_page_increment(gSadj,thumbH * xrows);                //  and in page steps

   if (topfileposn >= 0) {                                                 //  new target file position (Nth)
      scrollp = topfileposn / xcols * thumbH;                              //  scroll position for target file
      if (scrollp > maxscroll) scrollp = maxscroll;                        //    in top row of window
      if (gtk_adjustment_get_value(gSadj) != scrollp) {                    //  if not at scroll position, reset
         gtk_adjustment_set_value(gSadj,scrollp);                          //  will cause re-entrance
         return 1;                                                         //  scrollp OK in next call
      }
      topfileposn = -1;                                                    //  keep scroll position
   }
   
   cairo_clip_extents(cr,&x1,&y1,&x2,&y2);                                 //  window region to paint
   row1 = y1 / thumbH;
   row2 = y2 / thumbH;
   
   for (row = row1; row <= row2; row++)                                    //  draw file thumbnails
   {
      for (col = 0; col < xcols; col++)                                    //  draw all columns in row
      {
         ii = row * xcols + col;                                           //  next file
         if (ii >= nfiles) return 1;                                       //  exit 2 nested loops

         p0 = *flist[ii];                                                  //  replace possible ! with /
         *flist[ii] = '/';

         fname = flist[ii];                                                //  filespec
         pp = strrchr(fname,'/');                                          //  get file name only
         if (pp) fname = pp + 1;

         thumx = col * thumbW + margin;                                    //  upper left corner in drawing area
         thumy = row * thumbH + margin;

         if (image_file_type(flist[ii]) == 2) {         
            get_search_index_rec_min(flist[ii],pdate,size);                //  filename, photo date, size    v.13.01
            snprintf(text,200,"%s\n%s  %s",fname,pdate,size);
            draw_text(cr,text,thumx,thumy,thumbW-5);
            thumy += texthh;                                               //  position below text
         }

         else {         
            snprintf(text,200,"%s",fname);
            draw_text(cr,text,thumx,thumy,thumbW-5);
            thumy += texthh / 2;                                           //  position below text
         }

         if (thumbsize) {                                                  //  zero >> list view
            pxbT = image_thumbnail(flist[ii],thumbsize);                   //  get thumbnail
            if (pxbT) {
               gdk_cairo_set_source_pixbuf(cr,pxbT,thumx,thumy);
               cairo_paint(cr);
               g_object_unref(pxbT);
            }
         }

         *flist[ii] = p0;                                                  //  restore !
      }
   }

   return 1;
}


//  private function
//  paint metadata report - draw thumbnail images + metadata

int navi::gallery_paint_metadata(GtkWidget *gDwin, cairo_t *cr)
{
   using namespace navi;

   GdkPixbuf   *pxbT;
   double      x1, y1, x2, y2;
   int         ii, nrows, row, col;
   int         row1, row2;
   int         ww, hh, scrollp;
   int         drwingW, drwingH;
   int         thumx, thumy, textww, texthh;
   char        p0;
   
   if (thumbsize < 128) thumbsize = 128;

   fontsize = 7 + thumbsize / 128;                                         //  font size from 7 to 10

   thumbW = thumbsize + 10;                                                //  thumbnail layout size
   thumbH = thumbsize + 20;

   texthh = mdrows * fontsize * 1.8 + 20;                                  //  space for metadata text      v.13.01
   if (texthh > thumbH) thumbH = texthh;

   xwinW = gtk_widget_get_allocated_width(gSwin);                          //  drawing window size
   xwinH = gtk_widget_get_allocated_height(gSwin);

   xrows = int(0.1 + 1.0 * xwinH / thumbH);                                //  get thumbnail rows fitting in window
   if (xrows < 1) xrows = 1;
   xcols = 1;                                                              //  force cols = 1
   nrows = nfiles;                                                         //  thumbnail rows

   drwingW = xwinW;                                                        //  layout size for entire file list
   if (drwingW < 800) drwingW = 800;
   drwingH = (nrows + 1) * thumbH;                                         //  last row
   if (drwingH < xwinH) drwingH = xwinH;

   gtk_widget_get_size_request(gDwin,&ww,&hh);                             //  current size
   if (ww != drwingW || hh != drwingH)
      gtk_widget_set_size_request(gDwin,drwingW,drwingH);                  //  needs to change

   maxscroll = (nrows - xrows) * thumbH;                                   //  max. layout scroll position
   if (maxscroll < 0) maxscroll = 0;

   gtk_adjustment_set_step_increment(gSadj,thumbH);                        //  scrollbar works in row steps
   gtk_adjustment_set_page_increment(gSadj,thumbH * xrows);                //  and in page steps

   if (topfileposn >= 0) {                                                 //  new target file position (Nth)
      scrollp = topfileposn / xcols * thumbH;                              //  scroll position for target file
      if (scrollp > maxscroll) scrollp = maxscroll;                        //    in top row of window
      if (gtk_adjustment_get_value(gSadj) != scrollp) {                    //  if not at scroll position, reset
         gtk_adjustment_set_value(gSadj,scrollp);                          //  will cause re-entrance
         return 1;                                                         //  scrollp OK in next call
      }
      topfileposn = -1;                                                    //  keep scroll position
   }
   
   cairo_clip_extents(cr,&x1,&y1,&x2,&y2);                                 //  window region to paint
   row1 = y1 / thumbH;
   row2 = y2 / thumbH;

   textww = drwingW - thumbW - 2 * margin;                                 //  space for text right of thumbnail

   for (row = row1; row <= row2; row++)                                    //  draw file thumbnails
   {
      for (col = 0; col < xcols; col++)
      {
         ii = row * xcols + col;                                           //  next file
         if (ii >= nfiles) return 1;                                       //  exit 2 nested loops

         p0 = *flist[ii];                                                  //  replace possible ! with /
         *flist[ii] = '/';

         thumx = col * thumbW + margin;                                    //  upper left corner in window space
         thumy = row * thumbH + margin;
         
         pxbT = image_thumbnail(flist[ii],thumbsize);                      //  get thumbnail
         if (pxbT) {
            gdk_cairo_set_source_pixbuf(cr,pxbT,thumx,thumy);
            cairo_paint(cr);
            g_object_unref(pxbT);
         }

         draw_text(cr,flist[ii],thumbW+margin,thumy,textww);               //  write filespec to right of thumbnail
         
         if (mdlist && mdlist[ii])                                         //  write metadata if present
            draw_text(cr,mdlist[ii],thumbW+margin,thumy+20,textww);
         
         *flist[ii] = p0;                                                  //  restore !
      }
   }

   return 1;
}


//  private function
//  write text for thumbnail limited by width of thumbnail

void navi::draw_text(cairo_t *cr, char *text, int px, int py, int ww)
{
   using namespace navi;

   static PangoFontDescription   *pfont = 0;
   static PangoLayout            *playout = 0;
   
   static int     pfontsize = -1;
   static char    thumbfont[12] = "";
   
   if (fontsize != pfontsize) {                                            //  adjust for curr. font size      v.13.01
      pfontsize = fontsize;
      sprintf(thumbfont,"sans %d",fontsize);
      pfont = pango_font_description_from_string(thumbfont);
      playout = pango_cairo_create_layout(cr);
      pango_layout_set_font_description(playout,pfont);
   }

   pango_layout_set_width(playout,ww*PANGO_SCALE);                         //  limit width to avail. space
   pango_layout_set_ellipsize(playout,PANGO_ELLIPSIZE_END);
   pango_layout_set_text(playout,text,-1);

   cairo_move_to(cr,px,py);
   cairo_set_source_rgb(cr,0,0,0);
   pango_cairo_show_layout(cr,playout);
   return;
}


//  private function - menu function for gallery window
//    - scroll window as requested
//    - jump to new file or folder as requested

void navi::menufuncx(GtkWidget *win, cchar *menu)
{
   using namespace navi;

   int      ii, scrollp, scroll1, scroll2;
   int      step = thumbH / 8;                                             //  row-scroll step size
   char     *file;

   zfuncs::F1_help_topic = "navigation";                                   //  v.12.08
   
   if (strEqu(menu,ZTX("Open"))) {                                         //  change directory       v.12.07
      file = zgetfile1(ZTX("change directory"),"folder",curr_dirk);
      if (! file) return;
      gallery(file,"init");
      gallery(0,"paint");
      zfree(file);                                                         //  v.12.08
      return;
   }
      
   if (strEqu(menu,ZTX("Discard"))) {                                      //  replace special gallery with
      if (! curr_file) return;                                             //    directory from current file
      if (gallerytype == 1) return;
      gallery(curr_file,"init");                                           //  generate new gallery list
      gallery(0,"paint",-1);
      zmainloop();                                                         //  v.13.01
      return;
   }

   scrollp = gtk_adjustment_get_value(gSadj);                              //  current scroll position

   if (strEqu(menu,"Zoom+"))  {                                            //  next bigger thumbnail size
      for (ii = 0; ii < thumbxx; ii++) 
         if (thumbsize == thumbx[ii]) break;
      if (ii == 0) return;
      thumbsize = thumbx[ii-1];
      topfileposn = scrollp / thumbH * xcols;                              //  keep top row position
      gtk_widget_queue_draw(gDwin);
      zmainloop();                                                         //  v.13.01
      return;
   }

   if (strEqu(menu,"Zoom-"))  {                                            //  next smaller
      for (ii = 0; ii < thumbxx; ii++) 
         if (thumbsize == thumbx[ii]) break;
      if (ii >= thumbxx-1) thumbsize = 0;                                  //  no thumbs, list view
      else  thumbsize = thumbx[ii+1];
      if (thumbsize < 128 && gallerytype == 3)                             //  min. for metadata report        v.12.01
         thumbsize = 128;
      topfileposn = scrollp / thumbH * xcols;                              //  keep top row position
      gtk_widget_queue_draw(gDwin);
      zmainloop();                                                         //  v.13.01
      return;
   }
   
   if (strEqu(menu,ZTX("Row↑"))) {                                        //  scroll 1 row in small steps
      scroll1 = scrollp / thumbH * thumbH;                                 //  faster/smoother                 v.12.08
      scroll2 = scroll1 - thumbH;
      if (scroll2 < 0) scroll2 = 0;
      for (scrollp = scroll1; scrollp >= scroll2; scrollp -= step) {
         if (scrollp - scroll2 < step) scrollp = scroll2;
         gtk_adjustment_set_value(gSadj,scrollp);
         zmainloop();
      }
      return;
   }
      
   if (strEqu(menu,ZTX("Row↓"))) {
      scroll1 = (scrollp+thumbH/3) / thumbH * thumbH;
      scroll2 = scroll1 + thumbH;
      if (scroll2 > maxscroll) scroll2 = maxscroll;
      for (scrollp = scroll1; scrollp <= scroll2; scrollp += step) {
         if (scroll2 - scrollp < step) scrollp = scroll2;
         gtk_adjustment_set_value(gSadj,scrollp);
         zmainloop();
      }
      return;
   }
      
   if (strEqu(menu,ZTX("First"))) scrollp = 0;                             //  jump to page
   if (strEqu(menu,ZTX("Last"))) scrollp = maxscroll;
   if (strEqu(menu,ZTX("Page↑"))) scrollp -= thumbH * xrows;
   if (strEqu(menu,ZTX("Page↓"))) scrollp += thumbH * xrows;

   if (scrollp < 0) scrollp = 0;                                           //  enforce limits
   if (scrollp > maxscroll) scrollp = maxscroll;

   topfileposn = scrollp / thumbH * xcols;
   gtk_widget_queue_draw(gDwin);
   zmainloop();                                                            //  v.13.01

   return;
}


//  private function
//  directory selection - get new directory from mouse-click position

void navi::changedirk(GtkWidget *widget, GdkEventButton *event)            //  v.12.04
{
   using namespace navi;

   int      cc, pos;
   char     *pp, directory[500];
   cchar    *ppc;
   
   if (gallerytype > 1) return;                                            //  not a directory gallery

   ppc = gtk_entry_get_text(GTK_ENTRY(widget));                            //  current directory 
   if (! ppc) return;
   strncpy0(directory,ppc,500);
   cc = strlen(directory);
   if (cc < 2) return;
   pos = int(event->x) / 8;                                                //  mouse position in directory
   if (pos >= cc) pos = cc - 1;
   if (pos < 2) return;
   pp = strchr(directory+pos,'/');                                         //  truncate following directories
   if (! pp) return;
   *pp = 0;
   gallery(directory,"init");                                              //  initialize new gallery    v.12.08
   gallery(0,"paint");
   return;
}


//  private function
//  directory selection - go to overall top directory "/"

void navi::rootdirk(GtkWidget *widget, GdkEventButton *event)              //  new v.12.08
{
   gallery("/","init");
   gallery(0,"paint");
   return;
}


//  private function
//  mouse event function for gallery window - get selected thumbnail and file
//  user function receives clicked file, which is subject for zfree()

void navi::mouse_event(GtkWidget *widget, GdkEvent *event, void *)         //  v.13.01
{
   using namespace navi;

   GdkDevice      *mouse;
   int            evtype, mousex, mousey, mousebutt;
   int            row, col, nrows, dx, dy;
   int            Nth, noNth = 0, err;
   static int     pNth = -1, metip = 0;
   char           *filez, *fname;
   struct stat    statb;
   static char    metadata[1000];

   cchar    *keys[7] = { exif_date_key, exif_size_key, iptc_keywords_key, 
                         exif_comment_key, iptc_caption_key, 
                         exif_city_key, exif_country_key };
   char     **data;

   if (! nfiles) return;                                                   //  empty gallery

   evtype = event->type;
   mouse = gdk_event_get_device(event);

   if (evtype == GDK_LEAVE_NOTIFY) {                                       //  can happen before window drawn     v.13.01
      if (metip) {
         poptext_mouse(mouse,0,0,0);                                       //  cancel prior popup
         metip = 0;
      }
      pNth = -1;
      return;
   }

   mousex = int(((GdkEventMotion *) event)->x);
   mousey = int(((GdkEventMotion *) event)->y);
   mousebutt = ((GdkEventButton *) event)->button;

   row = (mousey - margin) / thumbH;                                       //  find selected row, col
   col = (mousex - margin) / thumbW;

   if (! xcols) return;                                                    //  v.13.01
   nrows = 1 + (nfiles-1) / xcols;                                         //  total thumbnail rows, 1 or more
   if (col < 0 || col >= xcols) noNth++;
   if (row < 0 || row >= nrows) noNth++;

   Nth = xcols * row + col;                                                //  mouse at this file
   if (Nth >= nfiles) noNth++;

   if (evtype == GDK_MOTION_NOTIFY)                                        //  popup mini metadata report      v.13.01
   {
      if ((noNth || Nth != pNth) && metip) {
         poptext_mouse(mouse,0,0,0);                                       //  cancel prior popup
         metip = 0;
         pNth = -1;
         return;                                                           //  return here necessary           v.13.01
      }

      if (noNth || Nth == pNth) return;

      filez = strdupz(flist[Nth],0,"navi");                                //  selected file
      *filez = '/';
      if (image_file_type(filez) != 2) return;

      fname = strrchr(filez,'/');                                          //  base name only
      fname++;

      data = exif_get(filez,keys,7);                                       //  get the metadata
      if (! data) return;

      if (data[0] && strlen(data[0]) > 10) data[0][10] = 0;                //  truncate date/time to yyyy:mm:dd
      if (data[3] && strlen(data[3]) > 50) data[3][50] = 0;                //  truncate caption and comment to 50 char.
      if (data[4] && strlen(data[4]) > 50) data[4][50] = 0;

      snprintf(metadata,999,
            "%s \n Date: %s \n Size: %s \n Tags: %s \n"
            " Comment: %s \n Caption: %s \n City: %s  %s",
            fname,data[0],data[1],data[2],data[3],data[4],data[5],data[6]);

      dx = 0.7 * thumbW;
      if (col == xcols-1) dx = -thumbW -200;
      dy = -20;
      poptext_mouse(mouse,metadata,dx,dy);                                 //  popup metadata report
      pNth = Nth;
      metip = 1;

      for (int ii = 0; ii < 7; ii++)
         if (data[ii]) zfree(data[ii]);

      return;
   }

   if (evtype == GDK_BUTTON_PRESS)
   {
      if (noNth) return;

      filez = strdupz(flist[Nth],0,"navi");                                //  selected file
      *filez = '/';
      
      err = stat(filez,&statb);
      if (err) {                                                           //  file is gone?
         zfree(filez);
         return;
      }

      if (S_ISDIR(statb.st_mode)) {                                        //  if directory, go there
         gallery(filez,"init");                                            //  go to top                       v.12.08
         gallery(0,"paint");
         zfree(filez);
         return;
      }

      if (mousebutt == 1) {                                                //  left click                      v.12.11
         if (zd_gallery_getfiles) gallery_getfiles_Lclick_func(Nth);       //  send to gallery_getfiles()
         else if (edit_coll_mousecapture) edit_coll_mousefunc(Nth);        //  send to edit_coll_mousefunc()   v.13.01
         else gallery_Lclick_func(Nth);                                    //  open the file
      }
         
      if (mousebutt == 3) {                                                //  right click                     v.12.11
         if (zd_gallery_getfiles) gallery_getfiles_Rclick_func(Nth);       //  send to gallery_getfiles()
         else gallery_Rclick_popup(Nth);                                   //  gallery thumbnail popup menu
      }
   }

   return;
}


//  Private function - respond to keyboard navigation keys.
//  KBrelease() for main window calls this when tab G is active.
//  key definitions: /usr/include/gtk-2.0/gdk/gdkkeysyms.h

int navi::KBxrelease(GtkWidget *win, GdkEventKey *event, void *)
{
   using namespace navi;

   int      KBkey;
   
   KBkey = event->keyval;

   if (KBkey == GDK_KEY_plus) menufuncx(win,ZTX("Zoom+"));                 //  +/- = bigger/smaller thumbnails
   if (KBkey == GDK_KEY_equal) menufuncx(win,ZTX("Zoom+"));
   if (KBkey == GDK_KEY_minus) menufuncx(win,ZTX("Zoom-"));
   if (KBkey == GDK_KEY_KP_Add) menufuncx(win,ZTX("Zoom+"));               //  keypad +/- also 
   if (KBkey == GDK_KEY_KP_Subtract) menufuncx(win,ZTX("Zoom-"));

   if (KBkey == GDK_KEY_Left) menufuncx(win,ZTX("Page↑"));                 //  left arrow = previous page
   if (KBkey == GDK_KEY_Right) menufuncx(win,ZTX("Page↓"));                //  right arrow = next page
   if (KBkey == GDK_KEY_Up) menufuncx(win,ZTX("Row↑"));                    //  up arrow = previous row
   if (KBkey == GDK_KEY_Down) menufuncx(win,ZTX("Row↓"));                  //  down arrow = next row
   
   if (KBkey == GDK_KEY_Home) menufuncx(win,ZTX("First"));                 //  keys added 
   if (KBkey == GDK_KEY_End) menufuncx(win,ZTX("Last"));
   if (KBkey == GDK_KEY_Page_Up) menufuncx(win,ZTX("Page↑"));
   if (KBkey == GDK_KEY_Page_Down) menufuncx(win,ZTX("Page↓"));

   if (KBkey == GDK_KEY_F1)
      showz_userguide(zfuncs::F1_help_topic);

   if (KBkey == GDK_KEY_F11) {                                             //  F11  >>  toggle main window     v.12.06
      if (! Wfullscreen) win_fullscreen();                                 //    to full-screen mode and back
      else win_unfullscreen();
   }
   
   if (KBkey == GDK_KEY_Escape && Wfullscreen)                             //  v.12.11
      win_unfullscreen();

   return 1;
}


//  set the window title for the gallery window                            //  v.12.07
//  window title = gallery name

void set_gwin_title()
{
   using namespace navi;

   char     *pp, title[200];
   int      gtype;

   if (cTab != tabG) return;
   
   gtype = navi::gallerytype;
   
   if (gtype == 1) 
      snprintf(title,200,"Directory: %s  %d files",galleryname,nfiles);

   else if (gtype == 2 || gtype == 3)
      snprintf(title,200,"Search Results: %d files",nimages);

   else if (gtype == 4) {
      pp = strrchr(navi::galleryname,'/');
      if (! pp) pp = navi::galleryname;
      else pp++;
      snprintf(title,200,"Collection: %s  %d files",pp,nimages);
   }

   else if (gtype == 5)
      strcpy(title,"Recent Files");

   else strcpy(title,"no directory");

   gtk_window_set_title(MWIN,title);
   return;
}


//  Get file position in file list.
//  If Nth position matches file, this is returned.
//  Otherwise the file is searched from position 0.
//  Position 0-last is returned if found, or -1 if not.

int gallery_position(cchar *file, int Nth)
{
   using namespace navi;
   
   int      ii;
   
   if (! nfiles) return -1;
   if (! file) return -1;                                                  //  bugfix     v.12.07

   if (Nth >= 0 && Nth < nfiles) ii = Nth;
   else ii = 0;
   
   if (strEqu(file+1,flist[ii]+1)) return ii;                              //  1st flist[ii] char. may be !

   for (ii = 0; ii < nfiles; ii++)
      if (strEqu(file+1,flist[ii]+1)) break;

   if (ii < nfiles) return ii;
   return -1;
}


//  Determine if a file is a directory or a supported image file type
//  Return: 0 = file not found
//          1 = directory
//          2 = image file
//          3 = RAW file
//          4 = thumbnail
//          5 = other

int image_file_type(cchar *file)
{
   using namespace navi;

   int            err, cc;
   cchar          *pp;
   struct stat    statbuf;

   if (! file) return 0;
   err = stat(file,&statbuf);
   if (err) return 0;
   
   if (S_ISDIR(statbuf.st_mode)) return 1;                                 //  directory

   if (! S_ISREG(statbuf.st_mode)) return 5;                               //  not a regular file

   if (thumbdirk) {
      cc = strlen(thumbdirk);                                              //  outlaw files in thumbnail directory
      if (strnEqu(file,thumbdirk,cc)) return 4;                            //  v.12.06
   }

   if (strstr(file,"/.thumbnails")) return 4;                              //  outlaw files in /.thumbnails    v.12.06

   pp = strrchr(file,'.');
   if (! pp) return 5;                                                     //  no file .ext                    v.13.01

   if (strcasestr(imagetypes,pp)) return 2;                                //  supported image type
   if (strcasestr(RAWfiletypes,pp)) return 3;                              //  supported RAW file type         v.12.09
   
   return 5;                                                               //  unknown
}


//  Given a thumbnail file, get the corresponding image file.
//  Returns null if no image file found.
//  Returned file is subject for zfree().
//  image file:  /image/dirk/file.xxx                                      //  .jpg .png .tiff etc.
//  thumb dirk:  /thumb/dirk                                               //  if thumb dirk defined
//  thumb file:  /thumb/dirk/image/dirk/file.xxx.jpeg                      //     thumb file is like this
//  thumb file:  /image/dirk/.thumbnails/file.xxx.jpeg                     //  else like this

char * thumb2imagefile(cchar *thumbfile)
{
   struct stat statb;
   int         err, cc;
   char        *imagefile;
   char        *pp;
   
   if (thumbdirk && strNeq(thumbdirk,"undefined"))                         //  remove /thumb/dirk from the front
   {
      cc = strlen(thumbdirk);
      imagefile = strdupz(thumbfile+cc,0,"thumb2imagefile");               //  have /image/dirk/file.xxx.jpeg
      cc = strlen(imagefile);
      imagefile[cc-5] = 0;                                                 //  /image/dirk/file.xxx
   }

   else                                                                    //  remove /.thumbnails from between
   {
      pp = (char *) strrchr(thumbfile,'/');                                //  /image/dirk/.thumbnails/file.xxx.jpeg
      if (! pp) return 0;                                                  //             |           |             |
      pp = pp - 12;                                                        //             pp          +12           +cc
      if (! strnEqu(pp,"/.thumbnails/",13)) return 0;
      cc = strlen(pp+12);
      if (! strEqu(pp+12+cc-5,".jpeg")) return 0;
      imagefile = strdupz(thumbfile,0,"thumb2imagefile");
      pp = imagefile + (pp - thumbfile);
      memmove((char *) pp,pp+12,cc-5);                                     //  /image/dirk/file.xxx
      pp[cc-5] = 0;
   }

   err = stat(imagefile,&statb);                                           //  check file exists
   if (! err) return imagefile;                                            //  return image file
   zfree(imagefile);                                                       //  not found
   return 0;
}


//  Given an image file, get the corresponding thumbnail file.
//  The filespec is returned whether or not the file exists.
//  Returned file is subject for zfree().

char * image2thumbfile(cchar *imagefile)
{
   int      cc, cc1, cc2;
   char     *pp, *thumbfile;

   if (thumbdirk && strNeq(thumbdirk,"undefined"))                         //  use defined thumbnail directory
   {
      cc1 = strlen(thumbdirk);
      cc2 = strlen(imagefile);
      thumbfile = zmalloc(cc1+cc2+6,"image2thumbfile");
      strcpy(thumbfile,thumbdirk);                                         //  /thumb/dirk
      strcpy(thumbfile+cc1,imagefile);                                     //  /thumb/dirk/image/dirk/file.xxx
      strcpy(thumbfile+cc1+cc2,".jpeg");                                   //  /thumb/dirk/image/dirk/file.xxx.jpeg
      return thumbfile;
   }

   else                                                                    //  use /image/dirk/.thumbnails/ 
   {
      thumbfile = strdupz(imagefile,18,"image2thumbfile");                 //  /image/dirk/file.xxx
      pp = strrchr(thumbfile,'/');                                         //             |        |
      if (! pp) return 0;                                                  //             pp       +cc
      cc = strlen(pp);
      memmove(pp+12,pp,cc);                                                //  /image/dirk............/file.xxx
      strncpy(pp,"/.thumbnails",12);                                       //  /image/dirk/.thumbnails/file.xxx
      strcpy(pp+12+cc,".jpeg");                                            //  /image/dirk/.thumbnails/file.xxx.jpeg
      return thumbfile;
   }
}


//  Get thumbnail file for the given image file.
//  If missing or stale, add or update thumbnail file on disk.
//  Returned filespec is subject for zfree().

char * image_thumbfile(char *imagefile)
{
   GdkPixbuf      *thumbpxb;
   GError         *gerror = 0;
   char           *thumbfile, *pp;
   int            err, type;
   struct stat    statf, statb;
   static int     Fmkdirerr = 0;
   
   err = stat(imagefile,&statf);
   if (err) return 0;
   
   type = image_file_type(imagefile);
   if (type != 2 && type != 3) return 0;                                   //  not an image file or RAW file   v.12.09
   
   thumbfile = image2thumbfile(imagefile);                                 //  get thumbnail file for image file
   if (! thumbfile) return 0;

   err = stat(thumbfile,&statb);                                           //  thumbfile exists, up to date ??
   if (! err && statb.st_mtime >= statf.st_mtime) return thumbfile;        //  yes, return it

   pp = strrchr(thumbfile,'/');                                            //  check if thumbnail directory exists
   *pp = 0;
   err = stat(thumbfile,&statb);
   *pp = '/';
   if (err) {                                                              //  no
      pp = thumbfile;
      while (true) {
         pp = strchr(pp+1,'/');                                            //  check each directory level
         if (! pp) break;
         *pp = 0;
         err = stat(thumbfile,&statb);
         if (err) {
            err = mkdir(thumbfile,0751);                                   //  if missing, try to create
            if (err) {
               if (! Fmkdirerr++)                                          //  if unable, print error once only
                  printf("create thumbnail: %s \n",strerror(errno));
               zfree(thumbfile);
               return 0;
            }
         }
         *pp = '/';
      }
   }

   thumbpxb = get_thumbnail_pixbuf(imagefile,thumbfilesize);               //  generate thumbnail pixbuf from image file
   if (! thumbpxb) return 0;

   gdk_pixbuf_save(thumbpxb,thumbfile,"jpeg",&gerror,"quality","80",null); //  save as .jpeg file in thumbnail directory
   g_object_unref(thumbpxb);
   navi::genthumbs++;                                                      //  count generated thumbnails
   return thumbfile;
}


//  Get thumbnail image (pixbuf) for given image file.
//  Use pixbuf cached in memory if available.
//  Create pixbuf from thumbnail file if size <= thumbnail file size.
//  Create pixbuf from image file if size > thumbnail file size.
//  Add pixbuf to memory cache if not there already.
//  Returned thumbnail belongs to caller: g_object_unref() is necessary.
//  Returns null if thumbnail not found on disk.

GdkPixbuf * image_thumbnail(char *fpath, int size)                         //  v.12.06
{
   GdkPixbuf         *thumbpxb;
   GError            *gerror = 0;
   int               ii, err;
   char              *bpath;
   time_t            mtime;
   struct stat       statf;
   const int         cachesize = thumbnail_cachesize;                      //  shorthand

   static int        nextcache, ftf = 1;
   static int        sizecache[cachesize];
   static time_t     mtimecache[cachesize];
   static char       *fpathcache[cachesize];
   static GdkPixbuf  *pixbufcache[cachesize];
   
   zthreadcrash();                                                         //  thread usage not allowed

   if (ftf) {                                                              //  first call
      for (ii = 0; ii < cachesize; ii++) 
         fpathcache[ii] = 0;                                               //  clear cache
      ftf = 0;
   }
   
   err = stat(fpath,&statf);                                               //  fpath status info
   if (err) return 0;

   if (! size) size = thumbfilesize;                                       //  default thumb size

   if (S_ISDIR(statf.st_mode)) {                                           //  if directory, return folder image
      thumbpxb = get_thumbnail_pixbuf(fpath,size);
      return thumbpxb;
   }

   mtime = statf.st_mtime;                                                 //  last modification time

   for (ii = nextcache; ii >= 0; ii--)
      if (fpathcache[ii] && strEqu(fpath,fpathcache[ii]) &&
          sizecache[ii] == size && mtime == mtimecache[ii]) break;         //  check mtime
   if (ii >= 0) {
      thumbpxb = gdk_pixbuf_copy(pixbufcache[ii]);
      return thumbpxb;
   }
   for (ii = cachesize-1; ii > nextcache; ii--)                            //  continue search
      if (fpathcache[ii] && strEqu(fpath,fpathcache[ii]) &&
          sizecache[ii] == size && mtime == mtimecache[ii]) break;
   if (ii > nextcache) {
      thumbpxb = gdk_pixbuf_copy(pixbufcache[ii]);
      return thumbpxb;
   }

   if (size > thumbfilesize || ! Fthumbnails)                              //  get thumbnail from image file     v.12.06
      thumbpxb = get_thumbnail_pixbuf(fpath,size);
   else {
      bpath = image_thumbfile(fpath);                                      //  get thumbnail file path
      if (! bpath) return 0;                                               //    (create thumbnail file if missing)
      thumbpxb = gdk_pixbuf_new_from_file_at_size(bpath,size,size,&gerror);//  get thumbnail from thumbnail file
      zfree(bpath);
   }
   if (! thumbpxb) return 0;

   nextcache++;                                                            //  next cache slot (oldest)
   if (nextcache == cachesize) nextcache = 0;
   ii = nextcache;
   if (fpathcache[ii]) {                                                   //  free prior occupant
      zfree(fpathcache[ii]);
      g_object_unref(pixbufcache[ii]);
   }
   fpathcache[ii] = strdupz(fpath,0,"thumbnail_cache");                    //  add new occupant
   pixbufcache[ii] = gdk_pixbuf_copy(thumbpxb);                            //  this memory is not tracked
   sizecache[ii] = size;
   mtimecache[ii] = mtime;

   return thumbpxb;                                                        //  return pixbuf to caller
}


//  Make a thumbnail pixbuf from the image file.
//  File can be a regular supported image file (jpeg etc.)
//    or a supported RAW file type.

GdkPixbuf * get_thumbnail_pixbuf(char *imagefile, int size)                //  v.12.09
{
   GdkPixbuf      *thumbpxb = 0;
   GError         *gerror = 0;
   char           *thumbfile, *pp;
   int            err, type;
   static int     ftf = 1;
   static char    folderthumb[300], brokenthumb[300];
   
   if (ftf) {
      ftf = 0;
      strcpy(folderthumb,zfuncs::zicondir);                                //  folder icon
      strcat(folderthumb,"/folder.png");
      strcpy(brokenthumb,zfuncs::zicondir);                                //  broken thumbnail icon     v.12.12
      strcat(brokenthumb,"/broken.png");
   }

   type = image_file_type(imagefile);

   if (type == 1)                                                          //  directory file
      thumbpxb = gdk_pixbuf_new_from_file_at_size(folderthumb,size,size,&gerror);

   else if (type == 2)                                                     //  supported image type (jpeg etc.)
      thumbpxb = gdk_pixbuf_new_from_file_at_size(imagefile,size,size,&gerror);

   else if (type == 3) {                                                   //  supported RAW file type
      snprintf(command,ccc,"dcraw -e \"%s\" ",imagefile);                  //  extract jpeg thumbnail from RAW file
      err = system(command);
      if (err) return 0;
      thumbfile = strdupz(imagefile,12,"raw_thumbnail");
      pp = strrchr(thumbfile,'.');
      if (! pp) pp = thumbfile + strlen(thumbfile);
      strcpy(pp,".thumb.jpg");
      thumbpxb = gdk_pixbuf_new_from_file_at_size(thumbfile,size,size,&gerror);
      remove(thumbfile);
      zfree(thumbfile);
   }

   else return 0;

   if (! thumbpxb) {
      printf("cannot make thumbnail: %s \n",imagefile);
      printf(" %s \n",gerror->message);
      gerror = 0;                                                          //  v.12.12
      thumbpxb = gdk_pixbuf_new_from_file_at_size(brokenthumb,size,size,&gerror);
   }

   return thumbpxb;
}


/**************************************************************************

   private function - manage list of image files within a directory

   get an image file in the same directory as given file or directory

   char * navi::image_navigate(cchar *filez, cchar *action, int Nth)

   action:  init:    file list = directories and image files in directory filez
            initF:   file list = filez = list of image files to use (cchar **)
            sort:    sort the file list, directories first, ignore case
            insert:  insert filez into file list at position Nth (0 to last+1)
            delete:  delete Nth file in list
            find:    returns Nth file or null if Nth > last

   Nth: file to find or delete (0 base)
   
   Returned values:
      find: filespec, else null
      The returned file belongs to caller and is subject for zfree().

***************************************************************************/

char * navi::image_navigate(cchar *filez, cchar *action, int Nth)
{
   using namespace navi;

   char           *buff;
   cchar          *findcommand = "find \"%s\" -maxdepth 1";
   char           *pp, *file2;
   int            err, ii, cc, ftyp, contx = 0, fposn;
   FILE           *fid;
   struct stat    statbuf;
   
   if (! strstr("init initF sort insert delete find",action))
         zappcrash("image_navigate %s",action);
   
   if (strnEqu(action,"init",4))                                           //  init or initF
   {
      if (! filez || *filez == 0) return 0;                                //  should not happen         v.12.10

      if (flist) {
         for (ii = 0; ii < nfiles; ii++) zfree(flist[ii]);                 //  free prior file list
         zfree(flist);
      }

      if (mdlist) {                                                        //  clear prior metadata if any
         for (ii = 0; ii < nfiles; ii++) 
            if (mdlist[ii]) zfree(mdlist[ii]);
         zfree(mdlist);
         mdlist = 0;
      }

      cc = maximages * sizeof(char *);      
      flist = (char **) zmalloc(cc,"navi");                                //  list of file pointers

      nfiles = nimages = 0;                                                //  no files
      fposn = 0;

      if (galleryname && filez != galleryname)                             //  don't destroy input       v.12.10
         zfree(galleryname);
      galleryname = strdupz(filez,0,"navi");
   }

   if (strEqu(action,"init"))                                              //  initialize from given directory
   {
      gallerytype = 1;                                                     //  gallery type = directory
      
      err = stat(galleryname,&statbuf);
      if (err) {
         pp = (char *) strrchr(galleryname,'/');                           //  bad file, check directory part  
         if (! pp) return 0;
         pp[1] = 0;
         err = stat(galleryname,&statbuf);
         if (err) return 0;                                                //  give up, empty file list
      }

      if (S_ISREG(statbuf.st_mode)) {                                      //  if a file, get directory part
         pp = (char *) strrchr(galleryname,'/');
         if (! pp) return 0;
         pp[1] = 0;
      }
      
      while ((buff = command_output(contx,findcommand,galleryname)))       //  find all files
      {
         if (strEqu(buff,galleryname)) {                                   //  skip self directory
            zfree(buff);
            continue;
         }
         
         if (strstr(buff,"/.")) {                                          //  ignore hidden files/directories
            zfree(buff);                                                   //                         v.12.12
            continue;
         }
         
         if (nfiles == maximages) {
            zmessageACK(0,Btoomanyfiles,maximages);
            break;
         }

         ftyp = image_file_type(buff);

         if (ftyp == 1) {                                                  //  subdirectory
            flist[nfiles] = buff;                                          //  add to file list
            flist[nfiles][0] = '!';                                        //  if directory, make it sort first
            nfiles++;
         }

         else if (ftyp == 2 || ftyp == 3) {                                //  supported image or RAW file  v.12.09
            flist[nfiles] = buff;                                          //  add to file list
            nfiles++;
            nimages++; 
         }

         else {
            zfree(buff);                                                   //  (thumbnails not ftyp 1)
            continue;
         }
      }
      
      if (nfiles > 1) 
         HeapSort(flist,nfiles,image_fcomp);                               //  Heap Sort - pointers to strings
      
      gallery_monitor("start");                                            //  monitor gallery file changes    v.12.09
      curr_file_count = nimages;                                           //  gallery image file count
      return 0;
   }

   if (strEqu(action,"initF"))                                             //  initialize from given list
   {
      if (gallerytype < 2) zappcrash("gallerytype %d",gallerytype);        //  gallery type from caller        v.13.01
      
      fid = fopen(galleryname,"r");                                        //  open file
      if (! fid) return 0;

      buff = zmalloc(maxfcc,"navi");

      while (true)                                                         //  read list of files
      {
         if (nfiles == maximages) {
            zmessageACK(0,Btoomanyfiles,maximages);
            break;
         }
         pp = fgets_trim(buff,maxfcc-1,fid,1);
         if (! pp) break;
         err = stat(pp,&statbuf);                                          //  check file exists
         if (err) continue;
         flist[nfiles] = strdupz(buff,0,"navi");                           //  add files to memory list
         nfiles++;
      }
      
      fclose(fid);
      zfree(buff);                                                         //  sort removed

      nimages = nfiles;
      curr_file_count = nimages;                                           //  gallery image file count
      return 0;
   }
   
   if (strEqu(action,"sort"))                                              //  sort the list from initF 
   {
      if (nfiles < 2) return 0;
      HeapSort(flist,nfiles,image_fcomp);                                  //  Heap Sort - pointers to strings
      return 0;
   }

   if (strEqu(action,"insert"))                                            //  insert new file into list
   {
      if (gallerytype == 3) return 0;                                      //  metadata report     v.12.01
      fposn = Nth;                                                         //  file position from caller
      if (fposn < 0) fposn = 0;                                            //  limit to allowed range
      if (fposn > nfiles) fposn = nfiles;

      if (nfiles == maximages-1) {                                         //  no room
         zmessageACK(0,Btoomanyfiles,maximages);
         return 0;
      }

      for (ii = nfiles; ii > fposn; ii--)                                  //  create hole is list
         flist[ii] = flist[ii-1];

      flist[fposn] = strdupz(filez,0,"navi");                              //  put new file in hole
      nfiles++;
      nimages++;                                                           //  bugfix
   }

   if (strEqu(action,"delete"))                                            //  delete file from list
   {
      if (gallerytype == 3) return 0;                                      //  metadata report     v.12.01
      fposn = Nth;                                                         //  file position from caller must be OK
      if (fposn < 0 || fposn > nfiles-1) return 0;
      nfiles--;
      if (*flist[fposn] != '!') nimages--;                                 //  not a directory              v.12.01
      zfree(flist[fposn]);                                                 //  remove file from list
      for (ii = fposn; ii < nfiles; ii++) {                                //  close the hole
         if (nfiles < 0) printf("meaningless reference %d",ii);            //  stop g++ optimization bug    ///
         flist[ii] = flist[ii+1];
      }
   }
   
   if (strEqu(action,"find"))
   {
      fposn = Nth;                                                         //  file position from caller must be OK
      if (fposn < 0 || fposn > nfiles-1) return 0;
      file2 = strdupz(flist[fposn],0,"navi");                              //  get Nth file
      file2[0] = '/';                                                      //  restore initial '/'
      err = stat(file2,&statbuf);
      if (! err) return file2;
      zfree(file2);
   }
   
   return 0;
}


//  private function for special file name compare
//  directories sort first and upper/lower case is ignored

int navi::image_fcomp(cchar *file1, cchar *file2)
{
   int      nn;
   nn = strcasecmp(file1,file2);                                           //  compare ignoring case
   if (nn != 0) return nn;
   nn = strcmp(file1,file2);                                               //  if equal, use utf8 compare
   return nn;
}


//  find function which can be called from a thread

char * gallery_find(int Nth)
{
   using namespace navi;

   char           *file2;
   int            err, fposn;
   struct stat    statbuf;
   
   fposn = Nth;                                                            //  file position from caller must be OK
   if (fposn < 0 || fposn > nfiles-1) return 0;
   file2 = strdupz(flist[fposn],0,"navi");                                 //  get Nth file
   file2[0] = '/';                                                         //  restore initial '/'
   err = stat(file2,&statbuf);
   if (! err) return file2;
   zfree(file2);
   return 0;
}


//  Monitor a gallery directory for file changes and refresh the file list.
//  Action is "start" or "stop".
//  Called only for gallerytype = 1 = directory.

void gallery_monitor(cchar *action)                                        //  v.12.09
{
   using namespace navi;
   
   void gallery_changed(void *, GFile *, void *, GFileMonitorEvent);

   static GFile          *gfile_gallery = 0;
   static GFileMonitor   *gallerymon = 0;

   if (gfile_gallery) {
      g_file_monitor_cancel(gallerymon);
      g_object_unref(gallerymon);
      g_object_unref(gfile_gallery);
      gfile_gallery = 0;
   }
   
   if (strEqu(action,"stop")) return;
   if (gallerytype != 1) return;
   
   gfile_gallery = g_file_new_for_path(galleryname);
   gallerymon = g_file_monitor_directory(gfile_gallery,(GFileMonitorFlags) 0,0,0);
   G_SIGNAL(gallerymon,"changed",gallery_changed,0);
   return;
}

void gallery_changed(void *, GFile *gfile, void *, GFileMonitorEvent event)
{
   using namespace navi;
   
   if (gallerytype != 1) {                                                 //  precaution
      gallery_monitor("stop");
      return;
   }
   
   if (event == G_FILE_MONITOR_EVENT_DELETED) {
      gallery(galleryname,"init",-1);
      if (cTab == tabG) gallery(0,"paint",-1);
   }

   else if (event == G_FILE_MONITOR_EVENT_CREATED) {
      gallery(galleryname,"init",-1);
      if (cTab == tabG) gallery(0,"paint",-1);
   }
   
   return;
}


/**************************************************************************/

//  Select files from the image gallery window, return list of files selected.
//  The dialog shows the list of files selected and can be edited.
//  The returned file list belongs to caller and is subject for zfree().
//  The file list EOL is marked with null.
//  The gallery() callback function is restored to caller's function.         v.12.07

namespace ggfnames
{
   int  dialog_event(zdialog *zd, cchar *event);
   int  find_file(cchar *imagefile);
   void insert_file(cchar *imagefile);
   void remove_file(cchar *imagefile);
   void Xclick_func(int Nth, char LR);
   int  mouseclick(GtkWidget *, GdkEventButton *event, void *);
   int  showthumb();

   GtkWidget   *drawarea = 0;
   GtkWidget   *Fwin = 0;
   cchar       *font = "Monospace 8";
   int         fontheight = 14;
   int         cursorpos = 0;
};


char ** gallery_getfiles()
{
   using namespace navi;
   using namespace ggfnames;

   PangoLanguage           *plang;
   PangoFontDescription    *pfontdesc;
   PangoContext            *pcontext;
   PangoFont               *pfont;
   PangoFontMetrics        *pmetrics;
   GdkCursor               *cursor;
   GdkWindow               *gdkwin;
   GtkTextBuffer           *textBuff;
   GtkTextIter             iter1, iter2;

   int      fontascent, fontdescent;
   int      line, nlines, ii;
   char     *imagefile, **filelist;
   
   zthreadcrash();                                                         //  thread usage not allowed
   
   zd_gallery_getfiles = zdialog_new(ZTX("Select Files"),mWin,ZTX("done"),ZTX("cancel"),null);
   zdialog *zd = zd_gallery_getfiles;
   zdialog_add_widget(zd,"hbox","hb1","dialog",0,"expand|space=5");
   zdialog_add_widget(zd,"frame","fr11","hb1",0,"expand");
   zdialog_add_widget(zd,"scrwin","scrwin","fr11",0,"expand");
   zdialog_add_widget(zd,"edit","files","scrwin");
   zdialog_add_widget(zd,"vbox","vb12","hb1");
   zdialog_add_widget(zd,"frame","fr12","vb12");
   zdialog_add_widget(zd,"hbox","hb2","dialog",0,"space=5");
   zdialog_add_widget(zd,"button","delete","hb2",ZTX("delete"),"space=8");
   zdialog_add_widget(zd,"button","insert","hb2",ZTX("insert"),"space=8");
   zdialog_add_widget(zd,"button","addall","hb2",ZTX("add all"),"space=30");

   GtkWidget *textbox = zdialog_widget(zd,"files");                        //  disable text wrap 
   gtk_text_view_set_wrap_mode(GTK_TEXT_VIEW(textbox),GTK_WRAP_NONE);

   GtkWidget *frame = zdialog_widget(zd,"fr12");                           //  drawing area for thumbnail image
   drawarea = gtk_drawing_area_new();
   gtk_widget_set_size_request(drawarea,256,258);                          //  increased
   gdkwin = gtk_widget_get_window(drawarea);                               //  gtk3
   gtk_container_add(GTK_CONTAINER(frame),drawarea);
   
   Fwin = zdialog_widget(zd,"files");                                      //  activate mouse-clicks for
   gtk_widget_add_events(Fwin,GDK_BUTTON_PRESS_MASK);                      //    file list widget
   G_SIGNAL(Fwin,"button-press-event",mouseclick,0);

   pfontdesc = pango_font_description_from_string(font);                   //  set default font for files window
   gtk_widget_modify_font(Fwin,pfontdesc);

   plang = pango_language_get_default();                                   //  get font metrics (what a mess)
   pcontext = gtk_widget_get_pango_context(Fwin);
   pfont = pango_context_load_font(pcontext,pfontdesc);
   pmetrics = pango_font_get_metrics(pfont,plang);
   fontascent = pango_font_metrics_get_ascent(pmetrics) / PANGO_SCALE;
   fontdescent = pango_font_metrics_get_descent(pmetrics) / PANGO_SCALE;
   fontheight = fontascent + fontdescent;                                  //  effective line height

   zdialog_resize(zd,600,0);                                               //  start dialog
   zdialog_run(zd,dialog_event,"save");                                    //  keep relative position          v.12.11

   cursor = gdk_cursor_new(GDK_TOP_LEFT_ARROW);                            //  cursor for file list widget
   gdkwin = gtk_text_view_get_window(GTK_TEXT_VIEW(Fwin),TEXTWIN);         //  (do after window realized)
   gdk_window_set_cursor(gdkwin,cursor);
   cursorpos = 0;

   if (! gallerytype)                                                      //  if no gallery, start with
      gallery(topdirk[0],"init");                                          //    top directory                 v.13.01

   settab("G");                                                            //  open gallery window

   zdialog_wait(zd);                                                       //  wait for dialog completion

   if (zd->zstat != 1) {                                                   //  cancelled
      zdialog_free(zd);                                                    //  kill dialog
      zd_gallery_getfiles = 0;
      return 0;
   }

   textBuff = gtk_text_view_get_buffer(GTK_TEXT_VIEW(Fwin));
   nlines = gtk_text_buffer_get_line_count(textBuff);

   filelist = (char **) zmalloc((nlines+1) * sizeof(char *),"imgl.getfiles");

   for (ii = line = 0; line < nlines; line++)                              //  get list of files from dialog
   {
      gtk_text_buffer_get_iter_at_line(textBuff,&iter1,line);              //  iter at line start
      iter2 = iter1;
      gtk_text_iter_forward_to_line_end(&iter2);
      imagefile = gtk_text_buffer_get_text(textBuff,&iter1,&iter2,0);      //  get line of text
      if (imagefile && *imagefile == '/') {
         filelist[ii] = strdupz(imagefile,0,"imgl.getfiles");              //  >> next file in list
         free(imagefile);
         ii++;
      }
   }
   filelist[ii] = 0;                                                       //  mark EOL
   
   zdialog_free(zd);                                                       //  kill dialog
   zd_gallery_getfiles = 0;

   if (! ii) {
      zfree(filelist);                                                     //  file list is empty
      return 0;
   }

   return filelist;                                                        //  return file list
}


//  gallery getfiles dialog event function

int ggfnames::dialog_event(zdialog *zd, cchar *event)
{
   using namespace ggfnames;

   GtkTextBuffer  *textBuff;
   GtkTextIter    iter1, iter2;
   char           *ftemp, *imagefile;
   static char    *deletedfiles[100];                                      //  last 100 files deleted
   static int     Ndeleted = 0;
   int            ii, line, Nth, ftyp;
   
   if (strEqu(event,"delete"))                                             //  delete file at cursor position
   {
      textBuff = gtk_text_view_get_buffer(GTK_TEXT_VIEW(Fwin));
      line = cursorpos;
      gtk_text_buffer_get_iter_at_line(textBuff,&iter1,line);              //  iter at line start
      iter2 = iter1;
      gtk_text_iter_forward_to_line_end(&iter2);                           //  iter at line end

      ftemp = gtk_text_buffer_get_text(textBuff,&iter1,&iter2,0);          //  get selected file
      if (*ftemp != '/') {
         free(ftemp);
         return 0;
      }

      if (Ndeleted == 100) {                                               //  capacity reached
         zfree(deletedfiles[0]);                                           //  remove oldest entry       v.13.01
         for (ii = 0; ii < 99; ii++)
            deletedfiles[ii] = deletedfiles[ii+1];
         Ndeleted = 99;
      }
         
      deletedfiles[Ndeleted] = strdupz(ftemp,0,"imgl.getfiles");           //  save deleted file for poss. insert
      Ndeleted++;                                                          //  v.13.01
      free(ftemp);
      
      gtk_text_buffer_delete(textBuff,&iter1,&iter2);                      //  delete file text
      gtk_text_buffer_get_iter_at_line(textBuff,&iter2,line+1);
      gtk_text_buffer_delete(textBuff,&iter1,&iter2);                      //  delete empty line (\n)

      showthumb();                                                         //  thumbnail = next file
   }

   if (strEqu(event,"insert"))                                             //  insert first deleted file
   {                                                                       //    at current cursor position
      if (! Ndeleted) return 0;
      insert_file(deletedfiles[0]);
      zfree(deletedfiles[0]);                                              //  remove file from the deleted list
      for (ii = 0; ii < Ndeleted-1; ii++)
         deletedfiles[ii] = deletedfiles[ii+1];
      Ndeleted--;
   }

   if (strEqu(event,"addall"))                                             //  insert all files in image gallery
   {
      textBuff = gtk_text_view_get_buffer(GTK_TEXT_VIEW(Fwin));
      Nth = 0;

      while (true)
      {
         imagefile = gallery(0,"find",Nth);                                //  get first or next file
         if (! imagefile) break;
         Nth++;
         ftyp = image_file_type(imagefile);                                //  must be image or RAW file  v.12.11
         if (ftyp != 2 && ftyp != 3) continue;
         gtk_text_buffer_get_iter_at_line(textBuff,&iter1,cursorpos);
         gtk_text_buffer_insert(textBuff,&iter1,"\n",1);                   //  insert new blank line
         gtk_text_buffer_get_iter_at_line(textBuff,&iter1,cursorpos);
         gtk_text_buffer_insert(textBuff,&iter1,imagefile,-1);             //  insert image file
         zfree(imagefile);
         cursorpos++;                                                      //  advance cursor position
      }
   }

   return 0;
}


//  See if image file is in the file list already or not.
//  Return the matching line number or -1 if not found.

int ggfnames::find_file(cchar *imagefile)                                  //  v.12.11
{
   using namespace ggfnames;

   GtkTextBuffer  *textBuff;
   GtkTextIter    iter1, iter2;
   char           *ftemp;
   int            line, last = -1, more;

   textBuff = gtk_text_view_get_buffer(GTK_TEXT_VIEW(Fwin));

   for (line = 0; ; line++)
   {   
      gtk_text_buffer_get_iter_at_line(textBuff,&iter1,line);              //  iter at line start
      iter2 = iter1;
      more = gtk_text_iter_forward_to_line_end(&iter2);                    //  iter at line end
      ftemp = gtk_text_buffer_get_text(textBuff,&iter1,&iter2,0);          //  included text
      if (strEqu(ftemp,imagefile)) last = line;                            //  remember last entry found
      free(ftemp);
      if (! more) break;
   }
   
   return last;
}


//  add image file to list at current cursor position, set thumbnail = file

void ggfnames::insert_file(cchar *imagefile)
{
   using namespace ggfnames;

   GtkTextIter    iter;
   GtkTextBuffer  *textBuff;
   
   textBuff = gtk_text_view_get_buffer(GTK_TEXT_VIEW(Fwin));
   gtk_text_buffer_get_iter_at_line(textBuff,&iter,cursorpos);
   gtk_text_buffer_insert(textBuff,&iter,imagefile,-1);                    //  insert image file
   gtk_text_buffer_insert(textBuff,&iter,"\n",1);                          //  insert new line

   showthumb();                                                            //  update thumbnail
   cursorpos++;                                                            //  advance cursor position

   return;
}


//  remove image file at last position found, set thumbnail = next

void ggfnames::remove_file(cchar *imagefile)                               //  v.12.11
{
   using namespace ggfnames;

   GtkTextBuffer  *textBuff;
   GtkTextIter    iter1, iter2;
   int            line;

   line = find_file(imagefile);
   if (line < 0) return;

   textBuff = gtk_text_view_get_buffer(GTK_TEXT_VIEW(Fwin));
   gtk_text_buffer_get_iter_at_line(textBuff,&iter1,line);                 //  iter at line start
   iter2 = iter1;
   gtk_text_iter_forward_to_line_end(&iter2);                              //  iter at line end
   gtk_text_buffer_delete(textBuff,&iter1,&iter2);                         //  delete file text
   gtk_text_buffer_get_iter_at_line(textBuff,&iter2,line+1);               //  next line
   gtk_text_buffer_delete(textBuff,&iter1,&iter2);                         //  delete empty line (\n)
   
   showthumb();                                                            //  thumbnail = curr. position
   cursorpos--;                                                            //  backup cursor position
   return;
}


//  called from image gallery window when a thumbnail is clicked
//  add image file to list at current cursor position, set thumbnail = file

void gallery_getfiles_Lclick_func(int Nth)                                 //  v.12.11
{
   ggfnames::Xclick_func(Nth,'L');
   return;
}

void gallery_getfiles_Rclick_func(int Nth)
{
   ggfnames::Xclick_func(Nth,'R');
   return;
}

void ggfnames::Xclick_func(int Nth, char LR)
{
   using namespace ggfnames;

   int            ftyp, line;
   static int     pNth = -1;                                               //  previously clicked file
   char           *imagefile;
   int            control, shift;
   
   if (! zd_gallery_getfiles) return;                                      //  should not happen
   if (Nth == -1) return;                                                  //  gallery gone ?
   
   if (Nth == -2) {
      showz_userguide(zfuncs::F1_help_topic);                              //  F1 context help
      pNth = -1;
      return;
   }
   
   imagefile = gallery(0,"find",Nth);                                      //  get file at clicked position
   if (! imagefile) {
      pNth = -1;
      return;
   }

   ftyp = image_file_type(imagefile);                                      //  must be image or RAW file
   if (ftyp != 2 && ftyp != 3) {
      zfree(imagefile);
      pNth = -1;
      return;
   }
   
   if (LR == 'R') {                                                        //  right click, unselect     v.12.11
      remove_file(imagefile);
      zfree(imagefile);
      return;
   }
   
   control = shift = 0;                                                    //  left click, select        v.12.11
   if (KBcontrolkey) control = 1;
   if (KBshiftkey) shift = 1;
   
   if (! control && ! shift)                                               //  no control or shift keys
   {
      pNth = -1;
      insert_file(imagefile);                                              //  insert file at current position
      zfree(imagefile);
      return;
   }

   if (control && ! shift)                                                 //  control key               v.12.11
   {
      pNth = -1;                                                           //  add or remove single file
      line = find_file(imagefile);
      if (line < 0) insert_file(imagefile);                                //  not found, add
      else remove_file(imagefile);                                         //  found, remove
      zfree(imagefile);
      return;
   }

   if (! control && shift)                                                 //  shift key                 v.12.11
   {
      zfree(imagefile);                                                    //  not needed

      if (pNth < 0) {                                                      //  start range of files to add
         pNth = Nth;
         return;
      }
      else {                                                               //  end range of files to add
         if (pNth > Nth) {
            int temp = pNth;                                               //  set ascending order
            pNth = Nth;
            Nth = temp;
         }
         for (int nn = pNth; nn <= Nth; nn++)                              //  add all files in range
         {
            imagefile = gallery(0,"find",nn);
            if (! imagefile) continue;
            ftyp = image_file_type(imagefile);
            if (ftyp != 2 && ftyp != 3) {
               zfree(imagefile);
               continue;
            }
            insert_file(imagefile);
            zfree(imagefile);
         }
         pNth = -1;
         return;
      }
   }

   if (control && shift)                                                   //  both control and shift keys
      return;                                                              //  ignore
   
   return;
}


//  process mouse click in files window: 
//  set new cursor position and set thumbnail = clicked file

int ggfnames::mouseclick(GtkWidget *, GdkEventButton *event, void *)
{
   using namespace ggfnames;

   int            mpy;
   GtkWidget      *scrollwin;
   GtkAdjustment  *scrolladj;
   double         scrollpos;

   if (event->type != GDK_BUTTON_PRESS) return 0;
   mpy = int(event->y);
   scrollwin = zdialog_widget(zd_gallery_getfiles,"scrwin");               //  window scroll position
   scrolladj = gtk_scrolled_window_get_vadjustment(GTK_SCROLLED_WINDOW(scrollwin));
   scrollpos = gtk_adjustment_get_value(scrolladj);
   cursorpos = (mpy + scrollpos) / fontheight;                             //  line selected
   showthumb();                                                            //  show thumbnail image
   return 0;
}


//  show thumbnail for file at current cursor position

int ggfnames::showthumb()
{
   using namespace ggfnames;

   int            line;
   char           *imagefile;
   GdkWindow      *gdkwin;
   cairo_t        *cr;
   GtkTextBuffer  *textBuff;
   GtkTextIter    iter1, iter2;
   GdkPixbuf      *thumbnail = 0;

   gdkwin = gtk_widget_get_window(drawarea);
   cr = gdk_cairo_create(gdkwin);
   
   line = cursorpos;
   textBuff = gtk_text_view_get_buffer(GTK_TEXT_VIEW(Fwin));
   gtk_text_buffer_get_iter_at_line(textBuff,&iter1,line);                 //  iter at line start
   iter2 = iter1;
   gtk_text_iter_forward_to_line_end(&iter2);                              //  iter at line end

   imagefile = gtk_text_buffer_get_text(textBuff,&iter1,&iter2,0);         //  get selected file
   if (*imagefile != '/') {
      free(imagefile);
      return 0;
   }

   thumbnail = image_thumbnail(imagefile,256);                             //  get thumbnail
   free(imagefile);

   if (thumbnail) {
      cairo_set_source_rgb(cr,1,1,1);                                      //  white background
      cairo_paint(cr); 
      gdk_cairo_set_source_pixbuf(cr,thumbnail,0,0);                       //  paint thumbnail
      cairo_paint(cr);
      g_object_unref(thumbnail);
   }

   return 0;
}


/**************************************************************************
   plugin menu functions
**************************************************************************/

//  edit plugins menu

void  m_edit_plugins(GtkWidget *, cchar *)
{
   int   edit_plugins_event(zdialog *zd, cchar *event);

   int         ii;
   char        *pp;
   zdialog     *zd;
   
   zfuncs::F1_help_topic = "plugins";
   
   zd = zdialog_new("Edit Plugins",mWin,ZTX("Add"),ZTX("Remove"),Bdone,null);
   zdialog_add_widget(zd,"hbox","hbm","dialog",0,"space=5");
   zdialog_add_widget(zd,"label","labm","hbm",ZTX("menu name"),"space=5");
   zdialog_add_widget(zd,"comboE","menu","hbm",0,"space=5");
   zdialog_add_widget(zd,"hbox","hbc","dialog",0,"space=5");
   zdialog_add_widget(zd,"label","labc","hbc","command","space=5");
   zdialog_add_widget(zd,"entry","command","hbc",0,"space=5|expand");

   for (ii = 0; ii < Nplugins; ii++)                                       //  stuff combo box with available
   {                                                                       //     plugin menu names
      pp = strstr(plugins[ii]," = ");
      if (! pp) continue;
      *pp = 0;
      zdialog_cb_app(zd,"menu",plugins[ii]);
      *pp = ' ';
   }
   
   zdialog_help(zd,"plugins");                                             //  zdialog help topic
   zdialog_run(zd,edit_plugins_event);
   return;
}


//  dialog event function

int  edit_plugins_event(zdialog *zd, cchar *event)
{
   int      ii, jj, cc, zstat;
   char     menu[40], *pp = 0;
   
   zdialog_fetch(zd,"menu",menu,40);                                       //  selected menu
   zdialog_fetch(zd,"command",command,ccc);
   
   if (strEqu(event,"menu")) 
   {
      for (ii = 0; ii < Nplugins; ii++)
      {
         pp = strstr(plugins[ii]," = ");                                   //  find corresp. plugin record
         if (! pp) continue;
         *pp = 0;
         jj = strEqu(plugins[ii],menu);
         *pp = ' ';
         if (jj) break;
      }
      
      if (ii == Nplugins) return 0;

      pp += 3;
      if (strlen(pp) < 3) return 0;
      strncpy0(command,pp,ccc);
      zdialog_stuff(zd,"command",command);                                 //  stuff corresp. command in dialog
      
      return 0;
   }
   
   zstat = zd->zstat;
   if (! zstat) return 0;
   
   if (zstat == 1)                                                         //  add new plugin
   {
      if (strlen(menu) < 3 || strlen(command) < 3) return 0;
      if (Nplugins == maxplugins) {
         zmessageACK(mWin,"too many plugins");
         return 0;
      }
      ii = Nplugins;                                                       //  add plugin record
      cc = strlen(menu) + strlen(command) + 5;
      plugins[ii] = zmalloc(cc,"plugins");                                 //  format: menu = command
      strcpy(plugins[ii],menu);
      strcat(plugins[ii]," = ");
      strcat(plugins[ii],command);
      Nplugins++;

      zmessageACK(mWin,ZTX("Restart Fotoxx to update plugin menu"));
   }
   
   if (zstat == 2)                                                         //  remove current plugin
   {
      for (ii = 0; ii < Nplugins; ii++)
      {
         pp = strstr(plugins[ii]," = ");                                   //  find corresp. plugin record
         if (! pp) continue;
         *pp = 0;
         jj = strEqu(plugins[ii],menu);
         *pp = ' ';
         if (jj) break;
      }
      
      if (ii == Nplugins) return 0;
      
      Nplugins--;                                                          //  remove plugin record
      for (jj = ii; jj < Nplugins; jj++)
         plugins[jj] = plugins[jj+1];
      
      zmessageACK(mWin,ZTX("Restart Fotoxx to update plugin menu"));
   }
   
   if (zstat == 3) {                                                       //  done
      zdialog_free(zd);
      return 0;
   }
   
   return 0;
}


//  process plugin menu selection
//  execute correspinding command using current image file

editfunc    EFplugin;

void  m_run_plugin(GtkWidget *, cchar *menu)
{
   int         ii, jj, err;
   char        *pp = 0, pluginfile[200];
   PXM         *pxmtemp;
   
   zfuncs::F1_help_topic = "plugins";
   
   for (ii = 0; ii < Nplugins; ii++)                                       //  search plugins for menu name
   {
      pp = strstr(plugins[ii]," = ");
      if (! pp) continue;
      *pp = 0;
      jj = strEqu(plugins[ii],menu);
      *pp = ' ';
      if (jj) break;
   }

   if (ii == Nplugins) {
      zmessageACK(mWin,"plugin menu not found %s",menu);
      return;
   }

   pp += 3;
   if (strlen(pp) < 3) {
      zmessageACK(mWin,"no plugin command");
      return;
   }

   strncpy0(command,pp,ccc);                                               //  corresp. command
   strTrim2(command);

   EFplugin.funcname = menu;
   if (! edit_setup(EFplugin)) return;                                     //  setup edit

   snprintf(pluginfile,199,"%s/plugfile.tif",get_zuserdir());              //  /.../.fotoxx/plugfile.tif
   
   err = PXM_TIFF_save(E1pxm,pluginfile,8);                                //  E1 >> plugin_file
   if (err) {
      if (*file_errmess)                                                   //  pass error to user           v.12.12
         zmessageACK(mWin,file_errmess);
      edit_cancel();
      return;
   }

   strcat(command," ");                                                    //  construct: command /.../plugin_file
   strcat(command,pluginfile);
   printf("plugin: %s \n",command);

   err = system(command);                                                  //  execute plugin command
   if (err) {
      zmessageACK(mWin,"plugin command error");
      edit_cancel();
      return;
   }
   
   pxmtemp = TIFF_PXM_load(pluginfile);                                    //  read command output file
   if (! pxmtemp) {
      zmessageACK(mWin,"plugin failed");
      edit_cancel();
      return;
   }
   
   PXM_free(E3pxm);                                                        //  plugin_file >> E3
   E3pxm = pxmtemp;

   EFplugin.Fmod = 1;                                                      //  assume image was modified
   edit_done();

   return;
}   


